(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1317667,      25257]
NotebookOptionsPosition[   1293007,      24548]
NotebookOutlinePosition[   1293388,      24565]
CellTagsIndexPosition[   1293345,      24562]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[TextData[StyleBox["functions;  must be LOADED IN",
 FontColor->RGBColor[1, 0, 0]]], "Subsubsection",
 CellChangeTimes->{{3.490531052385127*^9, 3.490531053820489*^9}, {
  3.4905960752795553`*^9, 3.490596086206231*^9}}],

Cell[CellGroupData[{

Cell[TextData[StyleBox["general",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905977630252953`*^9, 3.490597763965119*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"V", "[", 
   RowBox[{"r_", ",", "Ak_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Ak", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Rak", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}],
         "-", "r"}], ")"}], "3"], 
     RowBox[{"HeavisideTheta", "[", 
      RowBox[{
       RowBox[{"Rak", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
       "-", "r"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Rak", "//", "Length"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalPhi]", "[", 
   RowBox[{"r_", ",", "Bk_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Bk", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Rbk", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}],
         "-", "r"}], ")"}], "3"], 
     RowBox[{"HeavisideTheta", "[", 
      RowBox[{
       RowBox[{"Rbk", "\[LeftDoubleBracket]", "k", "\[RightDoubleBracket]"}], 
       "-", "r"}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"k", ",", 
      RowBox[{"Rbk", "//", "Length"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]", "[", "Bk_", "]"}], ":=", 
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{"nR", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", "[", "\[Rho]_", "]"}], ":=", 
   RowBox[{"Sqrt", "[", "\[Rho]", "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ecohesion", "[", 
   RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     FractionBox["1", "2"]}], 
    RowBox[{
     UnderoverscriptBox["\[Sum]", 
      RowBox[{"j", "=", "1"}], "n"], 
     RowBox[{"V", "[", 
      RowBox[{
       RowBox[{"nR", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
       ",", "Ak"}], "]"}]}]}], "+", 
   RowBox[{"f", "[", 
    RowBox[{"\[Rho]", "[", "Bk", "]"}], "]"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Evacancy", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Ecohesion", "[", 
     RowBox[{"Ak", ",", "Bk"}], "]"}], "-", 
    RowBox[{"f", "[", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}], "]"}], "+", 
    RowBox[{
     RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}]}]}], "\[IndentingNewLine]", 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"first", " ", "derivatives"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"D\[Rho]", "[", "Bk_", "]"}], ":=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"f", "[", "\[Rho]", "]"}], ",", "\[Rho]"}], "]"}], "/.", 
   RowBox[{"\[Rho]", "\[Rule]", 
    RowBox[{"\[Rho]", "[", "Bk", "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DV", "[", 
   RowBox[{"j_Integer", ",", "Ak_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"r", ",", "Ak"}], "]"}], ",", "r"}], "]"}], "/.", 
   RowBox[{"r", "\[Rule]", 
    RowBox[{
    "nR", "\[LeftDoubleBracket]", "j", 
     "\[RightDoubleBracket]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"D\[CapitalPhi]", "[", 
    RowBox[{"j_Integer", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"\[CapitalPhi]", "[", 
       RowBox[{"r", ",", "Bk"}], "]"}], ",", "r"}], "]"}], "/.", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{
     "nR", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]}]}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"second", " ", "derivatives"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"D\[Rho]2", "[", "Bk_", "]"}], ":=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"f", "[", "\[Rho]", "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "2"}], "}"}]}], "]"}], "/.", 
   RowBox[{"\[Rho]", "\[Rule]", 
    RowBox[{"\[Rho]", "[", "Bk", "]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DV2", "[", 
   RowBox[{"j_Integer", ",", "Ak_"}], "]"}], ":=", 
  RowBox[{
   RowBox[{"D", "[", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{"r", ",", "Ak"}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "2"}], "}"}]}], "]"}], "/.", 
   RowBox[{"r", "\[Rule]", 
    RowBox[{
    "nR", "\[LeftDoubleBracket]", "j", 
     "\[RightDoubleBracket]"}]}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"D\[CapitalPhi]2", "[", 
    RowBox[{"j_Integer", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"D", "[", 
     RowBox[{
      RowBox[{"\[CapitalPhi]", "[", 
       RowBox[{"r", ",", "Bk"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"r", ",", "2"}], "}"}]}], "]"}], "/.", 
    RowBox[{"r", "\[Rule]", 
     RowBox[{
     "nR", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]}]}]}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"auxiliary", " ", "definitions"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R2", "[", 
   RowBox[{"j_Integer", ",", "\[Alpha]_Integer", ",", "\[Beta]_Integer"}], 
   "]"}], ":=", 
  FractionBox[
   RowBox[{
    RowBox[{"R", "\[LeftDoubleBracket]", 
     RowBox[{"j", ",", "\[Alpha]"}], "\[RightDoubleBracket]"}], 
    RowBox[{"R", "\[LeftDoubleBracket]", 
     RowBox[{"j", ",", "\[Beta]"}], "\[RightDoubleBracket]"}]}], 
   RowBox[{
   "nR", "\[LeftDoubleBracket]", "j", 
    "\[RightDoubleBracket]"}]]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R4", "[", 
    RowBox[{
    "j_Integer", ",", "\[Alpha]_Integer", ",", "\[Beta]_Integer", ",", 
     "\[Gamma]_Integer", ",", "\[Delta]_Integer"}], "]"}], ":=", 
   FractionBox[
    RowBox[{
     RowBox[{"R", "\[LeftDoubleBracket]", 
      RowBox[{"j", ",", "\[Alpha]"}], "\[RightDoubleBracket]"}], 
     RowBox[{"R", "\[LeftDoubleBracket]", 
      RowBox[{"j", ",", "\[Beta]"}], "\[RightDoubleBracket]"}], 
     RowBox[{"R", "\[LeftDoubleBracket]", 
      RowBox[{"j", ",", "\[Gamma]"}], "\[RightDoubleBracket]"}], 
     RowBox[{"R", "\[LeftDoubleBracket]", 
      RowBox[{"j", ",", "\[Delta]"}], "\[RightDoubleBracket]"}]}], 
    SuperscriptBox[
     RowBox[{"nR", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     "2"]]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "standard", " ", "mapping", " ", "of", " ", "2", " ", "indices", " ", 
     "on", " ", "1"}], ",", " ", 
    RowBox[{
     RowBox[{
     "e", ".", "g", ".", " ", "Ref", ".", " ", 
      "\"\<Theory of dislocations\>\""}], " ", "Hirth", " ", "and", " ", 
     "Lothe"}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"map", "[", "i_Integer", "]"}], ":=", 
    RowBox[{"Switch", "[", 
     RowBox[{"i", ",", "\[IndentingNewLine]", "1", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}], ",", "2", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}], ",", "3", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "3"}], "}"}], ",", "4", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "3"}], "}"}], ",", "5", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "1"}], "}"}], ",", "6", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2"}], "}"}], ",", "7", ",", 
      RowBox[{"{", 
       RowBox[{"3", ",", "2"}], "}"}], ",", "8", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "3"}], "}"}], ",", "9", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}], ",", "_", ",", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"Print", "[", "\"\<Mapping not possible! Aborting\>\"", "]"}],
         ";", 
        RowBox[{"Abort", "[", "]"}], ";"}], ")"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"parameters", " ", "for", " ", "fitting"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Akn", ":=", 
   RowBox[{"Array", "[", 
    RowBox[{"AA", ",", 
     RowBox[{"Length", "[", "Ak", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bkn", ":=", 
   RowBox[{"Array", "[", 
    RowBox[{"BB", ",", 
     RowBox[{"Length", "[", "Bk", "]"}]}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490513520177157*^9, 3.490513685732851*^9}, {
   3.4905137166*^9, 3.4905137792590017`*^9}, {3.490513904120307*^9, 
   3.490513912802784*^9}, {3.4905140134346933`*^9, 3.4905140182013693`*^9}, {
   3.490514082684691*^9, 3.490514085106525*^9}, {3.490514115998582*^9, 
   3.490514127833315*^9}, {3.490514211707625*^9, 3.4905142870266953`*^9}, {
   3.4905143468960876`*^9, 3.490514400260051*^9}, {3.4905144821397676`*^9, 
   3.490514488254174*^9}, {3.490514522820006*^9, 3.490514543556551*^9}, {
   3.490514610262124*^9, 3.4905147123977633`*^9}, {3.490515163085053*^9, 
   3.490515171539096*^9}, 3.490515224853059*^9, {3.490515314529605*^9, 
   3.490515338763731*^9}, {3.490515418895402*^9, 3.4905154222551727`*^9}, {
   3.490517648558688*^9, 3.4905177277452583`*^9}, {3.490517769859743*^9, 
   3.4905178052126513`*^9}, {3.490518732013105*^9, 3.490518772210956*^9}, {
   3.4905226793789787`*^9, 3.4905227664792356`*^9}, {3.490522818221448*^9, 
   3.490522883016861*^9}, {3.490522914788879*^9, 3.490523151189982*^9}, {
   3.49052319004959*^9, 3.4905232180945263`*^9}, {3.490523276664836*^9, 
   3.490523325930956*^9}, 3.4905235459590607`*^9, {3.4905249293259172`*^9, 
   3.490524930128645*^9}, {3.490525065144713*^9, 3.490525094200183*^9}, {
   3.490525125847115*^9, 3.4905252895199614`*^9}, {3.490525394121203*^9, 
   3.490525509957008*^9}, {3.490525563642192*^9, 3.490525570744835*^9}, {
   3.490525615474635*^9, 3.490525641137846*^9}, {3.490525769014241*^9, 
   3.490525972940316*^9}, {3.490526022862143*^9, 3.490526036184943*^9}, {
   3.49052615204279*^9, 3.490526221818142*^9}, 3.490526307579508*^9, {
   3.4905263965471907`*^9, 3.490526648085837*^9}, {3.4905266869120293`*^9, 
   3.49052706226775*^9}, {3.4905274581694927`*^9, 3.4905274755070333`*^9}, {
   3.4905294976288643`*^9, 3.490529549145006*^9}, {3.490529613915743*^9, 
   3.490529883870623*^9}, {3.490529927208599*^9, 3.490529960579927*^9}, {
   3.490531543686408*^9, 3.490531571382658*^9}, {3.4905318129804077`*^9, 
   3.49053181393456*^9}, {3.490534650111743*^9, 3.4905350555944138`*^9}, 
   3.490536634838295*^9, {3.490555550051849*^9, 3.4905555790277443`*^9}, {
   3.490555852418103*^9, 3.490555856107552*^9}, {3.49058342819491*^9, 
   3.490583440302601*^9}, {3.490583493657379*^9, 3.490583675395978*^9}, {
   3.49059352737274*^9, 3.490593531825512*^9}, {3.490593575982025*^9, 
   3.490593576789216*^9}, 3.490593612858241*^9, {3.490593659809538*^9, 
   3.490593660369617*^9}, {3.49059369579455*^9, 3.490593696180953*^9}, {
   3.490593729074122*^9, 3.49059374105413*^9}, {3.490593859717883*^9, 
   3.490594150576387*^9}, {3.490594205092392*^9, 3.4905942612344093`*^9}, {
   3.4905947706713867`*^9, 3.490594774477147*^9}, {3.490595518654101*^9, 
   3.490595555446281*^9}, {3.490595600741249*^9, 3.490595694806055*^9}, {
   3.490595737996316*^9, 3.490595754802792*^9}, {3.490595792980196*^9, 
   3.490595794333482*^9}, 3.490595842796801*^9, {3.490597414408414*^9, 
   3.490597421563756*^9}, {3.490597481208816*^9, 3.490597588624696*^9}, {
   3.4905977751960983`*^9, 3.4905979054916143`*^9}, {3.490598123504608*^9, 
   3.490598124341524*^9}, {3.490605721171379*^9, 3.490605723990899*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["hcp",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905974954172287`*^9, 3.490597495850638*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"stress", " ", "tensor"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Sigma]hcp", "[", 
     RowBox[{
     "\[Alpha]_Integer", ",", "\[Beta]_Integer", ",", "Ak_", ",", "Bk_"}], 
     "]"}], " ", ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], 
        RowBox[{
         UnderoverscriptBox["\[Sum]", 
          RowBox[{"j", "=", "1"}], "n"], 
         RowBox[{
          RowBox[{"R2", "[", 
           RowBox[{"j", ",", "\[Alpha]", ",", "\[Beta]"}], "]"}], 
          RowBox[{"DV", "[", 
           RowBox[{"j", ",", "Ak"}], "]"}]}]}]}], "-", 
       RowBox[{
        RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
        RowBox[{
         UnderoverscriptBox["\[Sum]", 
          RowBox[{"j", "=", "1"}], "n"], 
         RowBox[{
          RowBox[{"R2", "[", 
           RowBox[{"j", ",", "\[Alpha]", ",", "\[Beta]"}], "]"}], 
          RowBox[{"D\[CapitalPhi]", "[", 
           RowBox[{"j", ",", "Bk"}], "]"}]}]}]}]}], ")"}], "/", 
     "\[CapitalOmega]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"elastic", " ", "constants"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chcp", "[", 
     RowBox[{
     "\[Alpha]_Integer", ",", "\[Beta]_Integer", ",", "\[Gamma]_Integer", ",",
       "\[Delta]_Integer", ",", "Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        FractionBox["1", "2"], 
        RowBox[{
         UnderoverscriptBox["\[Sum]", 
          RowBox[{"j", "=", "1"}], "n"], 
         RowBox[{
          RowBox[{"R4", "[", 
           RowBox[{
           "j", ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]", ",", 
            "\[Delta]"}], "]"}], 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"DV2", "[", 
             RowBox[{"j", ",", "Ak"}], "]"}], "-", 
            FractionBox[
             RowBox[{"DV", "[", 
              RowBox[{"j", ",", "Ak"}], "]"}], 
             RowBox[{
             "nR", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]]}], 
           ")"}]}]}]}], "-", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
          RowBox[{
           UnderoverscriptBox["\[Sum]", 
            RowBox[{"j", "=", "1"}], "n"], 
           RowBox[{
            RowBox[{"R4", "[", 
             RowBox[{
             "j", ",", "\[Alpha]", ",", "\[Beta]", ",", "\[Gamma]", ",", 
              "\[Delta]"}], "]"}], 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"D\[CapitalPhi]2", "[", 
               RowBox[{"j", ",", "Bk"}], "]"}], "-", 
              FractionBox[
               RowBox[{"D\[CapitalPhi]", "[", 
                RowBox[{"j", ",", "Bk"}], "]"}], 
               RowBox[{
               "nR", "\[LeftDoubleBracket]", "j", 
                "\[RightDoubleBracket]"}]]}], ")"}]}]}]}], "+", 
         RowBox[{
          RowBox[{"D\[Rho]2", "[", "Bk", "]"}], 
          RowBox[{
           UnderoverscriptBox["\[Sum]", 
            RowBox[{"j", "=", "1"}], "n"], 
           RowBox[{
            RowBox[{"R2", "[", 
             RowBox[{"j", ",", "\[Alpha]", ",", "\[Beta]"}], "]"}], 
            RowBox[{"D\[CapitalPhi]", "[", 
             RowBox[{"j", ",", "Bk"}], "]"}], 
            RowBox[{
             UnderoverscriptBox["\[Sum]", 
              RowBox[{"j", "=", "1"}], "n"], 
             RowBox[{
              RowBox[{"R2", "[", 
               RowBox[{"j", ",", "\[Gamma]", ",", "\[Delta]"}], "]"}], 
              RowBox[{"D\[CapitalPhi]", "[", 
               RowBox[{"j", ",", "Bk"}], "]"}]}]}]}]}]}]}], ")"}]}], ")"}], 
     "/", "\[CapitalOmega]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chcp", "[", 
     RowBox[{
     "\[Alpha]_Integer", ",", "\[Beta]_Integer", ",", "Ak_", ",", "Bk_"}], 
     "]"}], ":=", 
    RowBox[{"Chcp", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"map", "[", "\[Alpha]", "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"map", "[", "\[Alpha]", "]"}], "\[LeftDoubleBracket]", "2", 
       "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"map", "[", "\[Beta]", "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}], ",", 
      RowBox[{
       RowBox[{"map", "[", "\[Beta]", "]"}], "\[LeftDoubleBracket]", "2", 
       "\[RightDoubleBracket]"}], ",", "Ak", ",", "Bk"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "follwoing", " ", "functions", " ", "for", " ", "efficient", " ", 
     "fitting"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"rule", "[", 
      RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
         "\[Rule]", 
         RowBox[{
         "#", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], "&"}],
        "/@", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Join", "[", 
            RowBox[{"Akn", ",", "Bkn"}], "]"}], ",", 
           RowBox[{"Join", "[", 
            RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[Transpose]"}], 
        ")"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Ecoh", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"EcohAknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Evac", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"EvacAknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Sigma]hcp11", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"\[Sigma]hcp11AknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Sigma]hcp33", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"\[Sigma]hcp33AknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chcp11", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"Chcp11AknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chcp12", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"Chcp12AknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chcp13", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"Chcp13AknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chcp33", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"Chcp33AknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Chcp44", "[", 
     RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
    RowBox[{"Chcp44AknBkn", "/.", 
     RowBox[{"rule", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}]}]}]}]], "Input",
 CellChangeTimes->{{3.490513520177157*^9, 3.490513685732851*^9}, {
   3.4905137166*^9, 3.4905137792590017`*^9}, {3.490513904120307*^9, 
   3.490513912802784*^9}, {3.4905140134346933`*^9, 3.4905140182013693`*^9}, {
   3.490514082684691*^9, 3.490514085106525*^9}, {3.490514115998582*^9, 
   3.490514127833315*^9}, {3.490514211707625*^9, 3.4905142870266953`*^9}, {
   3.4905143468960876`*^9, 3.490514400260051*^9}, {3.4905144821397676`*^9, 
   3.490514488254174*^9}, {3.490514522820006*^9, 3.490514543556551*^9}, {
   3.490514610262124*^9, 3.4905147123977633`*^9}, {3.490515163085053*^9, 
   3.490515171539096*^9}, 3.490515224853059*^9, {3.490515314529605*^9, 
   3.490515338763731*^9}, {3.490515418895402*^9, 3.4905154222551727`*^9}, {
   3.490517648558688*^9, 3.4905177277452583`*^9}, {3.490517769859743*^9, 
   3.4905178052126513`*^9}, {3.490518732013105*^9, 3.490518772210956*^9}, {
   3.4905226793789787`*^9, 3.4905227664792356`*^9}, {3.490522818221448*^9, 
   3.490522883016861*^9}, {3.490522914788879*^9, 3.490523151189982*^9}, {
   3.49052319004959*^9, 3.4905232180945263`*^9}, {3.490523276664836*^9, 
   3.490523325930956*^9}, 3.4905235459590607`*^9, {3.4905249293259172`*^9, 
   3.490524930128645*^9}, {3.490525065144713*^9, 3.490525094200183*^9}, {
   3.490525125847115*^9, 3.4905252895199614`*^9}, {3.490525394121203*^9, 
   3.490525509957008*^9}, {3.490525563642192*^9, 3.490525570744835*^9}, {
   3.490525615474635*^9, 3.490525641137846*^9}, {3.490525769014241*^9, 
   3.490525972940316*^9}, {3.490526022862143*^9, 3.490526036184943*^9}, {
   3.49052615204279*^9, 3.490526221818142*^9}, 3.490526307579508*^9, {
   3.4905263965471907`*^9, 3.490526648085837*^9}, {3.4905266869120293`*^9, 
   3.49052706226775*^9}, {3.4905274581694927`*^9, 3.4905274755070333`*^9}, {
   3.4905294976288643`*^9, 3.490529549145006*^9}, {3.490529613915743*^9, 
   3.490529883870623*^9}, {3.490529927208599*^9, 3.490529960579927*^9}, {
   3.490531543686408*^9, 3.490531571382658*^9}, {3.4905318129804077`*^9, 
   3.49053181393456*^9}, {3.490534650111743*^9, 3.4905350555944138`*^9}, 
   3.490536634838295*^9, {3.490555550051849*^9, 3.4905555790277443`*^9}, {
   3.490555852418103*^9, 3.490555856107552*^9}, {3.49058342819491*^9, 
   3.490583440302601*^9}, {3.490583493657379*^9, 3.490583675395978*^9}, {
   3.49059352737274*^9, 3.490593531825512*^9}, {3.490593575982025*^9, 
   3.490593576789216*^9}, 3.490593612858241*^9, {3.490593659809538*^9, 
   3.490593660369617*^9}, {3.49059369579455*^9, 3.490593696180953*^9}, {
   3.490593729074122*^9, 3.49059374105413*^9}, {3.490593859717883*^9, 
   3.490594150576387*^9}, {3.490594205092392*^9, 3.4905942612344093`*^9}, {
   3.4905947706713867`*^9, 3.490594774477147*^9}, {3.490595518654101*^9, 
   3.490595555446281*^9}, {3.490595600741249*^9, 3.490595694806055*^9}, {
   3.490595737996316*^9, 3.490595754802792*^9}, {3.490595792980196*^9, 
   3.490595794333482*^9}, 3.490595842796801*^9, {3.490597408732676*^9, 
   3.490597425233079*^9}, {3.490597482947516*^9, 3.4905975123423862`*^9}, {
   3.490597680998776*^9, 3.490597723287633*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["utilities",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905974954172287`*^9, 3.490597495850638*^9}, {
  3.4905979187175503`*^9, 3.4905979200442343`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"fccCell", "[", 
    RowBox[{"a_Real:", "1."}], "]"}], ":=", 
   RowBox[{
    RowBox[{"a", "/", "2"}], 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"bccCell", "[", 
    RowBox[{"a_Real:", "1."}], "]"}], ":=", 
   RowBox[{
    RowBox[{"a", "/", "2"}], 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", "1", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", 
        RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", 
        RowBox[{"-", "1"}]}], "}"}]}], "}"}]}]}], ";", 
  RowBox[{
   RowBox[{"scCell", "[", 
    RowBox[{"a_Real:", "1."}], "]"}], ":=", 
   RowBox[{"a", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1"}], "}"}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hcpCell", "[", 
   RowBox[{
    RowBox[{"a_Real:", "1."}], ",", 
    RowBox[{"cBya_Real:", "1.5"}]}], "]"}], ":=", 
  RowBox[{"a", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{
        SuperscriptBox["3", 
         RowBox[{"1", "/", "2"}]], "/", "2"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "cBya"}], "}"}]}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"hcpCell", "[", 
   RowBox[{"a_", ",", "cBya_"}], "]"}], ":=", 
  RowBox[{"a", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"1", "/", "2"}], ",", 
       RowBox[{
        SuperscriptBox["3", 
         RowBox[{"1", "/", "2"}]], "/", "2"}], ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "cBya"}], "}"}]}], 
    "}"}]}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"hcpCoordsRel", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "/", "3"}], ",", 
        RowBox[{"1", "/", "3"}], ",", 
        RowBox[{"1", "/", "2"}]}], "}"}]}], "}"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell_List", ",", "radius_"}], "]"}], ":=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0"}], "}"}], "}"}], ",", "1", ",", 
     "radius"}], "]"}]}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"neighborsList", "[", 
   RowBox[{
   "cell_List", ",", "basisRel_List", ",", "atomNr_Integer", ",", "radius_"}],
    "]"}], ":=", 
  RowBox[{"Module", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"delta", "=", 
       SuperscriptBox["10", 
        RowBox[{"-", "4"}]]}], ",", 
      RowBox[{"sphereCovered", "=", "False"}], ",", 
      RowBox[{"n", "=", "0"}], ",", "\[IndentingNewLine]", 
      RowBox[{"neighborsList", "=", 
       RowBox[{"{", "}"}]}], ",", "checkAtom", ",", "distance", ",", 
      "notInSphere", ",", "permList", ",", 
      RowBox[{"permsDone", "=", 
       RowBox[{"{", "}"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"(", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"While", "[", 
       RowBox[{
        RowBox[{"!", "sphereCovered"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"notInSphere", "=", "0"}], ";", " ", "\[IndentingNewLine]", 
         RowBox[{"permList", "=", 
          RowBox[{"Complement", "[", 
           RowBox[{
            RowBox[{"Tuples", "[", 
             RowBox[{
              RowBox[{"Range", "[", 
               RowBox[{
                RowBox[{"-", "n"}], ",", "n"}], "]"}], ",", 
              RowBox[{"{", "3", "}"}]}], "]"}], ",", "permsDone"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"Do", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"checkAtom", "=", 
             RowBox[{
              RowBox[{
               RowBox[{
               "permList", "\[LeftDoubleBracket]", "i", 
                "\[RightDoubleBracket]"}], ".", "cell"}], "+", 
              RowBox[{
               RowBox[{
               "basisRel", "\[LeftDoubleBracket]", "j", 
                "\[RightDoubleBracket]"}], ".", "cell"}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"distance", "=", 
             RowBox[{"Norm", "[", 
              RowBox[{
               RowBox[{
                RowBox[{
                "basisRel", "\[LeftDoubleBracket]", "atomNr", 
                 "\[RightDoubleBracket]"}], ".", "cell"}], "-", "checkAtom"}],
               "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"distance", "<", "radius"}], ",", 
              RowBox[{"AppendTo", "[", 
               RowBox[{"neighborsList", ",", "checkAtom"}], "]"}], ",", 
              RowBox[{"notInSphere", "++"}]}], "]"}], ";"}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", 
             RowBox[{"permList", "//", "Length"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", 
             RowBox[{"basisRel", "//", "Length"}]}], "}"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"Length", "[", "basisRel", "]"}], 
             RowBox[{"Length", "[", "permList", "]"}]}], "\[Equal]", 
            "notInSphere"}], ",", 
           RowBox[{"sphereCovered", "=", "True"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"permsDone", "=", 
          RowBox[{"Join", "[", 
           RowBox[{"permsDone", ",", "permList"}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"n", "++"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"neighborsList", "//", "Rest"}]}], "\[IndentingNewLine]", 
     ")"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.490513520177157*^9, 3.490513685732851*^9}, {
   3.4905137166*^9, 3.4905137792590017`*^9}, {3.490513904120307*^9, 
   3.490513912802784*^9}, {3.4905140134346933`*^9, 3.4905140182013693`*^9}, {
   3.490514082684691*^9, 3.490514085106525*^9}, {3.490514115998582*^9, 
   3.490514127833315*^9}, {3.490514211707625*^9, 3.4905142870266953`*^9}, {
   3.4905143468960876`*^9, 3.490514400260051*^9}, {3.4905144821397676`*^9, 
   3.490514488254174*^9}, {3.490514522820006*^9, 3.490514543556551*^9}, {
   3.490514610262124*^9, 3.4905147123977633`*^9}, {3.490515163085053*^9, 
   3.490515171539096*^9}, 3.490515224853059*^9, {3.490515314529605*^9, 
   3.490515338763731*^9}, {3.490515418895402*^9, 3.4905154222551727`*^9}, {
   3.490517648558688*^9, 3.4905177277452583`*^9}, {3.490517769859743*^9, 
   3.4905178052126513`*^9}, {3.490518732013105*^9, 3.490518772210956*^9}, {
   3.4905226793789787`*^9, 3.4905227664792356`*^9}, {3.490522818221448*^9, 
   3.490522883016861*^9}, {3.490522914788879*^9, 3.490523151189982*^9}, {
   3.49052319004959*^9, 3.4905232180945263`*^9}, {3.490523276664836*^9, 
   3.490523325930956*^9}, 3.4905235459590607`*^9, {3.4905249293259172`*^9, 
   3.490524930128645*^9}, {3.490525065144713*^9, 3.490525094200183*^9}, {
   3.490525125847115*^9, 3.4905252895199614`*^9}, {3.490525394121203*^9, 
   3.490525509957008*^9}, {3.490525563642192*^9, 3.490525570744835*^9}, {
   3.490525615474635*^9, 3.490525641137846*^9}, {3.490525769014241*^9, 
   3.490525972940316*^9}, {3.490526022862143*^9, 3.490526036184943*^9}, {
   3.49052615204279*^9, 3.490526221818142*^9}, 3.490526307579508*^9, {
   3.4905263965471907`*^9, 3.490526648085837*^9}, {3.4905266869120293`*^9, 
   3.49052706226775*^9}, {3.4905274581694927`*^9, 3.4905274755070333`*^9}, {
   3.4905294976288643`*^9, 3.490529549145006*^9}, {3.490529613915743*^9, 
   3.490529883870623*^9}, {3.490529927208599*^9, 3.490529960579927*^9}, {
   3.490531543686408*^9, 3.490531571382658*^9}, {3.4905318129804077`*^9, 
   3.49053181393456*^9}, {3.490534650111743*^9, 3.4905350555944138`*^9}, 
   3.490536634838295*^9, {3.490555550051849*^9, 3.4905555790277443`*^9}, {
   3.490555852418103*^9, 3.490555856107552*^9}, {3.49058342819491*^9, 
   3.490583440302601*^9}, {3.490583493657379*^9, 3.490583675395978*^9}, {
   3.49059352737274*^9, 3.490593531825512*^9}, {3.490593575982025*^9, 
   3.490593576789216*^9}, 3.490593612858241*^9, {3.490593659809538*^9, 
   3.490593660369617*^9}, {3.49059369579455*^9, 3.490593696180953*^9}, {
   3.490593729074122*^9, 3.49059374105413*^9}, {3.490593859717883*^9, 
   3.490594150576387*^9}, {3.490594205092392*^9, 3.4905942612344093`*^9}, {
   3.4905947706713867`*^9, 3.490594774477147*^9}, {3.490595518654101*^9, 
   3.490595555446281*^9}, {3.490595600741249*^9, 3.490595694806055*^9}, {
   3.490595737996316*^9, 3.490595754802792*^9}, {3.490595792980196*^9, 
   3.490595794333482*^9}, 3.490595842796801*^9, {3.490597408732676*^9, 
   3.490597425233079*^9}, {3.490597482947516*^9, 3.4905975123423862`*^9}, {
   3.490597680998776*^9, 3.490597723287633*^9}, {3.4905979252544327`*^9, 
   3.490597967220995*^9}}]
}, Closed]]
}, Closed]],

Cell[BoxData[
 StyleBox[
  RowBox[{
   RowBox[{
   "SetDirectory", "[", 
    "\"\</home/grabowski/newSPHInX_sources/sphinx/src/share/SPHInX/potentials_\
eam/\>\"", "]"}], ";"}],
  FontColor->RGBColor[1, 0, 0]]], "Input",
 CellChangeTimes->{{3.490167904731841*^9, 3.4901679959789457`*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 "Mo Ackland       ",
 StyleBox["     Ref. G.J.Ackland and R.Thetford, Phil.Mag.A, 56, 15 (1987)  ",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.4849265665480003`*^9}, {
  3.490192186273527*^9, 3.49019218943464*^9}, {3.4906783444413*^9, 
  3.490678346341123*^9}, {3.490678438916267*^9, 3.4906784464522943`*^9}, {
  3.490788266475973*^9, 3.490788272564316*^9}, {3.4907883065429792`*^9, 
  3.490788308141904*^9}, {3.490788388528985*^9, 3.490788389527193*^9}, {
  3.490790129721364*^9, 3.490790141734213*^9}, {3.495519519746394*^9, 
  3.495519525328095*^9}, {3.4955195577389*^9, 3.495519584413404*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Mo\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{"str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<.AT1.fs\>\""}],
      ",", "\"\<Table\>\""}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490787991372445*^9, 3.4907880290722227`*^9}, {
  3.4907880593072567`*^9, 3.4907881162508*^9}, {3.490788279078946*^9, 
  3.490788280646761*^9}, {3.490788312057493*^9, 3.4907883134621353`*^9}, {
  3.4955193891255283`*^9, 3.495519400565346*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"header", "=", 
   RowBox[{"eam", "\[LeftDoubleBracket]", 
    RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"eam", "\[LeftDoubleBracket]", 
    RowBox[{"7", ";;", 
     RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"eam", "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4846545435109997`*^9, 3.48465457256*^9}, {
  3.484654605316*^9, 3.48465466008*^9}, {3.4846552739449997`*^9, 
  3.484655287557*^9}, {3.484656966821*^9, 3.484657002514*^9}, {
  3.4846573702390003`*^9, 3.484657372078*^9}, {3.490429635035323*^9, 
  3.49042967211051*^9}, {3.490788010595791*^9, 3.490788011548037*^9}, {
  3.4955211481421347`*^9, 3.495521187668003*^9}, {3.4955227049226007`*^9, 
  3.495522715879364*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nrho", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Nr", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "3"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dr", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "4"}], "\[RightDoubleBracket]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484655427189*^9, 3.4846554613*^9}, {3.4846555115*^9, 
  3.4846555319700003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "drho"}], ",", 
       RowBox[{
       "eam", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nrho"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "dr"}], ",", 
       RowBox[{"eam", "\[LeftDoubleBracket]", 
        RowBox[{"i", "+", "Nrho"}], "\[RightDoubleBracket]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "dr"}], ",", 
       RowBox[{"eam", "\[LeftDoubleBracket]", 
        RowBox[{"i", "+", "Nrho", "+", "Nr"}], "\[RightDoubleBracket]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"pair", "\[LeftDoubleBracket]", 
      RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], "/=", 
     RowBox[{"pair", "\[LeftDoubleBracket]", 
      RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2", ",", 
      RowBox[{"pair", "//", "Length"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pair", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "=", 
   RowBox[{"pair", "\[LeftDoubleBracket]", 
    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484654663009*^9, 3.484654672821*^9}, {3.484654751021*^9,
   3.484654777486*^9}, {3.4846554816429996`*^9, 3.4846555089300003`*^9}, {
  3.4846555400959997`*^9, 3.4846556064309998`*^9}, {3.484655868842*^9, 
  3.4846559497019997`*^9}, {3.484656986292*^9, 3.4846569900699997`*^9}, {
  3.484904556382*^9, 3.484904632399*^9}, {3.484904682245*^9, 
  3.484904682425*^9}, {3.495520522659491*^9, 3.49552054499302*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"emb", "\[LeftDoubleBracket]", 
    RowBox[{"1", ";;", 
     RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.484654687693*^9, 3.484654690523*^9}, {3.484654780767*^9,
   3.484654823402*^9}, {3.484655624172*^9, 3.484655624533*^9}, {
  3.484655657764*^9, 3.4846556758970003`*^9}, {3.484655994467*^9, 
  3.4846560760030003`*^9}, {3.484656218469*^9, 3.484656219928*^9}, {
  3.484656492049*^9, 3.484656508604*^9}, {3.484656600712*^9, 
  3.484656621238*^9}, {3.4846570141689997`*^9, 3.4846570184449997`*^9}, {
  3.4846571543599997`*^9, 3.484657167218*^9}, {3.495519414435128*^9, 
  3.495519414501975*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJxd2GdYU1m4BeCgSJcuvZfQpIbeslJIIvbecBwbih0YdXQsKGIFZ7AHewGv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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.484654690983*^9, {3.484654782067*^9, 3.48465482379*^9}, {
   3.484655618634*^9, 3.484655625007*^9}, {3.484655662102*^9, 
   3.484655676118*^9}, {3.4846559905480003`*^9, 3.4846560039960003`*^9}, {
   3.4846560401540003`*^9, 3.484656076316*^9}, 3.4846562202130003`*^9, {
   3.484656492756*^9, 3.4846565093389997`*^9}, {3.48465661108*^9, 
   3.4846566216210003`*^9}, {3.4846569968269997`*^9, 
   3.4846570187209997`*^9}, {3.484657154915*^9, 3.48465716745*^9}, 
   3.484657374535*^9, 3.484904684648*^9, 3.490429700528388*^9, 
   3.4907878715618343`*^9, 3.490788126921371*^9, 3.4907883211800632`*^9, 
   3.490789645013727*^9, {3.49551940792863*^9, 3.495519414913394*^9}, 
   3.49552273290516*^9, 3.495776844200366*^9, 3.495798071206949*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"a0", "=", "3.8"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"radius", "=", 
   RowBox[{"2", "a0"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"rhoInt", "[", "r_", "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{"r", "<", 
      RowBox[{
       RowBox[{"Last", "[", "rho", "]"}], "\[LeftDoubleBracket]", "1", 
       "\[RightDoubleBracket]"}]}], ",", 
     RowBox[{
      RowBox[{"Interpolation", "[", "rho", "]"}], "[", "r", "]"}], ",", "0"}],
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"bccCell", "[", 
       RowBox[{".8", "a0"}], "]"}], ",", "radius"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "nRSmallALat", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
      "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
      ",", 
      RowBox[{"rhoInt", "[", 
       RowBox[{
       "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
       "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", "n"}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  UnderoverscriptBox["\[Sum]", 
   RowBox[{"j", "=", "1"}], "n"], 
  RowBox[{"rhoInt", "[", 
   RowBox[{
   "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
   "]"}]}]}], "Input",
 CellChangeTimes->{{3.495777079700906*^9, 3.4957770875981293`*^9}, {
   3.495781435318462*^9, 3.495781435676222*^9}, {3.495781613202984*^9, 
   3.495781684147654*^9}, {3.495781753738037*^9, 3.495781802763097*^9}, {
   3.495781836631916*^9, 3.495781837025785*^9}, {3.49578190194209*^9, 
   3.49578198087297*^9}, 3.4957821161251507`*^9, {3.4957946151294518`*^9, 
   3.49579464052204*^9}}],

Cell[BoxData["24.504637349147885`"], "Output",
 CellChangeTimes->{
  3.4957814425441837`*^9, 3.495781688186635*^9, {3.4957818384422207`*^9, 
   3.49578184734667*^9}, 3.495781921183674*^9, {3.495781953534163*^9, 
   3.495781981422051*^9}, 3.495782116562539*^9, {3.495794618131352*^9, 
   3.495794641167294*^9}, 3.4957980758553257`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"rho", "\[LeftDoubleBracket]", 
   RowBox[{"1", ";;", 
    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], "]"}]], "Input",
 CellChangeTimes->{{3.484656629606*^9, 3.484656632193*^9}, {
   3.4846570625629997`*^9, 3.484657077796*^9}, 3.495519427111967*^9}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJxFmXk41O0XxgczjJnB2Lfs+07b2yLntEhSSVSEUlosqWhVtKhXJWnRLqWU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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.484656632574*^9, {3.48465703996*^9, 3.484657078124*^9}, 3.48465737602*^9, 
   3.484904686582*^9, 3.490429703751114*^9, 3.490787874925247*^9, 
   3.4907881283524113`*^9, 3.490788325473592*^9, 3.490789646023559*^9, 
   3.4955194274065247`*^9, 3.4955227402015038`*^9, 3.495776848749413*^9, 
   3.495798080561705*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"pair", "\[LeftDoubleBracket]", 
    RowBox[{"1", ";;", 
     RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "All"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.484657216967*^9, 3.4846572440030003`*^9}, {
  3.4846573579890003`*^9, 3.48465735831*^9}, {3.495519431589014*^9, 
  3.495519486121553*^9}, {3.4955227485231123`*^9, 3.4955228069207983`*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJxVmXc41X/Yx8/hcBxRpEGlQSqKStFS910qSSWjkBWVskfZM0mIShpUSBpE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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{{3.484657222541*^9, 3.484657244257*^9}, {3.484657358526*^9,
    3.484657377134*^9}, 3.4849046880769997`*^9, 3.4904297097591467`*^9, 
   3.490787889129201*^9, 3.490788132173828*^9, 3.4907883306481037`*^9, 
   3.490789649772833*^9, {3.495519431887787*^9, 3.495519486628577*^9}, {
   3.495522741550435*^9, 3.495522807294609*^9}, 3.495776851934742*^9, 
   3.495798082549273*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_AT_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_AT_rho\>\""}], 
   ",", "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{"str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_AT_emb\>\""}], 
   ",", "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.490788140653739*^9, 3.490788150921739*^9}, {
  3.4907883342022963`*^9, 3.4907883446254807`*^9}, {3.4907896560305777`*^9, 
  3.490789659257378*^9}, {3.495519498432425*^9, 3.495519503216054*^9}}],

Cell[BoxData["\<\"Mo/Mo_AT_pair\"\>"], "Output",
 CellChangeTimes->{3.4907881527096148`*^9, 3.4907883468406897`*^9, 
  3.4907896615359507`*^9, 3.495519503987768*^9, 3.4955228101363297`*^9, 
  3.495798084961669*^9}],

Cell[BoxData["\<\"Mo/Mo_AT_rho\"\>"], "Output",
 CellChangeTimes->{3.4907881527096148`*^9, 3.4907883468406897`*^9, 
  3.4907896615359507`*^9, 3.495519503987768*^9, 3.4955228101363297`*^9, 
  3.495798085042547*^9}],

Cell[BoxData["\<\"Mo/Mo_AT_emb\"\>"], "Output",
 CellChangeTimes->{3.4907881527096148`*^9, 3.4907883468406897`*^9, 
  3.4907896615359507`*^9, 3.495519503987768*^9, 3.4955228101363297`*^9, 
  3.4957980851627903`*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.4846560934370003`*^9, 3.4846561190810003`*^9}, {
   3.484656234546*^9, 3.4846562374849997`*^9}, {3.484657479156*^9, 
   3.484657497745*^9}, {3.484904699874*^9, 3.484904706182*^9}, 
   3.49078791370415*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Cu Ackland        ",
 StyleBox["     Ref. web; equivalent with Cu Ackland from below",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.4849265665480003`*^9}, {
  3.490192186273527*^9, 3.49019218943464*^9}, {3.4906783444413*^9, 
  3.490678346341123*^9}, {3.490678438916267*^9, 3.4906784464522943`*^9}, {
  3.490788266475973*^9, 3.490788272564316*^9}, {3.4907883065429792`*^9, 
  3.490788308141904*^9}, {3.490788388528985*^9, 3.490788389527193*^9}, {
  3.490790129721364*^9, 3.490790141734213*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Cu\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland.eam.fs\>\""}],
      ",", "\"\<Table\>\""}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490787991372445*^9, 3.4907880290722227`*^9}, {
  3.4907880593072567`*^9, 3.4907881162508*^9}, {3.490788279078946*^9, 
  3.490788280646761*^9}, {3.490788312057493*^9, 3.4907883134621353`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"header", "=", 
   RowBox[{"eam", "\[LeftDoubleBracket]", 
    RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"eam", "\[LeftDoubleBracket]", 
    RowBox[{"7", ";;", 
     RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"eam", "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4846545435109997`*^9, 3.48465457256*^9}, {
  3.484654605316*^9, 3.48465466008*^9}, {3.4846552739449997`*^9, 
  3.484655287557*^9}, {3.484656966821*^9, 3.484657002514*^9}, {
  3.4846573702390003`*^9, 3.484657372078*^9}, {3.490429635035323*^9, 
  3.49042967211051*^9}, {3.490788010595791*^9, 3.490788011548037*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nrho", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Nr", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "3"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dr", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "4"}], "\[RightDoubleBracket]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484655427189*^9, 3.4846554613*^9}, {3.4846555115*^9, 
  3.4846555319700003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "drho"}], ",", 
       RowBox[{
       "eam", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nrho"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "dr"}], ",", 
       RowBox[{"eam", "\[LeftDoubleBracket]", 
        RowBox[{"i", "+", "Nrho"}], "\[RightDoubleBracket]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "dr"}], ",", 
       RowBox[{"eam", "\[LeftDoubleBracket]", 
        RowBox[{"i", "+", "Nrho", "+", "Nr"}], "\[RightDoubleBracket]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"pair", "\[LeftDoubleBracket]", 
      RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], "/=", 
     RowBox[{"pair", "\[LeftDoubleBracket]", 
      RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2", ",", 
      RowBox[{"pair", "//", "Length"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pair", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "=", 
   RowBox[{"pair", "\[LeftDoubleBracket]", 
    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484654663009*^9, 3.484654672821*^9}, {3.484654751021*^9,
   3.484654777486*^9}, {3.4846554816429996`*^9, 3.4846555089300003`*^9}, {
  3.4846555400959997`*^9, 3.4846556064309998`*^9}, {3.484655868842*^9, 
  3.4846559497019997`*^9}, {3.484656986292*^9, 3.4846569900699997`*^9}, {
  3.484904556382*^9, 3.484904632399*^9}, {3.484904682245*^9, 
  3.484904682425*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"emb", "\[LeftDoubleBracket]", 
    RowBox[{"1", ";;", "1200"}], "\[RightDoubleBracket]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.484654687693*^9, 3.484654690523*^9}, {3.484654780767*^9,
   3.484654823402*^9}, {3.484655624172*^9, 3.484655624533*^9}, {
  3.484655657764*^9, 3.4846556758970003`*^9}, {3.484655994467*^9, 
  3.4846560760030003`*^9}, {3.484656218469*^9, 3.484656219928*^9}, {
  3.484656492049*^9, 3.484656508604*^9}, {3.484656600712*^9, 
  3.484656621238*^9}, {3.4846570141689997`*^9, 3.4846570184449997`*^9}, {
  3.4846571543599997`*^9, 3.484657167218*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJxd3Hdczf37B/BUSippSUuJ0tQ47XVeZ59T5+C2M+NOQoTs2ZdbVmZWZva4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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.484654690983*^9, {3.484654782067*^9, 3.48465482379*^9}, {
   3.484655618634*^9, 3.484655625007*^9}, {3.484655662102*^9, 
   3.484655676118*^9}, {3.4846559905480003`*^9, 3.4846560039960003`*^9}, {
   3.4846560401540003`*^9, 3.484656076316*^9}, 3.4846562202130003`*^9, {
   3.484656492756*^9, 3.4846565093389997`*^9}, {3.48465661108*^9, 
   3.4846566216210003`*^9}, {3.4846569968269997`*^9, 
   3.4846570187209997`*^9}, {3.484657154915*^9, 3.48465716745*^9}, 
   3.484657374535*^9, 3.484904684648*^9, 3.490429700528388*^9, 
   3.4907878715618343`*^9, 3.490788126921371*^9, 3.4907883211800632`*^9, 
   3.490789645013727*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"rho", "\[LeftDoubleBracket]", 
   RowBox[{"3000", ";;", 
    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], "]"}]], "Input",
 CellChangeTimes->{{3.484656629606*^9, 3.484656632193*^9}, {
  3.4846570625629997`*^9, 3.484657077796*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJwUmnk0ld8Xxg2ZK1PlznMp+SpUQtm7UpLKlEIaSCQZQqWoNFBJQoOoVMiQ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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.484656632574*^9, {3.48465703996*^9, 3.484657078124*^9}, 3.48465737602*^9, 
   3.484904686582*^9, 3.490429703751114*^9, 3.490787874925247*^9, 
   3.4907881283524113`*^9, 3.490788325473592*^9, 3.490789646023559*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"pair", "\[LeftDoubleBracket]", 
   RowBox[{"3500", ";;", 
    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], "]"}]], "Input",
 CellChangeTimes->{{3.484657216967*^9, 3.4846572440030003`*^9}, {
  3.4846573579890003`*^9, 3.48465735831*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJwUWXk8VO8XHmPfZ6yFlD2pLFEqnCNriSRRWYoUopSQpaiUlIq+2bNFUtqR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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{{3.484657222541*^9, 3.484657244257*^9}, {3.484657358526*^9,
    3.484657377134*^9}, 3.4849046880769997`*^9, 3.4904297097591467`*^9, 
   3.490787889129201*^9, 3.490788132173828*^9, 3.4907883306481037`*^9, 
   3.490789649772833*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland2_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland2_rho\>\""}], 
   ",", "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland2_emb\>\""}], 
   ",", "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.490788140653739*^9, 3.490788150921739*^9}, {
  3.4907883342022963`*^9, 3.4907883446254807`*^9}, {3.4907896560305777`*^9, 
  3.490789659257378*^9}}],

Cell[BoxData["\<\"Cu/Cu_Ackland2_pair\"\>"], "Output",
 CellChangeTimes->{3.4907881527096148`*^9, 3.4907883468406897`*^9, 
  3.4907896615359507`*^9}],

Cell[BoxData["\<\"Cu/Cu_Ackland2_rho\"\>"], "Output",
 CellChangeTimes->{3.4907881527096148`*^9, 3.4907883468406897`*^9, 
  3.490789662339581*^9}],

Cell[BoxData["\<\"Cu/Cu_Ackland2_emb\"\>"], "Output",
 CellChangeTimes->{3.4907881527096148`*^9, 3.4907883468406897`*^9, 
  3.490789663483046*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.4846560934370003`*^9, 3.4846561190810003`*^9}, {
   3.484656234546*^9, 3.4846562374849997`*^9}, {3.484657479156*^9, 
   3.484657497745*^9}, {3.484904699874*^9, 3.484904706182*^9}, 
   3.49078791370415*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Ru Mendelev        ",
 StyleBox["  Ref. \
http://www.ctcms.nist.gov/potentials/Download/Ru-MIM/Ru.eam.fs",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.4849265665480003`*^9}, {
  3.490192186273527*^9, 3.49019218943464*^9}, {3.4906783444413*^9, 
  3.490678346341123*^9}, {3.490678438916267*^9, 3.4906784464522943`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Ru\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"Import", "[", 
    RowBox[{
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
      "\"\<_Mendelev.eam.fs\>\""}], ",", "\"\<Table\>\""}], "]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.490787991372445*^9, 3.4907880290722227`*^9}, {
  3.4907880593072567`*^9, 3.4907881162508*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"header", "=", 
   RowBox[{"eam", "\[LeftDoubleBracket]", 
    RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"eam", "\[LeftDoubleBracket]", 
    RowBox[{"7", ";;", 
     RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"eam", "=", 
   RowBox[{"eam", "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4846545435109997`*^9, 3.48465457256*^9}, {
  3.484654605316*^9, 3.48465466008*^9}, {3.4846552739449997`*^9, 
  3.484655287557*^9}, {3.484656966821*^9, 3.484657002514*^9}, {
  3.4846573702390003`*^9, 3.484657372078*^9}, {3.490429635035323*^9, 
  3.49042967211051*^9}, {3.490788010595791*^9, 3.490788011548037*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Nrho", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "1"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "2"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Nr", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "3"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"dr", "=", 
   RowBox[{"header", "\[LeftDoubleBracket]", 
    RowBox[{"5", ",", "4"}], "\[RightDoubleBracket]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484655427189*^9, 3.4846554613*^9}, {3.4846555115*^9, 
  3.4846555319700003`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "drho"}], ",", 
       RowBox[{
       "eam", "\[LeftDoubleBracket]", "i", "\[RightDoubleBracket]"}]}], "}"}],
      ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nrho"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "dr"}], ",", 
       RowBox[{"eam", "\[LeftDoubleBracket]", 
        RowBox[{"i", "+", "Nrho"}], "\[RightDoubleBracket]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"i", "-", "1"}], ")"}], "dr"}], ",", 
       RowBox[{"eam", "\[LeftDoubleBracket]", 
        RowBox[{"i", "+", "Nrho", "+", "Nr"}], "\[RightDoubleBracket]"}]}], 
      "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", "Nr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"pair", "\[LeftDoubleBracket]", 
      RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], "/=", 
     RowBox[{"pair", "\[LeftDoubleBracket]", 
      RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", "2", ",", 
      RowBox[{"pair", "//", "Length"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"pair", "\[LeftDoubleBracket]", 
    RowBox[{"1", ",", "2"}], "\[RightDoubleBracket]"}], "=", 
   RowBox[{"pair", "\[LeftDoubleBracket]", 
    RowBox[{"2", ",", "2"}], "\[RightDoubleBracket]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484654663009*^9, 3.484654672821*^9}, {3.484654751021*^9,
   3.484654777486*^9}, {3.4846554816429996`*^9, 3.4846555089300003`*^9}, {
  3.4846555400959997`*^9, 3.4846556064309998`*^9}, {3.484655868842*^9, 
  3.4846559497019997`*^9}, {3.484656986292*^9, 3.4846569900699997`*^9}, {
  3.484904556382*^9, 3.484904632399*^9}, {3.484904682245*^9, 
  3.484904682425*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{
   RowBox[{"emb", "\[LeftDoubleBracket]", 
    RowBox[{"1", ";;", "1200"}], "\[RightDoubleBracket]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", "Automatic"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.484654687693*^9, 3.484654690523*^9}, {3.484654780767*^9,
   3.484654823402*^9}, {3.484655624172*^9, 3.484655624533*^9}, {
  3.484655657764*^9, 3.4846556758970003`*^9}, {3.484655994467*^9, 
  3.4846560760030003`*^9}, {3.484656218469*^9, 3.484656219928*^9}, {
  3.484656492049*^9, 3.484656508604*^9}, {3.484656600712*^9, 
  3.484656621238*^9}, {3.4846570141689997`*^9, 3.4846570184449997`*^9}, {
  3.4846571543599997`*^9, 3.484657167218*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJxd3HlcjPv7P/AUUSqltKJVKe3Tvs2rqVlqZjjHnjVLCVmzZc2+hciWcDqW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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.484654690983*^9, {3.484654782067*^9, 3.48465482379*^9}, {
   3.484655618634*^9, 3.484655625007*^9}, {3.484655662102*^9, 
   3.484655676118*^9}, {3.4846559905480003`*^9, 3.4846560039960003`*^9}, {
   3.4846560401540003`*^9, 3.484656076316*^9}, 3.4846562202130003`*^9, {
   3.484656492756*^9, 3.4846565093389997`*^9}, {3.48465661108*^9, 
   3.4846566216210003`*^9}, {3.4846569968269997`*^9, 
   3.4846570187209997`*^9}, {3.484657154915*^9, 3.48465716745*^9}, 
   3.484657374535*^9, 3.484904684648*^9, 3.490429700528388*^9, 
   3.4907878715618343`*^9, 3.490788126921371*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"rho", "\[LeftDoubleBracket]", 
   RowBox[{"3000", ";;", 
    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], "]"}]], "Input",
 CellChangeTimes->{{3.484656629606*^9, 3.484656632193*^9}, {
  3.4846570625629997`*^9, 3.484657077796*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJwkXHlcjF0bnjUKUVQKNVszTVPNUlHEXAihXSF7WSsVopC9lDaFUAipJBTZ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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.484656632574*^9, {3.48465703996*^9, 3.484657078124*^9}, 3.48465737602*^9, 
   3.484904686582*^9, 3.490429703751114*^9, 3.490787874925247*^9, 
   3.4907881283524113`*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListPlot", "[", 
  RowBox[{"pair", "\[LeftDoubleBracket]", 
   RowBox[{"3500", ";;", 
    RowBox[{"-", "1"}]}], "\[RightDoubleBracket]"}], "]"}]], "Input",
 CellChangeTimes->{{3.484657216967*^9, 3.4846572440030003`*^9}, {
  3.4846573579890003`*^9, 3.48465735831*^9}}],

Cell[BoxData[
 GraphicsBox[
  {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJwkXHlYjW8T1lnek63STgihqBSKQmZCKdopCpWSKBShKEQ7oaif0IpCFCJR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    "]]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  PlotRange->Automatic,
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{{3.484657222541*^9, 3.484657244257*^9}, {3.484657358526*^9,
    3.484657377134*^9}, 3.4849046880769997`*^9, 3.4904297097591467`*^9, 
   3.490787889129201*^9, 3.490788132173828*^9},
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Mendelev_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Mendelev_rho\>\""}], 
   ",", "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Mendelev_emb\>\""}], 
   ",", "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.490788140653739*^9, 3.490788150921739*^9}}],

Cell[BoxData["\<\"Ru/Ru_Mendelev_pair\"\>"], "Output",
 CellChangeTimes->{3.4907881527096148`*^9}],

Cell[BoxData["\<\"Ru/Ru_Mendelev_rho\"\>"], "Output",
 CellChangeTimes->{3.490788153594294*^9}],

Cell[BoxData["\<\"Ru/Ru_Mendelev_emb\"\>"], "Output",
 CellChangeTimes->{3.49078815456461*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.4846560934370003`*^9, 3.4846561190810003`*^9}, {
   3.484656234546*^9, 3.4846562374849997`*^9}, {3.484657479156*^9, 
   3.484657497745*^9}, {3.484904699874*^9, 3.484904706182*^9}, 
   3.49078791370415*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Fe Ackland              ",
 StyleBox["Ref. Ackland, Bacon, Calder, Harry, Phil. Mag. A 75 (1997) 713",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.4906047822956533`*^9, 3.490604786358427*^9}, {3.4906351291163683`*^9, 
   3.49063520278023*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Fe\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490635209649705*^9, 3.49063522189732*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", "\[Sigma]33", ",", 
      "C11", ",", "C12", ",", "C44"}], "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bk", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"7", ";;", "8"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rak", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"9", ";;", "14"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"15", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"bccCell", "[", "a0", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "\[Cross]", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
     ".", 
    RowBox[{
    "cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"radius", "=", 
    RowBox[{"2", "a0"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "radius"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.490635231737218*^9, 3.490635391126584*^9}, {
   3.4906354780092163`*^9, 3.490635489452805*^9}, {3.4906356222918453`*^9, 
   3.490635627586684*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Sigma]11", ",", 
       RowBox[{"\[Sigma]bcc", "[", 
        RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\[Sigma]33", ",", 
       RowBox[{"\[Sigma]bcc", "[", 
        RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C11", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C12", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C44", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}]}], 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
  3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
  3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
  3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
  3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
  3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
  3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
  3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
  3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}, {
  3.490635410591322*^9, 3.490635440897768*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.89`", ",", "1.8399998620497757`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.4906753308620243`*^9, 
   3.490787774883304*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.316`", ",", "4.3160000313049185`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.4906753308620243`*^9, 
   3.490787776895241*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"23.541904000000002`", ",", "24.522307352605985`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.4906753308620243`*^9, 
   3.490787777544755*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"V", "[", 
     RowBox[{
      RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
    RowBox[{"2", " ", 
     RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
     RowBox[{"\[CapitalPhi]", "[", 
      RowBox[{
       RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0.5", ",", "2"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}, {
  3.490635674693934*^9, 3.490635683065732*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxN2Hk4VG/YOHCpkC1bSEiRZEkhIbllS6SkhCgVUSj6ypYlISRbVJYUirKl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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{{0.5, 2}, {-0.5, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490606235931028*^9, 3.49063568434344*^9, 3.49078778098903*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"bccCell", "[", 
       RowBox[{"0.8", "a0"}], "]"}], ",", "radius"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "500"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{"0.05", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906377837368526`*^9, {3.490637816141879*^9, 3.490637857116971*^9}, {
   3.490787833228981*^9, 3.490787838703918*^9}}],

Cell[BoxData["43.874485106271216`"], "Output",
 CellChangeTimes->{3.4906377906644993`*^9, 3.490637829437358*^9, 
  3.4906378604117527`*^9, 3.490787786828517*^9, 3.490787840622086*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490787797716647*^9, 3.4907878095489607`*^9}}],

Cell[BoxData["11467"], "Output",
 CellChangeTimes->{3.4907878116641283`*^9, 3.490787842730542*^9}],

Cell[BoxData["11467"], "Output",
 CellChangeTimes->{3.4907878116641283`*^9, 3.4907878427849607`*^9}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.4907878116641283`*^9, 3.490787842811*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_rho\>\""}], ",",
    "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_emb\>\""}], ",",
    "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490637894913205*^9, 
   3.490637904139831*^9}}],

Cell[BoxData["\<\"Fe/Fe_Ackland_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, {3.490787822833744*^9, 3.4907878450534067`*^9}}],

Cell[BoxData["\<\"Fe/Fe_Ackland_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, {3.490787822833744*^9, 3.490787845354225*^9}}],

Cell[BoxData["\<\"Fe/Fe_Ackland_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, {3.490787822833744*^9, 3.4907878463238287`*^9}}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Cu Ackland             ",
 StyleBox["Ref. Ackland, et  al., Phil. Mag. A 75 (1997) 713 & Ref. Ackland, \
et al., Phil. Mag. A 56 (1987) 735",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.4906047822956533`*^9, 3.490604786358427*^9}, {3.4906351291163683`*^9, 
   3.49063520278023*^9}, {3.490638150821054*^9, 3.490638154338563*^9}, {
   3.490672168343008*^9, 3.490672192261283*^9}, 3.490673059295948*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Cu\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490635209649705*^9, 3.49063522189732*^9}, {
   3.490638163424374*^9, 3.490638164039442*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", "\[Sigma]33", ",", 
      "C11", ",", "C12", ",", "C44", ",", "\[Gamma]", ",", "\[Alpha]"}], 
     "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bk", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"7", ";;", "8"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rak", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"9", ";;", "14"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"15", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"fccCell", "[", "a0", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "\[Cross]", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
     ".", 
    RowBox[{
    "cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"radius", "=", 
    RowBox[{"2", "a0"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "radius"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.490635231737218*^9, 3.490635391126584*^9}, {
   3.4906354780092163`*^9, 3.490635489452805*^9}, {3.4906356222918453`*^9, 
   3.490635627586684*^9}, {3.490638489035017*^9, 3.4906384928899307`*^9}, {
   3.490638546030054*^9, 3.4906385466340437`*^9}, {3.490641394651822*^9, 
   3.490641441997636*^9}, {3.490641938204934*^9, 3.4906419402096043`*^9}, {
   3.490668552436515*^9, 3.4906685738311443`*^9}, 3.490672317098597*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", 
     RowBox[{"V", "[", 
      RowBox[{
       RowBox[{"2", 
        RowBox[{"a0", "/", 
         SuperscriptBox["3", 
          RowBox[{"1", "/", "2"}]]}]}], ",", "Ak"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Sigma]11", ",", 
       RowBox[{"\[Sigma]bcc", "[", 
        RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\[Sigma]33", ",", 
       RowBox[{"\[Sigma]bcc", "[", 
        RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C11", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C12", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C44", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}]}], 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
  3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
  3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
  3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
  3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
  3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
  3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
  3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
  3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}, {
  3.490635410591322*^9, 3.490635440897768*^9}, {3.490641838096979*^9, 
  3.490641839743491*^9}, {3.490641957080739*^9, 3.490641990247888*^9}, {
  3.4906722552637568`*^9, 3.4906722603596354`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.17`", ",", "1.1715823008112056`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906757724929256`*^9, 
   3.4907875207409286`*^9, 3.4907896779025583`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.518`", ",", "3.519353007934253`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906757724929256`*^9, 
   3.4907875207409286`*^9, 3.490789681122368*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"22.052415999999997`", ",", "22.048109172900205`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906757724929256`*^9, 
   3.4907875207409286`*^9, 3.4907896813216553`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.01`", ",", "0.00998628421873607`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906757724929256`*^9, 
   3.4907875207409286`*^9, 3.490789684894128*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"fromAckland", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"str", "<>", "\"\</EffectivePotential_fromAckland.dat\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"fromAckland2", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"str", "<>", "\"\</Potential_fromAckland.dat\>\""}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"ListPlot", "[", "fromAckland", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0.5", ",", "1.35"}], "}"}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"ListPlot", "[", 
    RowBox[{"fromAckland2", ",", 
     RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"V", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], ",", 
       RowBox[{"\[Phi]", "[", "r", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0.5", ",", "1.35"}], "}"}], ",", 
     RowBox[{"PlotStyle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Red", ",", "Dashed"}], "}"}]}]}], "]"}], 
   "\[IndentingNewLine]", ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".17"}], ",", ".3"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}, {
  3.490635674693934*^9, 3.490635683065732*^9}, {3.4906401587885637`*^9, 
  3.490640289258285*^9}, {3.490640654096795*^9, 3.490640780221518*^9}, {
  3.490641117860363*^9, 3.490641120351645*^9}, {3.490643400678535*^9, 
  3.490643407036413*^9}, {3.490668273186605*^9, 3.4906683528396463`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9Un8s1GEc/kapdMlSWazRj0WGtVoyak9Fq1kJjWXthpubKLVqlBnOWNKU
Qn+gu6NpJGOXsuG6148v12HyoxpizPfOrzvcUWkrW77ft/Vu79497+f9fJ7P
87yfvZJbYVIrhmEOr23+NLHBJnZhEvdjv6b52g6CERYHkacxV73SD5WDv8rB
mUPgp7kF17o+iv057DTbl2936UXHWnrwDQ7xdrH9+77oINR7wqH7Yab05DMt
LvEXFRzGpUOepyY6wGer6jmEj6jd7cJYKIZy5UM6DsXrqmvuFLSCh7mrHKyi
REwCafqPBzSJEVvPa2h9bz2CLuwOSDxST/u5qkfIxe6fivwq7OAJbuthb73L
+bmjjObL9XCduVsucSoiyRK3ZIlWj6eGTGZ4uIoI/JsNyBip6zT6vKfxcwZ0
nYZVK9tMhP6zDQgM3xMxer2F8PTBJgNi0nSLRQfaiABjp3AwLnQ1W9ZOBPsm
pvAn/2hvbypLBL2Xp5E+H1/226aDCH6ZppEZPelVucwS2u8MSn+9KraOZP/F
Z7DyufNQkrSdCHpvzkJsGyqZPd5GBD1js/D4EDmXYdNKcdocGl3Cxx3zNOQR
L9fXCO2DAXFcbRPlHzRCNBxwRadqIO6CQBNeyFeqzkbV0/xVE/K+j3Wd0NfS
+Mt5RG/hDaykcfEC1NqN1TEDStqP3SLMFaHbztjkEz++fuEiGHlQyL2wFOqf
mxktotINm9Tp9H9TzDD7aZLEPQUQ/OsxQ+atNP3wKKHz4GCB76jXUqGbgv5f
jAWur7Pk+z3K6HzVWNDX8lbxMVVJ3y9b4P5men2OvgQCnc8SruVkNBxrLqLz
K1tCtFPURLryMZ0/dg27hGS/888C/zx53zKYRkXat5oE/AWypI0t
     "]]}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxN1nk4VG/4P/D62MpWVIgsSbKVSBKaW9kKkTWEEJIthCQkJCJbdpkpoYXs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      "]]}}, 
   {RGBColor[1, 0, 0], PointBox[CompressedData["
1:eJwBcQKO/SFib1JlAgAAACYAAAACAAAA5ej020qz5j9yfuVi4TDTPzq8I3S5
2uY/WMmxVtRk0T9Dm/jnMSLnPz3knnB5is8/mG4ngKBJ5z9J2KNhHcDLP6FN
/PMYkec/m/b2kS12xz/2ICuMh7jnP//jjLPzHsU/QFLLlKPT5z8Pk/5I8WrC
P4uDa52/7uc/uuEWjwr5vz9KMaAIHBvoP2I+jkvjC7w/v600a1ws6D+uS2zq
niW5Pwrf1HN4R+g/gsf17NtmtT/JjAnf1HPoP0aRrJ4THLI/iDo+SjGg6D+4
d6IUzkWtP7LCeIh70eg/vL5ON2XBpD9Rx0cpBhTpPyir5wSH5Jo/e0+CZ1BF
6T9gpIWXy3KLP85f9+Pkp+k/ALxB1UKmJb/YPsxXXe/pP1AKUWLpN4K/QJNe
85Zq6j8YLQf9CASTv9/Uc3hH6Oo/EDxjx2wOmb9ysUBSy5TrP8RzGIRX3pq/
xP77soUy7D8w1CYzyXOYvyyQ1DLl6Ow/KKPgRbwwlb806TVvqabtP/hj/aOf
W5C//LKFMqRV7j/A75QkcgSIvw9xLxqV5O4/wOKcwXG0fL/C9mG+6nrvPwBl
ovWunWa/70nwDKoo8D8QAxYblReAP1QQdXyUYvA/WJvMJM9hkD+IOj5KMaDw
P3D9WP/o55Y/7ADDuRva8D8QEySZKn+bP9Y2MmPCN/E/0MCynsh7nz+ELlfb
yIzxP9DAsp7Ie58/XnFwrfPX8T+gPDyhBb2bP/gkeAZVFPI/4NNA9w2qlj9h
PMS9aFTyP+h/UdEDtpE/1fWeBM+g8j9wCwMWG5WHP08AQZNe8/I/4CDoc6Fi
ej9XSD1o
     "]]}, {{}, {}, 
    {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxNl3k41N8b98vWRiThm8qSNqmoKKV5y5pCCC3IThFFhVBJGUv2LfsyobKF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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{-0.17, 0.3},
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490606235931028*^9, 3.49063568434344*^9, 3.49063928360006*^9, 
   3.4906402956418667`*^9, {3.490640740993848*^9, 3.49064078226469*^9}, 
   3.490641123894382*^9, 3.490641168965413*^9, 3.490641458576531*^9, 
   3.490643012483081*^9, 3.490643428248577*^9, 3.490643488549136*^9, 
   3.490643639290344*^9, 3.490643798998518*^9, 3.490643931819478*^9, 
   3.490644025593341*^9, {3.490668247571972*^9, 3.49066828609971*^9}, {
   3.490668336631238*^9, 3.490668354889114*^9}, 3.4906684512098017`*^9, 
   3.490668590015751*^9, 3.49066913993747*^9, 3.490675788318387*^9, 
   3.490787532500342*^9, 3.490789690671727*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"fccCell", "[", 
       RowBox[{"0.8", "a0"}], "]"}], ",", "radius"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "200"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{".02", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4907875952895393`*^9, 3.49078765731631*^9}}],

Cell[BoxData["59.05138706171331`"], "Output",
 CellChangeTimes->{{3.490787598309967*^9, 3.490787628759901*^9}, 
   3.4907876589202833`*^9, 3.490789693474163*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490787631772696*^9, 3.490787644463355*^9}}],

Cell[BoxData["14461"], "Output",
 CellChangeTimes->{{3.490787645968053*^9, 3.490787660938653*^9}, 
   3.490789695554596*^9}],

Cell[BoxData["14461"], "Output",
 CellChangeTimes->{{3.490787645968053*^9, 3.490787660938653*^9}, 
   3.4907896955646467`*^9}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{{3.490787645968053*^9, 3.490787660938653*^9}, 
   3.490789695575375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_rho\>\""}], ",",
    "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_emb\>\""}], ",",
    "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490637894913205*^9, 
   3.490637904139831*^9}}],

Cell[BoxData["\<\"Cu/Cu_Ackland_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.4907876637645206`*^9, 3.490789696316894*^9}],

Cell[BoxData["\<\"Cu/Cu_Ackland_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.4907876637645206`*^9, 3.490789697071611*^9}],

Cell[BoxData["\<\"Cu/Cu_Ackland_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.4907876637645206`*^9, 3.490789698259335*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Ag Ackland             ",
 StyleBox["Ref. Ackland, Tichy, Vitek, Finnis, Phil. Mag. A 56 (1987) 735",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.4906047822956533`*^9, 3.490604786358427*^9}, {3.4906351291163683`*^9, 
   3.49063520278023*^9}, {3.490638150821054*^9, 3.490638154338563*^9}, {
   3.4906721093121147`*^9, 3.490672158961433*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Ag\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490635209649705*^9, 3.49063522189732*^9}, {
   3.490638163424374*^9, 3.490638164039442*^9}, {3.490672206790083*^9, 
   3.490672207424769*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", "\[Sigma]33", ",", 
      "C11", ",", "C12", ",", "C44", ",", "\[Gamma]", ",", "\[Alpha]"}], 
     "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bk", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"9", ";;", "10"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rak", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"11", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"7", ";;", "8"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", "*)"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"fccCell", "[", "a0", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "\[Cross]", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
     ".", 
    RowBox[{
    "cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"radius", "=", 
    RowBox[{"2", "a0"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "radius"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.490635231737218*^9, 3.490635391126584*^9}, {
   3.4906354780092163`*^9, 3.490635489452805*^9}, {3.4906356222918453`*^9, 
   3.490635627586684*^9}, {3.490638489035017*^9, 3.4906384928899307`*^9}, {
   3.490638546030054*^9, 3.4906385466340437`*^9}, {3.490641394651822*^9, 
   3.490641441997636*^9}, {3.490641938204934*^9, 3.4906419402096043`*^9}, {
   3.490668552436515*^9, 3.4906685738311443`*^9}, 3.490672310122747*^9, {
   3.490672578197186*^9, 3.490672582145076*^9}, {3.490672684070315*^9, 
   3.490672709446478*^9}, {3.4906728242020817`*^9, 3.4906728461397657`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Alpha]", ",", 
     RowBox[{"V", "[", 
      RowBox[{
       RowBox[{"2", 
        RowBox[{"a0", "/", 
         SuperscriptBox["3", 
          RowBox[{"1", "/", "2"}]]}]}], ",", "Ak"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Sigma]11", ",", 
       RowBox[{"\[Sigma]bcc", "[", 
        RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"\[Sigma]33", ",", 
       RowBox[{"\[Sigma]bcc", "[", 
        RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C11", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C12", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"C44", ",", 
       RowBox[{"Cbcc", "[", 
        RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}]}], 
    "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
  3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
  3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
  3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
  3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
  3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
  3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
  3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
  3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}, {
  3.490635410591322*^9, 3.490635440897768*^9}, {3.490641838096979*^9, 
  3.490641839743491*^9}, {3.490641957080739*^9, 3.490641990247888*^9}, {
  3.4906722412840843`*^9, 3.490672246143961*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.`", ",", "1.0004426560220965`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906722143584967`*^9, 
   3.490672342584502*^9, 3.4906723837715397`*^9, 3.4906726380778217`*^9, 
   3.490672695248485*^9, 3.490672727043847*^9, 3.490672849017926*^9, 
   3.4907873160454273`*^9, 3.490787700777124*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.967`", ",", "2.9674438893381083`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906722143584967`*^9, 
   3.490672342584502*^9, 3.4906723837715397`*^9, 3.4906726380778217`*^9, 
   3.490672695248485*^9, 3.490672727043847*^9, 3.490672849017926*^9, 
   3.4907873160454273`*^9, 3.4907877018128843`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"15.476356000000001`", ",", "15.476375407466838`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906722143584967`*^9, 
   3.490672342584502*^9, 3.4906723837715397`*^9, 3.4906726380778217`*^9, 
   3.490672695248485*^9, 3.490672727043847*^9, 3.490672849017926*^9, 
   3.4907873160454273`*^9, 3.490787704152913*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.007`", ",", "0.006999660887132576`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490635444314663*^9, 
   3.49063549242561*^9, 3.490635639628024*^9, 3.490638507827044*^9, 
   3.490638551982771*^9, 3.490640149610565*^9, {3.490641402676675*^9, 
   3.490641448604389*^9}, {3.490641975363125*^9, 3.490641991226507*^9}, 
   3.49064298179152*^9, 3.490668229348174*^9, 3.49066826925525*^9, 
   3.49066857767162*^9, 3.490669133677937*^9, 3.4906722143584967`*^9, 
   3.490672342584502*^9, 3.4906723837715397`*^9, 3.4906726380778217`*^9, 
   3.490672695248485*^9, 3.490672727043847*^9, 3.490672849017926*^9, 
   3.4907873160454273`*^9, 3.490787704766629*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "WARNING", " ", "comparing", " ", "to", " ", "effective", " ", "potential",
     " ", "of", " ", "Cu"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"fromAckland", "=", 
     RowBox[{
     "Import", "[", "\"\<Cu/EffectivePotential_fromAckland.dat\>\"", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"fromAckland2", "=", 
     RowBox[{"Import", "[", "\"\<Cu/Potential_fromAckland.dat\>\"", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{"Show", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"ListPlot", "[", "fromAckland", "]"}], ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"V", "[", 
         RowBox[{
          RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
        RowBox[{"2", " ", 
         RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
         RowBox[{"\[CapitalPhi]", "[", 
          RowBox[{
           RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "0.5", ",", "1.35"}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"ListPlot", "[", 
      RowBox[{"fromAckland2", ",", 
       RowBox[{"PlotStyle", "\[Rule]", "Red"}]}], "]"}], ",", 
     RowBox[{"Plot", "[", 
      RowBox[{
       RowBox[{"V", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"r", ",", "0.5", ",", "1.35"}], "}"}], ",", 
       RowBox[{"PlotStyle", "\[Rule]", 
        RowBox[{"{", "Red", "}"}]}]}], "]"}], "\[IndentingNewLine]", ",", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".17"}], ",", ".3"}], "}"}]}], ",", 
     RowBox[{"AxesOrigin", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}, {
  3.490635674693934*^9, 3.490635683065732*^9}, {3.4906401587885637`*^9, 
  3.490640289258285*^9}, {3.490640654096795*^9, 3.490640780221518*^9}, {
  3.490641117860363*^9, 3.490641120351645*^9}, {3.490643400678535*^9, 
  3.490643407036413*^9}, {3.490668273186605*^9, 3.4906683528396463`*^9}, {
  3.490672878990739*^9, 3.490672905650495*^9}, {3.490787347674911*^9, 
  3.490787364674568*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9Un8s1GEc/kapdMlSWazRj0WGtVoyak9Fq1kJjWXthpubKLVqlBnOWNKU
Qn+gu6NpJGOXsuG6148v12HyoxpizPfOrzvcUWkrW77ft/Vu79497+f9fJ7P
87yfvZJbYVIrhmEOr23+NLHBJnZhEvdjv6b52g6CERYHkacxV73SD5WDv8rB
mUPgp7kF17o+iv057DTbl2936UXHWnrwDQ7xdrH9+77oINR7wqH7Yab05DMt
LvEXFRzGpUOepyY6wGer6jmEj6jd7cJYKIZy5UM6DsXrqmvuFLSCh7mrHKyi
REwCafqPBzSJEVvPa2h9bz2CLuwOSDxST/u5qkfIxe6fivwq7OAJbuthb73L
+bmjjObL9XCduVsucSoiyRK3ZIlWj6eGTGZ4uIoI/JsNyBip6zT6vKfxcwZ0
nYZVK9tMhP6zDQgM3xMxer2F8PTBJgNi0nSLRQfaiABjp3AwLnQ1W9ZOBPsm
pvAn/2hvbypLBL2Xp5E+H1/226aDCH6ZppEZPelVucwS2u8MSn+9KraOZP/F
Z7DyufNQkrSdCHpvzkJsGyqZPd5GBD1js/D4EDmXYdNKcdocGl3Cxx3zNOQR
L9fXCO2DAXFcbRPlHzRCNBxwRadqIO6CQBNeyFeqzkbV0/xVE/K+j3Wd0NfS
+Mt5RG/hDaykcfEC1NqN1TEDStqP3SLMFaHbztjkEz++fuEiGHlQyL2wFOqf
mxktotINm9Tp9H9TzDD7aZLEPQUQ/OsxQ+atNP3wKKHz4GCB76jXUqGbgv5f
jAWur7Pk+z3K6HzVWNDX8lbxMVVJ3y9b4P5men2OvgQCnc8SruVkNBxrLqLz
K1tCtFPURLryMZ0/dg27hGS/888C/zx53zKYRkXat5oE/AWypI0t
     "]]}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxN13c8VX/8OPDKCGmQUcloyP4USSruy64Q2VtIUomMdO2ZkT2vyB5ZlZ19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      "]]}}, 
   {RGBColor[1, 0, 0], PointBox[CompressedData["
1:eJwBcQKO/SFib1JlAgAAACYAAAACAAAA5ej020qz5j9yfuVi4TDTPzq8I3S5
2uY/WMmxVtRk0T9Dm/jnMSLnPz3knnB5is8/mG4ngKBJ5z9J2KNhHcDLP6FN
/PMYkec/m/b2kS12xz/2ICuMh7jnP//jjLPzHsU/QFLLlKPT5z8Pk/5I8WrC
P4uDa52/7uc/uuEWjwr5vz9KMaAIHBvoP2I+jkvjC7w/v600a1ws6D+uS2zq
niW5Pwrf1HN4R+g/gsf17NtmtT/JjAnf1HPoP0aRrJ4THLI/iDo+SjGg6D+4
d6IUzkWtP7LCeIh70eg/vL5ON2XBpD9Rx0cpBhTpPyir5wSH5Jo/e0+CZ1BF
6T9gpIWXy3KLP85f9+Pkp+k/ALxB1UKmJb/YPsxXXe/pP1AKUWLpN4K/QJNe
85Zq6j8YLQf9CASTv9/Uc3hH6Oo/EDxjx2wOmb9ysUBSy5TrP8RzGIRX3pq/
xP77soUy7D8w1CYzyXOYvyyQ1DLl6Ow/KKPgRbwwlb806TVvqabtP/hj/aOf
W5C//LKFMqRV7j/A75QkcgSIvw9xLxqV5O4/wOKcwXG0fL/C9mG+6nrvPwBl
ovWunWa/70nwDKoo8D8QAxYblReAP1QQdXyUYvA/WJvMJM9hkD+IOj5KMaDw
P3D9WP/o55Y/7ADDuRva8D8QEySZKn+bP9Y2MmPCN/E/0MCynsh7nz+ELlfb
yIzxP9DAsp7Ie58/XnFwrfPX8T+gPDyhBb2bP/gkeAZVFPI/4NNA9w2qlj9h
PMS9aFTyP+h/UdEDtpE/1fWeBM+g8j9wCwMWG5WHP08AQZNe8/I/4CDoc6Fi
ej9XSD1o
     "]]}, {{}, {}, 
    {RGBColor[1, 0, 0], LineBox[CompressedData["
1:eJxNlnk0VH/8/ytbC5EUpfBBJSVLpYh5KltalDWFLEUlkRKiRQhl38cyiVBS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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{-0.17, 0.3},
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490606235931028*^9, 3.49063568434344*^9, 3.49063928360006*^9, 
   3.4906402956418667`*^9, {3.490640740993848*^9, 3.49064078226469*^9}, 
   3.490641123894382*^9, 3.490641168965413*^9, 3.490641458576531*^9, 
   3.490643012483081*^9, 3.490643428248577*^9, 3.490643488549136*^9, 
   3.490643639290344*^9, 3.490643798998518*^9, 3.490643931819478*^9, 
   3.490644025593341*^9, {3.490668247571972*^9, 3.49066828609971*^9}, {
   3.490668336631238*^9, 3.490668354889114*^9}, 3.4906684512098017`*^9, 
   3.490668590015751*^9, 3.49066913993747*^9, {3.4906728721459637`*^9, 
   3.4906729079331923`*^9}, 3.490787330325883*^9, 3.4907877123234663`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"fccCell", "[", 
       RowBox[{"0.8", "a0"}], "]"}], ",", "radius"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "200"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{".02", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906377837368526`*^9, {3.490637816141879*^9, 3.490637857116971*^9}, {
   3.490787373492622*^9, 3.490787386202241*^9}, {3.4907876905629997`*^9, 
   3.490787691108412*^9}, {3.490787732582678*^9, 3.4907877394865837`*^9}}],

Cell[BoxData["50.5010403695125`"], "Output",
 CellChangeTimes->{
  3.4906377906644993`*^9, 3.490637829437358*^9, 3.4906378604117527`*^9, 
   3.490672987703668*^9, {3.49078736780037*^9, 3.490787387281045*^9}, {
   3.490787721476853*^9, 3.490787740602357*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490787392857375*^9, 3.490787405318203*^9}}],

Cell[BoxData["16345"], "Output",
 CellChangeTimes->{3.490787410038938*^9, 3.490787743254793*^9}],

Cell[BoxData["16345"], "Output",
 CellChangeTimes->{3.490787410038938*^9, 3.4907877437118587`*^9}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.490787410038938*^9, 3.490787744758829*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_rho\>\""}], ",",
    "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_emb\>\""}], ",",
    "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490637894913205*^9, 
   3.490637904139831*^9}}],

Cell[BoxData["\<\"Ag/Ag_Ackland_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.490673006407028*^9, 3.490787431224451*^9, 
   3.490787749517667*^9}],

Cell[BoxData["\<\"Ag/Ag_Ackland_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.490673006407028*^9, 3.490787431224451*^9, 
   3.49078775014541*^9}],

Cell[BoxData["\<\"Ag/Ag_Ackland_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.490673006407028*^9, 3.490787431224451*^9, 
   3.490787751218787*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Ti Ackland              ",
 StyleBox["R",
  FontColor->GrayLevel[0.5]],
 StyleBox["ef. G.J.Ackland, Phil.Mag.A, 66, 917. (1992)  FITTED TO FCC",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.4906047822956533`*^9, 3.490604786358427*^9}, {3.4906351291163683`*^9, 
   3.49063520278023*^9}, {3.490638150821054*^9, 3.490638154338563*^9}, {
   3.4906721093121147`*^9, 3.490672158961433*^9}, {3.4906788895444736`*^9, 
   3.4906788933990602`*^9}, 3.490679057250547*^9, {3.490679712883355*^9, 
   3.4906797173634577`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Ti\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490635209649705*^9, 3.49063522189732*^9}, {
   3.490638163424374*^9, 3.490638164039442*^9}, {3.490672206790083*^9, 
   3.490672207424769*^9}, {3.4906788977028303`*^9, 3.4906788978290777`*^9}, {
   3.4906790675378532`*^9, 3.490679069705167*^9}, {3.490785836272027*^9, 
   3.4907858368673*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "cBya", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", 
      "\[Sigma]33", ",", "C11", ",", "C12", ",", "C13", ",", "C33", ",", 
      "C44", ",", "C66", ",", "a0fcc", ",", "Evfcc"}], "}"}], "=", "prop"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0fcc", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bk", "=", 
   RowBox[{
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"7", ";;", "8"}], "\[RightDoubleBracket]"}], "/", 
    SuperscriptBox["a0fcc", "3"]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rak", "=", 
   RowBox[{
    RowBox[{"a0fcc", " ", 
     RowBox[{"par", "\[LeftDoubleBracket]", 
      RowBox[{"9", ";;", "14"}], "\[RightDoubleBracket]"}]}], "+", 
    SuperscriptBox["10", 
     RowBox[{"-", "7"}]]}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Rbk", "=", 
   RowBox[{
    RowBox[{"a0fcc", " ", 
     RowBox[{"par", "\[LeftDoubleBracket]", 
      RowBox[{"15", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
    SuperscriptBox["10", 
     RowBox[{"-", "7"}]]}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"cell", "=", 
   RowBox[{"fccCell", "[", "a0fcc", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "\[Cross]", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}],
     ".", 
    RowBox[{
    "cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"radius", "=", 
   RowBox[{"2", "a0fcc"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "radius"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.490635231737218*^9, 3.490635391126584*^9}, {
   3.4906354780092163`*^9, 3.490635489452805*^9}, {3.4906356222918453`*^9, 
   3.490635627586684*^9}, {3.490638489035017*^9, 3.4906384928899307`*^9}, {
   3.490638546030054*^9, 3.4906385466340437`*^9}, {3.490641394651822*^9, 
   3.490641441997636*^9}, {3.490641938204934*^9, 3.4906419402096043`*^9}, {
   3.490668552436515*^9, 3.4906685738311443`*^9}, 3.490672310122747*^9, {
   3.490672578197186*^9, 3.490672582145076*^9}, {3.490672684070315*^9, 
   3.490672709446478*^9}, {3.4906728242020817`*^9, 3.4906728461397657`*^9}, 
   3.490679075225806*^9, {3.490679160301991*^9, 3.490679182940626*^9}, {
   3.490679513152046*^9, 3.490679514148221*^9}, {3.490679653291011*^9, 
   3.490679653575042*^9}, 3.490785876509953*^9, {3.490786215157013*^9, 
   3.490786237232274*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"{", 
   RowBox[{"Evfcc", ",", 
    RowBox[{"Evacancy", "[", 
     RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}]}]], "Input",
 CellChangeTimes->{{3.490786117936125*^9, 3.490786141316992*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.4`", ",", "1.3908069165875356`"}], "}"}]], "Output",
 CellChangeTimes->{3.4907861550001373`*^9, 3.490786257513608*^9}]
}, Open  ]],

Cell[TextData[StyleBox["Compare to hcp values",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 CellChangeTimes->{{3.490679841053218*^9, 3.490679850577664*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"hcpCell", "[", 
    RowBox[{"a0", ",", "cBya"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"basis", "=", "hcpCoordsRel"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[Cross]", 
      RowBox[{
      "cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ".", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
     "/", 
    RowBox[{"Length", "[", "basis", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"radius", "=", 
   RowBox[{"2", "a0"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "basis", ",", "1", ",", "radius"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, 3.490679782725648*^9, {3.4907859972485447`*^9, 
   3.49078599849647*^9}, 3.4907860448449*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
   3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
   3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
   3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
   3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
   3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
   3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
   3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
   3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}, {
   3.4906798257716837`*^9, 3.490679826202484*^9}, 3.4907860448455*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.55`", ",", "1.3401047946389735`"}], "}"}]], "Output",
 CellChangeTimes->{3.490786168240151*^9, 3.490786272394858*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.85`", ",", "4.8505377913915275`"}], "}"}]], "Output",
 CellChangeTimes->{3.490786168240151*^9, 3.490786273221409*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"43.559999999999995`", ",", "49.292559298756466`"}], 
  "}"}]], "Output",
 CellChangeTimes->{3.490786168240151*^9, 3.490786274507311*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"fccCell", "[", 
       RowBox[{"0.8", "a0fcc"}], "]"}], ",", "radius"}], "]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "500"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{".05", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906377837368526`*^9, {3.490637816141879*^9, 3.490637857116971*^9}, {
   3.4906797551100607`*^9, 3.490679755199333*^9}, {3.4907862973428993`*^9, 
   3.490786297873315*^9}, {3.490786341552487*^9, 3.4907863434523153`*^9}}],

Cell[BoxData["100.73737531097356`"], "Output",
 CellChangeTimes->{3.4906377906644993`*^9, 3.490637829437358*^9, 
  3.4906378604117527`*^9, 3.490672987703668*^9, 3.490679677771641*^9, 
  3.490679756000668*^9, 3.490785887949003*^9, 3.490786299168418*^9, 
  3.490786345011409*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.4907863061411333`*^9, 3.49078631870481*^9}}],

Cell[BoxData["11805"], "Output",
 CellChangeTimes->{{3.4907863287776957`*^9, 3.490786346778363*^9}}],

Cell[BoxData["11805"], "Output",
 CellChangeTimes->{{3.4907863287776957`*^9, 3.4907863467885933`*^9}}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{{3.4907863287776957`*^9, 3.490786346800014*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_rho\>\""}], ",",
    "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Ackland_emb\>\""}], ",",
    "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490637894913205*^9, 
   3.490637904139831*^9}}],

Cell[BoxData["\<\"Ti/Ti_Ackland_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.490673006407028*^9, 3.490679687414434*^9, 
   3.49067976241257*^9, 3.4907863494767923`*^9}],

Cell[BoxData["\<\"Ti/Ti_Ackland_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.490673006407028*^9, 3.490679687414434*^9, 
   3.49067976241257*^9, 3.49078635020774*^9}],

Cell[BoxData["\<\"Ti/Ti_Ackland_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490637905999457*^9, 3.490673006407028*^9, 3.490679687414434*^9, 
   3.49067976241257*^9, 3.490786351163681*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Ti Vitek                    ",
 StyleBox["Ref. Igarashi, Khantha, and Vitek,  Phil. Mag. B 63 (1991) 603",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.4906047822956533`*^9, 3.490604786358427*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Ti\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.4907853527858343`*^9, 3.490785353353208*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "cBya", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", 
      "\[Sigma]33", ",", "C11", ",", "C12", ",", "C13", ",", "C33", ",", 
      "C44", ",", "C66", ",", "a0fcc", ",", "Evfcc"}], "}"}], "=", "prop"}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rak", "=", 
   RowBox[{
    RowBox[{"a0", " ", 
     RowBox[{"par", "\[LeftDoubleBracket]", 
      RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}]}], "+", 
    SuperscriptBox["10", 
     RowBox[{"-", "7"}]]}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Ak", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"7", ";;", "12"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"13", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";", " ", 
   RowBox[{"(*", " ", 
    RowBox[{"to", " ", "avoid", " ", 
     RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Bk", "=", 
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"17", ";;", "20"}], "\[RightDoubleBracket]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"hcpCell", "[", 
    RowBox[{"a0", ",", "cBya"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"basis", "=", "hcpCoordsRel"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[Cross]", 
      RowBox[{
      "cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ".", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
     "/", 
    RowBox[{"Length", "[", "basis", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"radius", "=", 
   RowBox[{"2", "a0"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "basis", ",", "1", ",", "radius"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.4907853662002287`*^9, 3.490785373521936*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"6", ",", "6", ",", "Ak", ",", "Bk"}], "]"}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
  3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
  3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
  3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
  3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
  3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
  3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
  3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
  3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.55`", ",", "1.5499741037325552`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490785378370261*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.85`", ",", "4.850307086326168`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.4907853791831923`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"43.559999999999995`", ",", "43.56879118398102`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.4907853804445972`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.0000307888923712295`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490785381604168*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.00001245959806969524`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490785382653522*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0992`", ",", "1.1047766662437297`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.4907853835215816`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5424`", ",", "0.5423751669678087`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490785384802494*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.4263`", ",", "0.4267320979242512`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490785385292819*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1891`", ",", "1.1907388583608527`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490785386220056*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3171`", ",", "0.31754328321235253`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.4907853870376787`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.2812`", ",", "0.28120074963796027`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906062299243*^9, 3.490785388097619*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"fromVitek", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"str", "<>", "\"\</EffectivePotential_fromVitek.dat\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "fromVitek", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0.5", ",", "2"}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJw9kglIE2AUx5dEw3uKpCXVzJZNQdMWlqivJJM8YjkzNTVS16EdjDymiWmk
RU7NTJmhZulKTcqN1A7ly3Sz8kAnSwmtLY/NbR5zh84j2mTtg8fH4z34/v/f
/3NKuBlONcFgMB660t9ihbC9P14IJ2lvEu3EPyFyB2nOTS2EQJd7IakBY+Db
XCor6xABm08xd/MTwM6YT9btuX9g5Yr97ZL0Yag92DQyhZ8EnPuwqch2AAq6
sfxQySRYpl0eIGfwQFU4GhYkngK5A/dD8ZkOkEqqMEdbpyHHuU/kzWkGXH3l
UG/FDGAM51LnQKeyUAz67SpZAwohu3Wcp0igtv7ulmDX98j1b4Qwx34WzES2
1Tj3LrQi2k52EMyCJzXehjLDRfP+4yZmdVLg/aqLk/t9R7fagixHXsvga9hk
3jhpEFXSTkxcLJLDiN5O6xDa5mMXHcuYAw/N7rmEhWHEYN9JJJTPQ4R+3MJH
nGvZh96lL0D1pkE++kyfSE09vQgjdLx3EZaPkvMzUsy+LULGDwud4yFEMz/A
kJIUEBM125hfPoi2Xt2vYrMUQNJyjpd59KEMr7NKqukS9DzJDAyt7EUfq0MF
2dFLkKXrzvX0oFIudwyxl2Bm0THaCnUh+e+oUyxzJeReV2tHIxGiRzmPumQq
wevtA6LyoY5HsOKVybIS6GtOee17OEgQWVjDpKmM/Ji2Xc4bapXBfw3axJGi
hs24qh8hXdg4okxt4BuFmEdKsIiqMewXQ0AgUUdcA7abDzyDLKKNL//CMliQ
w7swBBZIyEk0T80ySAefPp9vbgRsQQtemLJi7P2TmfFxshWwnnqpOHajCYZ7
K3j7YrXGeRKh3F3er/2vFxJ5Nmn3D68a8mSBlU7trpZVEPvof2g96NPacFyD
LwQfp9gXddDQFqPqYawZ9VG6VdIY7LrBDxOm8crwvfR1A5/H8A88Zogz
     "]]}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF13k0lN//APAhISn7UsgSEkpKkpi3EC2UJUuSPVvKLlmyVKJSki1knUmW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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{-0.5, 1},
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490606235931028*^9, 3.4907853944163733`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"dr", "=", 
   RowBox[{
    RowBox[{"5", " ", 
     SuperscriptBox["10", 
      RowBox[{"-", "4"}]]}], "//", "N"}]}], ";", " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "2000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{".2", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
   3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
  3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
  3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
  3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
  3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, {
  3.4907854852274714`*^9, 3.490785509474689*^9}}],

Cell[BoxData["1605.273183730813`"], "Output",
 CellChangeTimes->{{3.490785494401976*^9, 3.490785511037621*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.4907855142222958`*^9, 3.490785532898683*^9}}],

Cell[BoxData["11805"], "Output",
 CellChangeTimes->{3.490785534487664*^9}],

Cell[BoxData["11805"], "Output",
 CellChangeTimes->{3.490785535304152*^9}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.490785536173218*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_pair\>\""}], ",", 
   "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_rho\>\""}], ",", 
   "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_emb\>\""}], ",", 
   "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}}],

Cell[BoxData["\<\"Ti/Ti_Vitek_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.4907855429535923`*^9}],

Cell[BoxData["\<\"Ti/Ti_Vitek_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490785543712163*^9}],

Cell[BoxData["\<\"Ti/Ti_Vitek_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.49060624071303*^9, 
   3.490785545571575*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["own fitting",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905972003333693`*^9, 3.4905972025222683`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EcohAknBkn", "=", 
   RowBox[{"Ecohesion", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EvacAknBkn", "=", 
   RowBox[{"Evacancy", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp11AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp33AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp11AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp12AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp13AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp33AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp44AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"4", ",", "4", ",", "Akn", ",", "Bkn"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490531084065048*^9, 3.490531131962385*^9}, {
  3.490531285559321*^9, 3.4905313367468033`*^9}, {3.490531589938838*^9, 
  3.490531593206221*^9}, {3.4905316243781567`*^9, 3.490531631619998*^9}, {
  3.490535272081443*^9, 3.4905352888810997`*^9}, {3.4905841906861362`*^9, 
  3.490584233669372*^9}, {3.490596146553184*^9, 3.490596194876034*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Ecoh", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "Ec"}], ",", 
       RowBox[{
        RowBox[{"Evac", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "Ev"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp11", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "\[Sigma]11"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp33", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "\[Sigma]33"}], ",", 
       RowBox[{
        RowBox[{"Chcp11", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C11"}], ",", 
       RowBox[{
        RowBox[{"Chcp12", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C12"}], ",", 
       RowBox[{
        RowBox[{"Chcp13", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C13"}], ",", 
       RowBox[{
        RowBox[{"Chcp33", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C33"}], ",", 
       RowBox[{
        RowBox[{"Chcp44", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C44"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp", "[", 
         RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}], "\[Equal]", 
        "0"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], ",", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{".1", "Ak"}], ",", 
          RowBox[{".1", "Bk"}]}], "]"}]}], "}"}], "\[Transpose]"}]}], "]"}], "//",
    "Chop"}]}]], "Input",
 CellChangeTimes->{{3.490532037678464*^9, 3.4905321548304377`*^9}, {
  3.490532209508809*^9, 3.49053221787148*^9}, {3.490596350391958*^9, 
  3.4905963514215803`*^9}, {3.4905966173506203`*^9, 3.490596622417412*^9}, {
  3.490596720824193*^9, 3.490596722381658*^9}, {3.490596978878623*^9, 
  3.4905970354414263`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"AA", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"-", "0.41204893539732923`"}]}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "2", "]"}], "\[Rule]", "1.705116335469353`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "3", "]"}], "\[Rule]", 
    RowBox[{"-", "0.019472953162508796`"}]}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "4", "]"}], "\[Rule]", 
    RowBox[{"-", "4.48366966704566`"}]}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "5", "]"}], "\[Rule]", "5.7624489590676`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "6", "]"}], "\[Rule]", 
    RowBox[{"-", "15.753492142287227`"}]}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"-", "3.651123105346925`"}]}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "2", "]"}], "\[Rule]", "9.15273579278849`"}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "3", "]"}], "\[Rule]", 
    RowBox[{"-", "10.099852076324707`"}]}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "4", "]"}], "\[Rule]", "60.76879187`"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.490532227468444*^9, {3.490532489718526*^9, 3.490532516732068*^9}, {
   3.490532812419867*^9, 3.490532850330225*^9}, {3.490596269567227*^9, 
   3.4905962940277557`*^9}, 3.490596624499443*^9, 3.49059672327493*^9, {
   3.4905969793860607`*^9, 3.4905970029612722`*^9}, 3.4905970358871307`*^9, 
   3.4905981350626507`*^9, 3.4906062501797647`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"original", " ", "Ak", " ", "Bk"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Ak", "\[IndentingNewLine]", "Bk"}]}]], "Input",
 CellChangeTimes->{{3.4905966282017813`*^9, 3.490596629747342*^9}, {
  3.490596758734058*^9, 3.490596759490575*^9}, {3.4905971737634087`*^9, 
  3.490597182576355*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0611882`", ",", "0.0918677`", ",", 
   RowBox[{"-", "0.1748514`"}], ",", 
   RowBox[{"-", "0.931018`"}], ",", "0.742162`", ",", "91.3710199`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.490606250316444*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0652343`", ",", "1.2469778`", ",", 
   RowBox[{"-", "6.2825442`"}], ",", "607.6879187`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.490606250320397*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{
      RowBox[{"Evacancy", "[", 
       RowBox[{"Akn", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{
      RowBox[{"Ecohesion", "[", 
       RowBox[{"Akn", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{
      RowBox[{"\[Rho]", "[", "Bkn", "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"4", ",", "4", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"6", ",", "6", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490596804858758*^9, 3.4905968319531183`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.55`", ",", "1.5500000000000114`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606250820196*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"4.85`", ",", "4.850000000000016`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.4906062508842382`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"43.559999999999995`", ",", "43.560000000000116`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606250970574*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "1.0052439079527995`*^-15"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606251026716*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "6.534085401693196`*^-16"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606251089982*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0992`", ",", "1.0992000000000013`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.49060625132014*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5424`", ",", "0.5424000000000005`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606251734931*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.4263`", ",", "0.4263000000000003`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606252184037*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1891`", ",", "1.1890999999999965`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606252633321*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3171`", ",", "0.31709999999999966`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606253065791*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.2812`", ",", "0.27839999999999865`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606253512027*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], " ", ",", "Akn"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"D\[Rho]", "[", "Bkn", "]"}], 
        RowBox[{"\[CapitalPhi]", "[", 
         RowBox[{
          RowBox[{"a0", " ", "r"}], ",", "Bkn"}], "]"}]}]}], "/.", "sol"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0.5", ",", "2"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.490596881267724*^9, 3.490596901214881*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF13k0lN//APAhISn7UsgSEkpKkpi3EC2UJUuSPVvKLlmyVKJSki1knUmW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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJxFmnk41O/3/yXZkiXSjkQJoZK8pTlCkpAlkewJSagQEUJI9n0ZO5NSIrvw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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{{0.5, 2}, {-0.5, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.490596904365493*^9, {3.490597014762521*^9, 3.4905970436979303`*^9}, 
   3.490598143113193*^9, 3.490606255918695*^9}]
}, Open  ]]
}, Closed]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Mg Vitek                  ",
 StyleBox["Ref. Igarashi, Khantha, and Vitek,  Phil. Mag. B 63 (1991) 603",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.4906047822956533`*^9, 3.490604786358427*^9}, {3.490605962046369*^9, 
   3.490605966018268*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Mg\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490605970893587*^9, 3.490605971041005*^9}, {
   3.490785047660318*^9, 3.4907850482041597`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "cBya", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", 
      "\[Sigma]33", ",", "C11", ",", "C12", ",", "C13", ",", "C33", ",", 
      "C44", ",", "C66"}], "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rak", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"7", ";;", "12"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"13", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bk", "=", 
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"17", ";;", "20"}], "\[RightDoubleBracket]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"hcpCell", "[", 
    RowBox[{"a0", ",", "cBya"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"basis", "=", "hcpCoordsRel"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[Cross]", 
      RowBox[{
      "cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ".", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
     "/", 
    RowBox[{"Length", "[", "basis", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"radius", "=", 
    RowBox[{"2", "a0"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "basis", ",", "1", ",", "radius"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.490702417858289*^9, 3.4907024640564117`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"6", ",", "6", ",", "Ak", ",", "Bk"}], "]"}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
  3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
  3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
  3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
  3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
  3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
  3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
  3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
  3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.8`", ",", "0.8100493908612115`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.490785053445895*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.51`", ",", "1.5440837833887342`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.4907850543043337`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.0164`", ",", "2.155225957652996`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.490785055612419*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "2.9712782774059097`*^-6"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.4907850566718397`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "1.6248397140103736`*^-6"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.490785057316723*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3962`", ",", "0.3965791676614097`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.490785058070619*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1619`", ",", "0.161991275155392`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.490785058653658*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1355`", ",", "0.1355925790550782`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.4907850603071747`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.4148`", ",", "0.4151596364469475`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.4907850618814983`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.115`", ",", "0.11509400397918054`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.490785062378099*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1172`", ",", "0.11729394625301146`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.4906061987331543`*^9, 
   3.490675592315692*^9, 3.4907023843696833`*^9, {3.49070243106992*^9, 
   3.490702465083256*^9}, 3.49078506461264*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"fromVitek", "=", 
   RowBox[{"Import", "[", 
    RowBox[{"str", "<>", "\"\</EffectivePotential_fromVitek.dat\>\""}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "fromVitek", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0.5", ",", "2"}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}}],

Cell[BoxData[
 GraphicsBox[{
   {Hue[0.67, 0.6, 0.6], PointBox[CompressedData["
1:eJxTTMoPSmViYGBQA2IQnW8cce0xyzP7favDctxnvrcXmPzDtCXlmf0STp7z
Tclv7HX6ojycXz+zF7h83NLj1gv7isg3WkZOz+0vuYrHllx8al+3nuvekWPP
7WUe355UfvWRvZtYXPEllxf2j677LuTkuW9fWqwfc+n5C3uzQ0X+yjrX7dVN
7SdtTn5pb/C7cobduYv2LgYLlxS9eml/jUdAJFL/tP2W/YImjytf2RefZXCc
+PWQ/SOZx0D42t782HbV96u22q9wSNJk3fravrdaKnHn8oX2Dtdb3z1KemP/
atP89pePe/Zf0boKhG/tzdk9pRd5rd1/eXuZ89K/b+1rQMoFt+2fIFS5leXJ
O/tJWxRXXfHcs79h+tF1Ssof7D+vEr0d+Gz//thu8ZJd/z/YN0R/Whe1ce/+
BzXfb2av/mifAtQ9rXrXfrVDD1Y1m32Cm3dMsZFLZdon+2+FfJPMXLbutzWf
tTr74yf7ZqXXqfb8m/dv9gHBz/Yh6oVAH23c375c6NqZfZ/tD66f7SQssW4/
v/xs31CzL/YRGUyHNz9YsT/PZw5b68ovUPOX7V+oL8YYI/HVvuLk7qyjZUv2
23Dy+auu+WqvrpLboVW6aL/n2f4nbyK+2f9jdr12um7e/ifL2o22vflm36lV
KnSdZ8F+hkUvXUqLv9tngM2fsX929cNJduw/4PyD6tUCcnN+2M8Fh+fE/UEB
1p+PKf6Eh+f0qSpH7q35ac8kGPpKZV3nfk7VqcH+Nr/s94LVN+43b0qz8b//
y15rM0h9zf72ChD8DZcHAJ2JORw=
     "]]}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF13k01N//OHAkW4hsJVu2ZC0iWXoikexrKLRIklBok0JoJXnbkmRrESlL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      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{-0.5, 1},
  PlotRangeClipping->True]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490605988915002*^9, 3.490606202804105*^9, 3.4906756160006933`*^9, 
   3.490702472011942*^9, 3.490785090841647*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"dr", "=", 
   RowBox[{
    RowBox[{"5", " ", 
     SuperscriptBox["10", 
      RowBox[{"-", "4"}]]}], "//", "N"}]}], ";", " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "1000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{".1", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
   3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
  3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
  3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
  3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
  3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, {
  3.490785140997734*^9, 3.490785158770198*^9}}],

Cell[BoxData["239.02922440289538`"], "Output",
 CellChangeTimes->{{3.490785151013226*^9, 3.490785160608786*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.4907851668778353`*^9, 3.490785182245225*^9}}],

Cell[BoxData["12837"], "Output",
 CellChangeTimes->{3.490785184381814*^9}],

Cell[BoxData["12837"], "Output",
 CellChangeTimes->{3.490785185111458*^9}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.490785186010047*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_pair\>\""}], ",", 
   "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_rho\>\""}], ",", 
   "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_emb\>\""}], ",", 
   "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}}],

Cell[BoxData["\<\"Mg/Mg_Vitek_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.490605993769765*^9, 
   3.4907024755023727`*^9, 3.490785190299358*^9}],

Cell[BoxData["\<\"Mg/Mg_Vitek_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.490605993769765*^9, 
   3.4907024755023727`*^9, 3.490785191043126*^9}],

Cell[BoxData["\<\"Mg/Mg_Vitek_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.490605993769765*^9, 
   3.4907024755023727`*^9, 3.4907851918639183`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["own fitting",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905972003333693`*^9, 3.4905972025222683`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EcohAknBkn", "=", 
   RowBox[{"Ecohesion", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EvacAknBkn", "=", 
   RowBox[{"Evacancy", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp11AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp33AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp11AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp12AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp13AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp33AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp44AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"4", ",", "4", ",", "Akn", ",", "Bkn"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490531084065048*^9, 3.490531131962385*^9}, {
  3.490531285559321*^9, 3.4905313367468033`*^9}, {3.490531589938838*^9, 
  3.490531593206221*^9}, {3.4905316243781567`*^9, 3.490531631619998*^9}, {
  3.490535272081443*^9, 3.4905352888810997`*^9}, {3.4905841906861362`*^9, 
  3.490584233669372*^9}, {3.490596146553184*^9, 3.490596194876034*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Ecoh", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "Ec"}], ",", 
       RowBox[{
        RowBox[{"Evac", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "Ev"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp11", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "\[Sigma]11"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp33", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "\[Sigma]33"}], ",", 
       RowBox[{
        RowBox[{"Chcp11", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C11"}], ",", 
       RowBox[{
        RowBox[{"Chcp12", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C12"}], ",", 
       RowBox[{
        RowBox[{"Chcp13", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C13"}], ",", 
       RowBox[{
        RowBox[{"Chcp33", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C33"}], ",", 
       RowBox[{
        RowBox[{"Chcp44", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C44"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp", "[", 
         RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}], "\[Equal]", 
        "0"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], ",", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{".1", "Ak"}], ",", 
          RowBox[{".1", "Bk"}]}], "]"}]}], "}"}], "\[Transpose]"}]}], "]"}], "//",
    "Chop"}]}]], "Input",
 CellChangeTimes->{{3.490532037678464*^9, 3.4905321548304377`*^9}, {
  3.490532209508809*^9, 3.49053221787148*^9}, {3.490596350391958*^9, 
  3.4905963514215803`*^9}, {3.4905966173506203`*^9, 3.490596622417412*^9}, {
  3.490596720824193*^9, 3.490596722381658*^9}, {3.490596978878623*^9, 
  3.4905970354414263`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"AA", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"-", "3.1506454549219205`"}]}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "2", "]"}], "\[Rule]", "2.1245397568796345`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "3", "]"}], "\[Rule]", "6.382528943622771`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "4", "]"}], "\[Rule]", "0.6447334934224187`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "5", "]"}], "\[Rule]", 
    RowBox[{"-", "33.712385253238104`"}]}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "6", "]"}], "\[Rule]", "177.12823522896332`"}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"-", "4.6431540208068105`"}]}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "2", "]"}], "\[Rule]", "12.912565903731402`"}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "3", "]"}], "\[Rule]", 
    RowBox[{"-", "13.982151027242734`"}]}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "4", "]"}], "\[Rule]", "6.263155940000001`"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.490532227468444*^9, {3.490532489718526*^9, 3.490532516732068*^9}, {
   3.490532812419867*^9, 3.490532850330225*^9}, {3.490596269567227*^9, 
   3.4905962940277557`*^9}, 3.490596624499443*^9, 3.49059672327493*^9, {
   3.4905969793860607`*^9, 3.4905970029612722`*^9}, 3.4905970358871307`*^9, 
   3.4905981350626507`*^9, 3.49060620794221*^9, 3.4907024845504417`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"original", " ", "Ak", " ", "Bk"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Ak", "\[IndentingNewLine]", "Bk"}]}]], "Input",
 CellChangeTimes->{{3.4905966282017813`*^9, 3.490596629747342*^9}, {
  3.490596758734058*^9, 3.490596759490575*^9}, {3.4905971737634087`*^9, 
  3.490597182576355*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0319086`", ",", 
   RowBox[{"-", "0.0297906`"}], ",", "0.0254509`", ",", 
   RowBox[{"-", "0.2764095`"}], ",", "0.2215581`", ",", "43.168396`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.4906062092523003`*^9, 3.490702485731196*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0623314`", ",", 
   RowBox[{"-", "0.0656703`"}], ",", 
   RowBox[{"-", "0.3659664`"}], ",", "62.6315594`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.4906062092523003`*^9, 3.490702485738327*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{
      RowBox[{"Evacancy", "[", 
       RowBox[{"Akn", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{
      RowBox[{"Ecohesion", "[", 
       RowBox[{"Akn", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{
      RowBox[{"\[Rho]", "[", "Bkn", "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"4", ",", "4", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"6", ",", "6", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490596804858758*^9, 3.4905968319531183`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.8`", ",", "0.7999999999999672`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702486561872*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.51`", ",", "1.509999999999963`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702486598312*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.0164`", ",", "2.016399999999976`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702486658381*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "4.576989611119474`*^-15"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702486717826*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "1.4428505872213791`*^-15"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702486778699*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3962`", ",", "0.3962000000001871`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.4907024870423613`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1619`", ",", "0.16190000000007224`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702487423141*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1355`", ",", "0.13550000000002105`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.4907024878038692`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.4148`", ",", "0.4148000000000627`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702488205761*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.115`", ",", "0.11500000000001513`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702488625688*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1172`", ",", "0.11715000000005318`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490702488997118*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], " ", ",", "Akn"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"D\[Rho]", "[", "Bkn", "]"}], 
        RowBox[{"\[CapitalPhi]", "[", 
         RowBox[{
          RowBox[{"a0", " ", "r"}], ",", "Bkn"}], "]"}]}]}], "/.", "sol"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0.5", ",", "2"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.490596881267724*^9, 3.490596901214881*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF2Xk01N8bOHAkW4hsZc+WspUtWXqQaCFbhCwtkiQU2qQQ2pB8bElCiGix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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwtlHlMk2ccx1skMJgMFgJzcYxTgqNYjsCYkv64lE4ZR4FMLiFcY5SsbExB
jRwKoVwOIUGKApUBysrRARNk0rcIlFYZlFIolAbLJZf0fWEbIoLu2bI3efLm
m+/39/n+8vzxWMaxGIlaJBLpNDr//gsz01o/6dEA6b+PgKidYcuaXg14WvZd
T27D4dH+dfv2pxqIbXH2Ygo2IUiw1do5irQji2FG34TV7FjHHpkGpNzdHl35
SzA9RHPtVyIef4aevL0B6XqvaRPrGiD07cTF9HXQf/ZNv0KjAWGl+bTL4hrU
l0z5qLY1EPSH88BM9hpIDbvoy3tovrpik4ytgoMpi/FKH4c0WvnKTsgKrFgt
Jx61x4GgWRh/IFuCrKWQVXMqDrFXcJ5t4RKYNj1JsXHBwXE6w17stQS+x7ks
h1M4qMPv3GN3L8I9auRlOIfy2rkC564FcN+SvPEJxIG7nDo/dGkBpB3uWfQQ
HCwa1Wn3Ty7AW1fTG8GRSJv5VbmL5iHSY7wknonm8+OjRRtq2D4Aw2QW4q/O
u5N61FCEtd1KTcdBuP5QJyBfDT3eJZUXryJt6u/xnrUaTL704xYUo/nUTVGo
fA7Gwvo6eTzkW06wc7xU0JVj9SKlHYccurietzcL1byCI591ov5n6uMvu2Yh
gcy49qAX9RlkGWVRZmGv5cWZRgnixWe6cWyVYKttpKxdwYF0ebHG32MaDlMv
Hr6wgXRYABvI07AVrqSZ4YhvvGxdJFLA4/aGn+/sID+o6t1OsAKaW++6jWgR
4Cmw8VxMmQIIdyJJPiQgtti/trFaDh2aeM4DYwLU/r9x8mLkYJNX6cw2IUDI
YhQdWMtBv/1Ngt/HSGtRVKW8CZjUFkmGLBDvFPMLVacM6NW7cY1WBFgc5E/S
fpRBL9V+P8+GgJzEGbbKRQbciLITvnYEcL0pIg5/HJj8iIonVALKjt0qH6uV
wtzpUkq9E+L9lf1c8LUUgmaxoVwXAoKaeYlFhlJw0zm26/k54ikyog1ejQI5
Co/CaKjPqAbeFozAbd0828dfIX+mm6A6DEPErmfIYCDiOYkTlEki+HTtIHsk
GO1fd6WuqmYIGp5mzKjC0D5s/aZ4rUHglzJLDqJRPry7obdZCGLjkG3adyhf
xan1WemAYm0jc780xD96pLuC/CsE/D1yLvAHpMnkm2cd2kA+daYx5hIBpE7H
n5LimmCec/J8ThbSoc4OXvRC2DO3EvTfRPnilEfv7vOwPqPn65Iy5O9e2zLR
42M55LsfycqRtupukHp3YDqLJt8vVKL+s1tMg8GHmHGTns2hOrSf/YD17X0M
o1C2Cn3bCUjrS3IV1kqwC+7CsOExAvjz2a/lJxSYODpT2TKO8iXBlH2pAnO+
4RhTPoHuk8E4v5g+jemOcpOjFQQQ7ydK1n6fwfjxuVf/nEN5u5QAbqgKG0id
/OXbNeL/90ON/QNWSTbu
     "]], LineBox[CompressedData["
1:eJxFmHk4FHzU/kc91lQo+05aUCmhlDl2SgtSJFtIPZQlZC9kC2VfEh6kVJak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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{{0.5, 2}, {-0.5, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.490596904365493*^9, {3.490597014762521*^9, 3.4905970436979303`*^9}, 
   3.490598143113193*^9, 3.490606217827778*^9, 3.490702492250169*^9}]
}, Open  ]]
}, Closed]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Hf Vitek                   ",
 StyleBox["Ref. Igarashi, Khantha, and Vitek,  Phil. Mag. B 63 (1991) 603",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.4906047822956533`*^9, 3.490604786358427*^9}, {3.490605962046369*^9, 
   3.490605966018268*^9}, {3.4906060196857233`*^9, 3.4906060199024897`*^9}, 
   3.490635139274091*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Hf\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490605970893587*^9, 3.490605971041005*^9}, {
   3.490606024737935*^9, 3.490606024881797*^9}, {3.490768764662431*^9, 
   3.490768765630795*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "cBya", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", 
      "\[Sigma]33", ",", "C11", ",", "C12", ",", "C13", ",", "C33", ",", 
      "C44", ",", "C66"}], "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rak", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"7", ";;", "12"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"13", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bk", "=", 
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"17", ";;", "20"}], "\[RightDoubleBracket]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"hcpCell", "[", 
    RowBox[{"a0", ",", "cBya"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"basis", "=", "hcpCoordsRel"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[Cross]", 
      RowBox[{
      "cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ".", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
     "/", 
    RowBox[{"Length", "[", "basis", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"radius", "=", 
    RowBox[{"2", "a0"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "basis", ",", "1", ",", "radius"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"6", ",", "6", ",", "Ak", ",", "Bk"}], "]"}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
  3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
  3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
  3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
  3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
  3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
  3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
  3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
  3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.15`", ",", "2.150250713620168`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.490768776450486*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.44`", ",", "6.440006738671723`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.4907687777523403`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"73.61640000000003`", ",", "73.60802701786452`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.4907687795651293`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "3.1552157535073145`*^-6"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.490768781334791*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "0.0003483628702482182`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.490768782386718*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1866`", ",", "1.1679247864090407`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.490768783430613*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.465`", ",", "0.4585257624424214`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.49076878526359*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.4089`", ",", "0.40728747385144837`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.4907687861902723`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.2759`", ",", "1.2781514548954056`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.490768787764297*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3745`", ",", "0.37513580878318153`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.4907687894068947`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.3608`", ",", "0.3546995119833101`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, 3.4906059785394278`*^9, 3.490606143370027*^9, 
   3.490611294144555*^9, 3.490768790537031*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"V", "[", 
     RowBox[{
      RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
    RowBox[{"2", " ", 
     RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
     RowBox[{"\[CapitalPhi]", "[", 
      RowBox[{
       RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0.5", ",", "2"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}, {
  3.4906061546376677`*^9, 3.490606160588088*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwdl3k4lO3bx5E9Ilsia0goQpE0p6VkzVJKspaQhEQpKWSPyFKyzUg7RUiS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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{{0.5, 2}, {-0.5, 1}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490605988915002*^9, 3.490606161590955*^9, 3.490611303765588*^9, 
   3.490768797289884*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "3000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{".3", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
   3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
  3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
  3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
  3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
  3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, {
  3.490611307955472*^9, 3.490611316926196*^9}, {3.490784591831321*^9, 
  3.490784604205674*^9}, {3.490784635364869*^9, 3.490784651607841*^9}}],

Cell[BoxData["2074.690787587355`"], "Output",
 CellChangeTimes->{{3.49061131042013*^9, 3.49061132164231*^9}, 
   3.4907688038851633`*^9, 3.490784605531744*^9, {3.490784638233601*^9, 
   3.490784653291576*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490784610430657*^9, 3.490784625313325*^9}}],

Cell[BoxData["12777"], "Output",
 CellChangeTimes->{{3.490784626806922*^9, 3.49078465503307*^9}}],

Cell[BoxData["12777"], "Output",
 CellChangeTimes->{{3.490784626806922*^9, 3.490784655043687*^9}}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{{3.490784626806922*^9, 3.4907846550558987`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_pair\>\""}], ",", 
   "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_rho\>\""}], ",", 
   "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_emb\>\""}], ",", 
   "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}}],

Cell[BoxData["\<\"Hf/Hf_Vitek_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.490605993769765*^9, 
   3.4906061655716257`*^9, 3.490611326392984*^9, 3.490784659198411*^9}],

Cell[BoxData["\<\"Hf/Hf_Vitek_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.490605993769765*^9, 
   3.4906061655716257`*^9, 3.490611326392984*^9, 3.490784659982369*^9}],

Cell[BoxData["\<\"Hf/Hf_Vitek_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, 3.490605993769765*^9, 
   3.4906061655716257`*^9, 3.490611326392984*^9, 3.49078466105656*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Ru Vitek_highT     ",
 StyleBox["Ref. Igarashi, Khantha, and Vitek,  Phil. Mag. B 63 (1991) 603",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.49060166054762*^9, 3.49060166624483*^9}, {3.49060474609651*^9, 
   3.490604748431958*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Ru\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
      "\"\<_Vitek_highT.dat\>\""}], "]"}], "//", "Flatten"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490601674157384*^9, 3.490601674284174*^9}, {
   3.490601847355219*^9, 3.4906018748184958`*^9}, {3.49069175520931*^9, 
   3.49069175621646*^9}, 3.490704301201807*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "cBya", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", 
      "\[Sigma]33", ",", "C11", ",", "C12", ",", "C13", ",", "C33", ",", 
      "C44", ",", "C66"}], "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rak", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"1", ";;", "6"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"7", ";;", "12"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"13", ";;", "16"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Bk", "=", 
    RowBox[{"par", "\[LeftDoubleBracket]", 
     RowBox[{"17", ";;", "20"}], "\[RightDoubleBracket]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"\[Rho]\[Rho]0", "/.", 
    RowBox[{
     RowBox[{"Solve", "[", 
      RowBox[{
       RowBox[{"Ev", "\[Equal]", 
        RowBox[{"Ec", "-", 
         RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], "+", 
         RowBox[{
          RowBox[{"D", "[", 
           RowBox[{
            RowBox[{"f", "[", "\[Rho]\[Rho]0", "]"}], ",", "\[Rho]\[Rho]0"}], 
           "]"}], "\[Rho]\[Rho]0"}]}]}], ",", "\[Rho]\[Rho]0"}], "]"}], 
     "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"hcpCell", "[", 
    RowBox[{"a0", ",", "cBya"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"basis", "=", "hcpCoordsRel"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[Cross]", 
      RowBox[{
      "cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ".", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
     "/", 
    RowBox[{"Length", "[", "basis", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"radius", "=", 
    RowBox[{"2", "a0"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "basis", ",", "1", ",", "radius"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.4906960650886908`*^9, 3.490696137721244*^9}, {
   3.490696176601822*^9, 3.490696188082768*^9}, {3.490696702737916*^9, 
   3.490696737302623*^9}, {3.490696776993742*^9, 3.4906968023344097`*^9}, {
   3.4906968632160797`*^9, 3.490696961759561*^9}, {3.4907020963634367`*^9, 
   3.4907021424345407`*^9}, {3.490702172666451*^9, 3.490702173293314*^9}, {
   3.4907022179275303`*^9, 3.490702311290826*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"6", ",", "6", ",", "Ak", ",", "Bk"}], "]"}]}], 
    "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
  3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
  3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
  3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
  3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
  3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
  3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
  3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
  3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.25`", ",", "2.247552584192406`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.490704303448182*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.74`", ",", "6.852289615683601`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.4907043035040283`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"80.64040000000001`", ",", "84.81441251674535`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.4907043035845127`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.0036629427914498082`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.490704303670039*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "0.02390654398742313`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.490704303749873*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.597`", ",", "3.518232846563278`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.49070430380453*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1684`", ",", "1.1814591967661632`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.490704304116547*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0442`", ",", "1.645655843221844`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.490704304453104*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.9977`", ",", "6.22906666115855`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.4907043048222437`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1803`", ",", "1.7748970890670543`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.490704305192484*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.2143`", ",", "1.1683868248985543`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490603402672634*^9, {3.490605902503797*^9, 3.4906059235663033`*^9}, 
   3.490609760902144*^9, 3.490611238916276*^9, {3.49068083729239*^9, 
   3.490680860607422*^9}, 3.490691761445963*^9, {3.490696047459985*^9, 
   3.490696138630612*^9}, {3.4906961774754143`*^9, 3.4906961887563066`*^9}, {
   3.490696705145144*^9, 3.490696738386093*^9}, {3.490696778892235*^9, 
   3.490696803568328*^9}, {3.490696871169024*^9, 3.490696962963937*^9}, {
   3.4907021183085814`*^9, 3.4907021431906233`*^9}, 3.490702174398031*^9, {
   3.490702220550264*^9, 3.490702328075542*^9}, 3.490704305509184*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0.5", ",", "2"}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}, {
  3.4906020440406437`*^9, 3.490602049639514*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3k8lN8Xx5Ei+06RLCnfiJJkyxmUbCWyhRAqSahQSCFKthRKkq3Nln1L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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{-0.5, 1},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490602051496909*^9, 3.490603415448492*^9, 3.490605932534903*^9, 
   3.490609763896706*^9, 3.4906808762354307`*^9, 3.490691770017817*^9, 
   3.4906968284978037`*^9, 3.4906970173044167`*^9, 3.490702331157653*^9, 
   3.490704307810997*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "10000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{
    SuperscriptBox["10", "0"], "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906073941848*^9, {3.490607457034018*^9, 3.490607457133724*^9}, {
   3.4906090472738543`*^9, 3.490609057888105*^9}, {3.490609540881029*^9, 
   3.490609685293902*^9}}],

Cell[BoxData["8156.031132195406`"], "Output",
 CellChangeTimes->{3.490609628027426*^9, 3.4906097644370317`*^9, 
  3.4906917720661297`*^9, 3.490697018927493*^9, 3.490702331470207*^9, 
  3.490704308775032*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490704311006287*^9, 3.49070431237512*^9}}],

Cell[BoxData["11005"], "Output",
 CellChangeTimes->{3.4907043137633877`*^9}],

Cell[BoxData["11005"], "Output",
 CellChangeTimes->{3.490704313861827*^9}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.4907043139645777`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_highT_pair\>\""}],
    ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_highT_rho\>\""}], 
   ",", "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_highT_emb\>\""}], 
   ",", "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490602297888136*^9, 
   3.490602307001584*^9}, {3.490602455546969*^9, 3.490602461254315*^9}}],

Cell[BoxData["\<\"Ru/Ru_Vitek_highT_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.4906970213900146`*^9, 3.490702333196707*^9, 
   3.490704315411058*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_highT_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.4906970213900146`*^9, 3.490702333196707*^9, 
   3.490704315840103*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_highT_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.4906970213900146`*^9, 3.490702333196707*^9, 
   3.490704316218018*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["own fitting",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905972003333693`*^9, 3.4905972025222683`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EcohAknBkn", "=", 
   RowBox[{"Ecohesion", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EvacAknBkn", "=", 
   RowBox[{"Evacancy", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp11AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp33AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp11AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp12AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp13AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp33AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp44AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"4", ",", "4", ",", "Akn", ",", "Bkn"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490531084065048*^9, 3.490531131962385*^9}, {
  3.490531285559321*^9, 3.4905313367468033`*^9}, {3.490531589938838*^9, 
  3.490531593206221*^9}, {3.4905316243781567`*^9, 3.490531631619998*^9}, {
  3.490535272081443*^9, 3.4905352888810997`*^9}, {3.4905841906861362`*^9, 
  3.490584233669372*^9}, {3.490596146553184*^9, 3.490596194876034*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{
   RowBox[{"FindRoot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"Ecoh", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "Ec"}], ",", 
       RowBox[{
        RowBox[{"Evac", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "Ev"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp11", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "\[Sigma]11"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp33", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "\[Sigma]33"}], ",", 
       RowBox[{
        RowBox[{"Chcp11", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C11"}], ",", 
       RowBox[{
        RowBox[{"Chcp12", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C12"}], ",", 
       RowBox[{
        RowBox[{"Chcp13", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C13"}], ",", 
       RowBox[{
        RowBox[{"Chcp33", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C33"}], ",", 
       RowBox[{
        RowBox[{"Chcp44", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], "\[Equal]", "C44"}], ",", 
       RowBox[{
        RowBox[{"\[Sigma]hcp", "[", 
         RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}], "\[Equal]", 
        "0"}]}], "}"}], ",", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Join", "[", 
         RowBox[{"Akn", ",", "Bkn"}], "]"}], ",", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"2", "Ak"}], ",", 
          RowBox[{".89", "Bk"}]}], "]"}]}], "}"}], "\[Transpose]"}]}], "]"}], 
   "//", "Chop"}]}]], "Input",
 CellChangeTimes->{{3.490532037678464*^9, 3.4905321548304377`*^9}, {
  3.490532209508809*^9, 3.49053221787148*^9}, {3.490596350391958*^9, 
  3.4905963514215803`*^9}, {3.4905966173506203`*^9, 3.490596622417412*^9}, {
  3.490596720824193*^9, 3.490596722381658*^9}, {3.490596978878623*^9, 
  3.4905970354414263`*^9}, {3.4906811722778063`*^9, 3.4906811746103687`*^9}, {
  3.490681331352146*^9, 3.490681346791827*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindRoot", "::", "\<\"cvmit\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Failed to converge to the \
requested accuracy or precision within \\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\
\\!\\(\\*StyleBox[\\!\\(100\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" \
iterations.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/FindRoot/cvmit\\\", ButtonNote -> \
\\\"FindRoot::cvmit\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.4906811686847277`*^9, 3.4906811751519127`*^9}, {
   3.4906813332778873`*^9, 3.490681347855503*^9}, 3.490691990418304*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"AA", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"-", "43.481972094902645`"}]}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "2", "]"}], "\[Rule]", "157.90366302653806`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "3", "]"}], "\[Rule]", "37.90820244428706`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "4", "]"}], "\[Rule]", 
    RowBox[{"-", "242.4647564709169`"}]}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "5", "]"}], "\[Rule]", "91.79930439011208`"}], ",", 
   RowBox[{
    RowBox[{"AA", "[", "6", "]"}], "\[Rule]", "21.192733420222666`"}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "1", "]"}], "\[Rule]", 
    RowBox[{"-", "343.2480806097921`"}]}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "2", "]"}], "\[Rule]", "1298.4795253566751`"}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "3", "]"}], "\[Rule]", 
    RowBox[{"-", "1296.3091537650923`"}]}], ",", 
   RowBox[{
    RowBox[{"BB", "[", "4", "]"}], "\[Rule]", "3244.5362013930003`"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.490532227468444*^9, {3.490532489718526*^9, 3.490532516732068*^9}, {
   3.490532812419867*^9, 3.490532850330225*^9}, {3.490596269567227*^9, 
   3.4905962940277557`*^9}, 3.490596624499443*^9, 3.49059672327493*^9, {
   3.4905969793860607`*^9, 3.4905970029612722`*^9}, 3.4905970358871307`*^9, 
   3.4905981350626507`*^9, 3.49060620794221*^9, {3.4906811686881227`*^9, 
   3.490681175157628*^9}, {3.490681333292745*^9, 3.490681347861301*^9}, 
   3.490691990428214*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"original", " ", "Ak", " ", "Bk"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"Ak", "\[IndentingNewLine]", "Bk"}]}]], "Input",
 CellChangeTimes->{{3.4905966282017813`*^9, 3.490596629747342*^9}, {
  3.490596758734058*^9, 3.490596759490575*^9}, {3.4905971737634087`*^9, 
  3.490597182576355*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1335238`", ",", 
   RowBox[{"-", "0.3970328`"}], ",", "0.8590007`", ",", 
   RowBox[{"-", "2.6302896`"}], ",", "2.2441547`", ",", "407.4766429`"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.4906062092523003`*^9, 3.490681178826795*^9, {
   3.490691841119636*^9, 3.4906918647977324`*^9}, 3.490691942629725*^9, 
   3.4906919913910427`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.5096889`", ",", "1.2702851`", ",", 
   RowBox[{"-", "13.2144632`"}], ",", "3645.5462937`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.4906062092523003`*^9, 3.490681178826795*^9, {
   3.490691841119636*^9, 3.4906918647977324`*^9}, 3.490691942629725*^9, 
   3.490691991433681*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{
      RowBox[{"Evacancy", "[", 
       RowBox[{"Akn", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{
      RowBox[{"Ecohesion", "[", 
       RowBox[{"Akn", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{
      RowBox[{"\[Rho]", "[", "Bkn", "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"4", ",", "4", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"6", ",", "6", ",", "Akn", ",", "Bkn"}], "]"}], "/.", 
      "sol"}]}], "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490596804858758*^9, 3.4905968319531183`*^9}, {
  3.49069187723279*^9, 3.49069188433842*^9}, {3.4906919801252623`*^9, 
  3.490691985486809*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.25`", ",", "2.2499994520533475`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691992041264*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.74`", ",", "6.739998903919803`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691992083447*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"80.64040000000001`", ",", "80.64038031104428`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.4906919921437063`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.0000861240223829355`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691992203293*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "0.0005792616798658291`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691992263542*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.597`", ",", "3.5972728799622846`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691992546337*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1684`", ",", "1.200707112616459`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.4906919929537563`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0442`", ",", "0.712902180008568`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691993359277*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.9977`", ",", "6.359094200801523`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691993771184*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1803`", ",", "1.1695520977473057`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691994179579*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.2143`", ",", "1.1982828836728967`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, {
   3.49069186663334*^9, 3.4906918849289837`*^9}, 3.4906919432970552`*^9, 
   3.490691994586773*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], ",", "Akn"}], "]"}], "/.", "sol"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], " ", ",", "Akn"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"D\[Rho]", "[", "Bkn", "]"}], 
        RowBox[{"\[CapitalPhi]", "[", 
         RowBox[{
          RowBox[{"a0", " ", "r"}], ",", "Bkn"}], "]"}]}]}], "/.", "sol"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0.5", ",", "2"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "5"}], ",", "10"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.490596881267724*^9, 3.490596901214881*^9}, {
  3.490681365445443*^9, 3.4906813694177628`*^9}, {3.490681482592225*^9, 
  3.490681497081016*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwdknk01XkYxq/1FnInJGWi5CqEaWGs9y0ZM5GaOmXpWCJhpBqRZJlBlCVL
k47IECJlT5Zs78++ZImoVPYlyZYal7i/75h5znnO++/zed5nm8PF42f5GQzG
yVX/d91VFFtedPCA8b+kqHn2c+3BTh74N4YWH+2WpPTtYvb59/LAslbS0kVT
knrRuXlXyQQP6DFHjSQ+CYpbrCGryqQhNN3BSjuIRakkLtSvWUuDnhNbbZjD
oqwDK38fF6Ehbn6j5tSyOEWZmjakiNMQVTrcJn9FnAoddHKXkaZhhXaN57mv
o2REkhqF2DRwcpRMLa6KUto2Yp6DhjTs0zmcf7+VSbkavpSrMqLh1fHua89j
mVTijoTme8Y0jIdyZsxsmBRjfoe8hQkNt2NZnpazwlTT9YMtbcdoIBqMMr+N
wpRlvs/W8tM0iOUsD9VfEaS8BT623vmDBmc3Gx1vLz7q20Fd0cQAGsyufE7S
/omP8g+OOJQaRMOHmrkvJ6X4qCAh9Ybc6zQYnFcUyyhkUBFMD2yMWuULEn+s
OE0wSZRXsJREQ6Tgx4jEzTzcevjIHLlPg4xEQLVL7Qqm3UxWF05b5WGH9oy4
rWDmOsMsiYc0WPM634xUL+MT1o0Hqnmr/O8SRBc9vmG95Po4G6Sh4Jrn96+5
XPzlhEPPmWoaUhsVijlZXGyJLZR0raXhwJ33aiZ2XGzfYB7j1UhDznkr7qHm
BXyz8V5YdAcNwz4NBb0P/sEpWbZf9QAN6gZDVclXv6CEoo49m0FAQN1Jdkp5
FvXjQ7hr+An41x3Nzq2awbPiXZFTAgQGu4JtXU7MYOmia1khk0D6zczciqBp
tG1LlDRkEbAfK33aPPkJH3sxGmzlCKTWfMfy/TCB3Z8OWxtuJXBXbDJZOWIC
eafj59kKBBJSz7lXakzgr6Z75KfZBCzHObYxvh9wQd7R21eNwOyBNdJ1W8bR
sLlR5a4+AbN+nSKXiBF040hV+3IIhG96oTemP4J3Ck9b2O0nkOZ5TkFzdhgn
/l66pmREQKcqNM7EfBijLqn2PTUl0CG5/80u9SF8Kxsd3XmKwPZy155MZj8K
3nrHLrImUBKd9YwvuA/VhHdW3LUlkGWan9jH14cBc9SEnQOB3KHCCxv436NS
/fyBmd8IyF10yTeWeoseF8y/ilxdzauTK1Pu/wpltByblHwJdLY/6M0TfIUV
PPdEQ38CgdNai1aRPSgcGWnkE0igXFxgoDqtGxOy6mI/hhGYfMc6FDbaheDR
5SJ0k8D6opKpTu8uHNUd1N8WRWBTZjqrRLwL1VuWRy3/IuCpoOxoAp1YM7FH
symBQGSDsa+fUwc65+9fO5pI4GeB1NQdme0o5n2kjyQRuHS7X/TtVBuaM11D
fkwjkMfJqNf7sxUn2Sk9GVkEduVtqjFqbEaJMyyvkAoCrgGDeiv9dViissUk
pWq1j9dmHruP1KH1vIpcJUVAs9bYQ4SqxYxA44avdQRsx0JmorJqUPe+v7Rj
GwEwGancm0LhgHPE5J8dBOJ2W7B7FSkM1oivutdJQDXBYvfQScT2qqdOL3sI
DNgfDHvmV4kOfZ+KDfsJPNLq1l3kL0Nm+lK47SCBY8qyycwfnmG2G9POZ5hA
VV1bSpx9KS4sKzCfjK/+Q/p5PbOrGMM3n7LYNktgi5CPXet4IWoMO6safCZw
Q/5SVLBWIXY/ukwsv6zuZXvAsFX4E5TTufUwhkvgvfBeAxVOAdYykn2zlwjc
8go6K5aUjy5N2UeblgnsnNNf6OXLR7GYsu2jPAJFly8y1r3MxQKLJi4hBCQg
Zqfo4xz8F8N+2f4=
     "]], LineBox[{{1.1191275915090235`, 10.}, {1.1404177097917372`, -5.}}]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwdl3k81N/3x5Ei+06RLCmfiJJkqzMo2UpkCyFUklChIlmiZEuhJFlbbNm3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     "]]}, 
   {Hue[0.1421359549995791, 0.6, 0.6], 
    LineBox[{{0.7999360669824708, -5.}, {
     0.8063860652072603, -1.6795724204418718`}, {
     0.8068504244514806, -1.4537318781320892`}, {
     0.8073147836957009, -1.2293238317362238`}, {
     0.8082435021841415, -0.7847901937661845}, {0.8101009391610228, 
     0.08725249332405838}, {0.8138158131147853, 1.7640813555930777`}, {
     0.8212455610223104, 4.855447780380729}, {0.8217099202665307, 
     5.037312535462377}, {0.822174279510751, 5.217865057984966}, {
     0.8231029979991916, 5.575048438275928}, {0.8249604349760729, 
     6.273833770269846}, {0.8286753089298354, 7.609920563402937}, {
     0.8359740700678774, 10.}}], 
    LineBox[{{1.0386765115922878`, 10.}, {1.050727210010812, 
     9.03227236499498}, {1.080360903543972, 6.978655341658339}, {
     1.1124711797129738`, 4.955852131635737}, {1.1439968140280212`, 
     3.020276478607755}, {1.1734071942442164`, 1.1219509343651666`}, {
     1.2052941570962532`, -1.1866962593774915`}, {
     1.2350658658494378`, -3.6330360429128916`}, {1.2508217777406574`, -5.}}],
     LineBox[CompressedData["
1:eJwdkgs4VGsXxwdhXHINc1KRIlHSVYnzapScUJJQuUy6yZfSUR2RGkKRa6HB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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{{0.5, 2}, {-5, 10}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.490596904365493*^9, {3.490597014762521*^9, 3.4905970436979303`*^9}, 
   3.490598143113193*^9, 3.490606217827778*^9, 3.490681189456958*^9, {
   3.490681358387107*^9, 3.4906813714967623`*^9}, 3.490681499453601*^9, 
   3.490692004280875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", 
     RowBox[{"Bkn", "/.", "sol"}]}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "50000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{"5", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906073941848*^9, {3.490607457034018*^9, 3.490607457133724*^9}, {
   3.4906090472738543`*^9, 3.490609057888105*^9}, {3.490609540881029*^9, 
   3.490609685293902*^9}, {3.49068185000086*^9, 3.490681882403051*^9}}],

Cell[BoxData["20444.684427928463`"], "Output",
 CellChangeTimes->{
  3.490609628027426*^9, 3.4906097644370317`*^9, 3.490681523053619*^9, {
   3.4906818520791473`*^9, 3.4906818830938663`*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{
        RowBox[{"V", "[", 
         RowBox[{"r", ",", "Akn"}], "]"}], "/.", "sol"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{
        RowBox[{"\[CapitalPhi]", "[", 
         RowBox[{"r", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490681834690378*^9, 3.490681843677499*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"emb", "//", "Length"}]], "Input",
 CellChangeTimes->{{3.490681885708858*^9, 3.49068188899675*^9}}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.490681889694666*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_highT_own_pair\>\""}], ",", "pair", ",", "\"\<Table\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_highT_own_rho\>\""}], ",", "rho", ",", "\"\<Table\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_highT_own_emb\>\""}], ",", "emb", ",", "\"\<Table\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490602297888136*^9, 
   3.490602307001584*^9}, {3.490602455546969*^9, 3.490602461254315*^9}, {
   3.490681529283904*^9, 3.49068153549925*^9}}],

Cell[BoxData["\<\"Ru/Ru_Vitek_highT_own_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.4906819096661*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_highT_own_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.490681910145193*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_highT_own_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.490681910546452*^9}]
}, Open  ]]
}, Closed]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Ru Vitek_lowT       ",
 StyleBox["Ref. Igarashi, Khantha, and Vitek,  Phil. Mag. B 63 (1991) 603",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.49060166054762*^9, 3.49060166624483*^9}, {3.4906025043567657`*^9, 
   3.490602505346787*^9}, {3.490604660850788*^9, 3.490604758771997*^9}, 
   3.490768728941039*^9, 3.490784678495131*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Ru\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_lowT.dat\>\""}],
      "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490601674157384*^9, 3.490601674284174*^9}, {
   3.490601847355219*^9, 3.4906018748184958`*^9}, 3.490602517570265*^9, 
   3.4907041201077023`*^9}],

Cell[TextData[StyleBox["WARNING: modifying embedding function",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 CellChangeTimes->{{3.4906058547672*^9, 3.49060586552531*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "\[Rho]_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Sqrt", "[", "\[Rho]", "]"}], 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"A", " ", "\[Rho]"}]}], ")"}], "  ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Ref", ".", " ", "Vitek"}], " ", "Eq", " ", 
     RowBox[{"(", "8", ")"}]}], " ", "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.490610914916313*^9, 3.490610916449903*^9}, {
  3.4906109506729383`*^9, 3.4906109519747343`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "cBya", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", 
      "\[Sigma]33", ",", "C11", ",", "C12", ",", "C13", ",", "C33", ",", 
      "C44", ",", "C66"}], "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rak", "=", 
   RowBox[{"a0", " ", 
    RowBox[{"(", 
     RowBox[{"par", "\[LeftDoubleBracket]", 
      RowBox[{"1", ";;", "7"}], "\[RightDoubleBracket]"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"8", ";;", "14"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rbk", "=", 
   RowBox[{"a0", " ", 
    RowBox[{"(", 
     RowBox[{"par", "\[LeftDoubleBracket]", 
      RowBox[{"15", ";;", "19"}], "\[RightDoubleBracket]"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bk", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"20", ";;", "24"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"A", "=", 
    RowBox[{"par", "\[LeftDoubleBracket]", "25", "\[RightDoubleBracket]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  StyleBox[
   RowBox[{"a0", "=", "2.7067"}],
   FontSize->14,
   FontColor->RGBColor[1, 0, 0]], 
  StyleBox[";",
   FontSize->14,
   FontColor->RGBColor[1, 0, 0]], 
  StyleBox[" ",
   FontSize->14], 
  StyleBox[
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{
      RowBox[{
      "this", " ", "is", " ", "the", " ", "lattice", " ", "constant", " ", 
       "at", " ", "which", " ", "the", " ", "properties", " ", "are", " ", 
       "matched"}], ";", " ", 
      RowBox[{"not", " ", "the", " ", "original", " ", "one"}], ";", " ", 
      "why"}], ",", " ", 
     RowBox[{"I", " ", "do", " ", "not", " ", "know", " ", 
      RowBox[{"??", "??"}]}]}], " ", "*)"}],
   FontSize->14], 
  StyleBox["\[IndentingNewLine]",
   FontSize->14], "\[IndentingNewLine]", 
  RowBox[{"\[Rho]0", "=", 
   RowBox[{"1", "/", 
    RowBox[{"(", 
     RowBox[{"2", "A"}], ")"}]}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Ref", ".", " ", "Vitek"}], " ", "text", " ", "following", " ", 
    RowBox[{"Eq", ".", " ", 
     RowBox[{"(", "8", ")"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"cell", "=", 
   RowBox[{"hcpCell", "[", 
    RowBox[{"a0", ",", "cBya"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"basis", "=", "hcpCoordsRel"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[Cross]", 
      RowBox[{
      "cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ".", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
     "/", 
    RowBox[{"Length", "[", "basis", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"radius", "=", 
   RowBox[{"3", "a0"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "basis", ",", "1", ",", "radius"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.4906026010589743`*^9, 3.4906026392783127`*^9}, {
   3.4906027001195602`*^9, 3.49060272725968*^9}, {3.49060284707508*^9, 
   3.490602858819017*^9}, {3.490602945183097*^9, 3.49060294847338*^9}, {
   3.490603024169639*^9, 3.490603037380048*^9}, {3.490603249528762*^9, 
   3.490603282820067*^9}, 3.49060333363957*^9, {3.4906038959762783`*^9, 
   3.4906038974361486`*^9}, {3.490603964738929*^9, 3.490604037606134*^9}, {
   3.490604603345162*^9, 3.4906046536231613`*^9}, {3.490605822679552*^9, 
   3.490605842396473*^9}, {3.490610735464527*^9, 3.4906107364135513`*^9}, {
   3.4906109175216303`*^9, 3.490610918078246*^9}, {3.490682772669886*^9, 
   3.4906828808880243`*^9}, {3.490682940264163*^9, 3.4906829414427853`*^9}, {
   3.49068327220924*^9, 3.4906833565837708`*^9}, {3.490683497187504*^9, 
   3.490683498212101*^9}, 3.490683544576749*^9, {3.490683583298387*^9, 
   3.490683589001547*^9}, {3.490694275701416*^9, 3.490694278987451*^9}, {
   3.490694350756584*^9, 3.49069437645816*^9}, {3.490694517611721*^9, 
   3.4906945181791353`*^9}, 3.4906945483046503`*^9, {3.4906946156396646`*^9, 
   3.490694630368155*^9}, {3.490694668356805*^9, 3.490694791704966*^9}, {
   3.4906948346134*^9, 3.4906948507437763`*^9}, {3.4906950238615847`*^9, 
   3.49069503166964*^9}, {3.490695171134181*^9, 3.490695184581197*^9}, {
   3.4906953753676977`*^9, 3.490695376018426*^9}, {3.490695550160174*^9, 
   3.4906955503221817`*^9}, {3.4906957528161087`*^9, 3.490695839536717*^9}, {
   3.490695872671501*^9, 3.490695923438806*^9}, {3.4906959656736717`*^9, 
   3.490695990887137*^9}, {3.490697458464633*^9, 3.490697502381847*^9}, {
   3.4906976616529627`*^9, 3.490697715244532*^9}, {3.490697745426147*^9, 
   3.490697756206113*^9}, {3.4906978000048122`*^9, 3.4906978382244*^9}, {
   3.490698126812005*^9, 3.490698196227777*^9}, {3.4906982388391933`*^9, 
   3.4906984136530724`*^9}, {3.490701819758326*^9, 3.490701935186613*^9}, {
   3.4907019752211103`*^9, 3.490702011902227*^9}, {3.490702071997645*^9, 
   3.490702074381549*^9}, {3.4907041339933577`*^9, 3.490704150981084*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"6", ",", "6", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"True", ",", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"3", 
         RowBox[{"\[Rho]", "[", "Bk", "]"}]}], ")"}], 
       RowBox[{"-", "1"}]], "<", "A", "<", 
      SuperscriptBox[
       RowBox[{"\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"-", "1"}]]}]}], "}"}], "  ", 
   RowBox[{"(*", " ", 
    RowBox[{"Ref", " ", "Vitek", " ", "text", " ", "following", " ", 
     RowBox[{"Eq", ".", " ", 
      RowBox[{"(", "8", ")"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
   3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
   3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
   3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
   3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
   3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
   3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
   3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
   3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}, {
   3.4906049533260727`*^9, 3.4906049618199167`*^9}, 3.490605597580228*^9, {
   3.4906981411633663`*^9, 3.4906981414957867`*^9}, {3.490701946137982*^9, 
   3.490701946299754*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.25`", ",", "2.2507564798443838`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.490704153540592*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.74`", ",", "6.740666866369104`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.4907041536007433`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"322.5619157597301`", ",", "322.57510651570203`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.49070415366938*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.0012769392567265128`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.4907041537180233`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.0006574366691965956`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.490704153771905*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.597`", ",", "3.606830780623138`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.490704156880782*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1684`", ",", "1.1736593530845636`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.490704160153598*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0442`", ",", "1.0497845494592224`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.4907041635730343`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.9977`", ",", "3.9969325913417997`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.4907041670036907`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1803`", ",", "1.1805465081074595`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.4907041702714577`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.2143`", ",", "1.2165857137692935`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.4907041737549953`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "True"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.49068269704598*^9, {3.490682777821363*^9, 3.4906828556408253`*^9}, 
   3.490682947053669*^9, {3.490683307860869*^9, 3.490683357788497*^9}, 
   3.4906835000958223`*^9, 3.4906835456425743`*^9, 3.490683594770618*^9, 
   3.49068809232447*^9, 3.490691619674008*^9, 3.490692021654564*^9, {
   3.4906942566263733`*^9, 3.4906942841460447`*^9}, {3.490694353774439*^9, 
   3.4906943776760063`*^9}, {3.490694519654049*^9, 3.490694549390875*^9}, {
   3.490694686781541*^9, 3.490694792735076*^9}, {3.490694835978457*^9, 
   3.490694853759593*^9}, 3.490695187011483*^9, 3.4906953779416113`*^9, 
   3.4906955513518133`*^9, {3.490695846924954*^9, 3.4906958928213453`*^9}, 
   3.4906959250014353`*^9, 3.490696010371881*^9, {3.490697465450212*^9, 
   3.490697503490041*^9}, {3.490697674309823*^9, 3.4906977161903677`*^9}, {
   3.490697746785368*^9, 3.4906977571000347`*^9}, {3.490697808015032*^9, 
   3.490697839228046*^9}, {3.490698132273802*^9, 3.490698196901492*^9}, {
   3.4906982404209127`*^9, 3.490698414801968*^9}, {3.49070182163472*^9, 
   3.490701947377273*^9}, 3.490702041824294*^9, 3.4907041737611723`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0.5", ",", "2"}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
   3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
   3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
   3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
   3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}, {
   3.4906020440406437`*^9, 3.490602049639514*^9}, {3.490683433089872*^9, 
   3.490683450321622*^9}, 3.490683601426015*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxFl3k01P/3x5FsEbJFWRJSKSqpLHPfllCIRGRLkoRCi0QLRSRbdpLwIbIU
JVR4I7KLSJqZShEzjDHWbDPze33P+Z2TP8x5nNfrde/zPu99vd8zW9x8rc9x
cXBw+KN///uU5Llcqrr6B3Zw3L/gLmSHpRBd676KjsI9TlGGuNdJzOOs3NY7
J0bBQ/CxLjvOBpvV8UpPtxuF5/q69/Sv2GAh4pXCFY6jMIv5mWadtMEymi1W
KWdHoftsq2yBrA3Wve3WF+uro8B4hmfNlZzAtGikCJXkUVgXxrS42mON8VxL
p3UNjMJM7vE15TuOY9bB8dpfiKPQVXf2Qq7ocSwrNCKS/GMUHo/NDxUvWmFa
sdeUJkZHoYzbf4CnxQrzKDjuxPd3FBRp2akkdyus5Rt/p4HUGBz5WvmadsQS
iyQEFVfZjQFDvHIHdtEc6zfyX6pzHIMNo51Zy5g5pmDmafLx9BhISB878Vvc
HKu2Ozncf34MqiZ1txyqNcOofns3zVwfA2WrB+2cImbY0f/Go9TSxiBkuklh
ovYIto7P0StncAzop3nNbmqbYM+um3qeJY+Bg+cbZXNJEwwb2++hPITij5f9
wGaMsasfRdyej42BMTUnO63IGPsR9vFU+cIYyDeN2rE3G2NlnHuPNIhTgMOp
Tz2d7zBmu8Kn+suKApTE2bPBywYYw2tB+T8bCmS5fa5pJBpgUcThrefsKXBJ
9WGm2nsDrO5tnTz1NAU+qmbmn79pgKkGXpWavkSBoPHK3kAOA2x57icPZwwF
xn892/V3vT72lF75R6GNAgzM/lnDAwJGFH8roNlFAWdd83SeYwRMUue9ukkv
BTavHTqYuoGARUfgNy5+o8C9hs91GZl6WKBCq9A7KgUOHrIrUa7Qxaysv+0/
IUCFzPpL+lumtTGuypXwcDMqDG+4yHDNOYDpkZlFaZZUqBeLodZdOoAFcnH0
FJ+gwoXFohQ33QMY/Ri3zGdHKiSqd1oEDWphxDHBF3I+VFgulFz4I6aFvZaW
G6iKpkKku4tbWKom5n4LUxnvosKp3xbGcT17sEnBQytVvVSYr1++KP58DxaQ
uacn/AsVrsv8t7U3dA/24L1i0JbvVCCb+T5h7NuDvVji7ranUUGe703UhwwN
bOla27UWgXEI6f6VuPvPbiz2knVznsk4+IRxp3Qm7sCkWEczLpuNA9WIq22r
9Q4sO8bQF7Mch8qBCNchkR3Y6xJNafLJcXjxQPd+ZNx2bHBc8qKYxzhsmWzf
Gf1IFdt6niR+N2wchIv8SZsLVbDq0+7upxvGQXxNaomh7FaMQ5ZPVKZ5HHbG
WdbXUhSxI8Ti2v7WcVhPNWPEVShiRJtZyaM949A0Kx+iY6GIrRy526b5cxzc
R/KcCu5uwQia2bsFmONg6qxL3boij92fNiQ1cUxAwNBvxkCmPPbpxVjEHe4J
MPKJ598D8pjrdvVfc+smQPKGgtJguBwWKleX+FNmAtI8Zhd/ychiTXzkxYqD
iCOdFs+elcEEP97J99WdgBRTdU9DYRnM9t7/XJgA7tuRDfXvpbFRplfxU5MJ
YCjTRxMkpTHe2SXnqJMT8MLj3N+wPins6HepD6evToB+3spaBS8JrLf8RIxA
2QQkddx/pMEjir1TFjwjWTEB1PX+sSq4CJaX3qSpWD0Bv2ovfKkPFMECQveT
D9VPwO5Up6I6kjAmc1xq54WeCVDROmB2GhfC3BnE1hbGBNj7hZfONvBjFu6J
mX1zKH/33bC3JvyY1qCZ38/F/+khR5d182F89TVSfzloELhpzl5tiBcrjcvy
UBGlAUf4yPQeUR5sYbcbd/geGjx/jdXvKuLCfubKDMbvp4Env7OpnQEX1irZ
V5x5iAZfl8WfZpA4sQyW4YkKfRoERxb89BTlxKBbOXf4OA3aAwRD58XYEHmR
CgaXaUCsMth/ynEJ/H/liB0LoMHgo3zLiNJFcLB1GDsVRINLHnX67zgXYZde
R6z/XRqIvypfUSxbgM+Cpd+zE2gQUrhKK1Wag00lfsHsVzTQiFdm7O+ng/UD
eXZzJVrvokT6t01ClEf33eh3NNC9KsU51ECDRQW1KOlGGrQOqsQb1IzDQPJY
2r5eGmRvl1VLR8/hhDsuleenaLDRonGsVfsntDsJae+epQHjNl1BNeI7cGrX
1M4t0EAwwm+z7TcS+M1JN4eyaJD3y9ZxJnYQLC586XssNAk93E0sdcJn4Dth
Pv1p5yTUfwzVzH70DjCNlasp6mjd8qFUndIbuC5UtOi0bxKwsp6tHukvYbSF
l2NcexI47vhi272S4YPuh/XcR9H5Bp3xK2ql+LL05YR2i0mw0mITHrq+xvf+
VZB8dHwSDvLHee2Xqsazy2/Lyp2aBMatJ3sk8+vx2yraagc9J0HptvIZj3Nt
eOUa6kuW9yT4nEkM4bndgU8Ope5r9p2ExaunhLxjunCnx/Pa1tcnwd4htdKj
tQc/JFJ+xOf+JLzyG8pcm9KPzy1tO5+dNwlXEi2tw91IeGfMhGh14SSQ9SQ2
Tx8i43lbXtZ8KpmEN+fiv/4n+B23PaK1gV0xCeLm1yLX5/3AK9OMap2bJ0FQ
urtNuXsIj1Xj87yG+jRraj+Qve0X7lHfsSGmaxI0bR7WT93+hUtSrD1rvkxC
t8AJ1y3bfuPXD5wR2zSK/HLR3n3LZRi36lCq2zuO4nWRI7GCYVz1NMXzKH0S
JDUXlPnow/jgfd+6GwuTcGxp7lTNtRG8TGbfhUfLk5D9XUjgTeUIHvliQew5
axIs2rjV2+dH8IMDty4M8tAhumGW3+3SH1zES1+cIUAHTVv5b4yCPziFyY3z
CtPBnhVnWfHzD56uHC1+QIoOUZkF7tNHRvHlqxl48jY6JPuGxk/yj+Gf+Vy8
SnfS4bxQwXL7/jG8KHOLRLM6HZy+//QTch3DHZoKveYO0MFHfub1t5dj+F57
HwlBXTqoS7PTfb+M4QI09fqtGB22W9+vu7s0hr8Xq5I4YUoH1wSv+YN6FDyp
IKjey5wOCgorChQnCu6jQ/C+a0WHs6s+tWrBFHzz2eb6cns6bCt1DI59TcHn
FiK925zosJ9fsLKqi4J3RplL/nKlw6MG7qTYUQp+81Wft8gFOjjbavk4i1Nx
G+NUSdWLdBirzr1zZjsVVyM6NIA/HYzv13nu1KPi3JfkfOyu0aHm7lbNBksq
/p3zt6TvDTqI+HvTVc9Q8crk/Ib7t+ggK66R5+lPxWO3X/DJCqVDusY6t/sh
VJxwnNHQ9YAOq8PeqlcfU3HJP699/sTQ4Qin8lGrAipOD7wuxXxEh4xnjs8U
X1Hxj4I6jeIpdDiU8vzI9HsqnpXN8lHLoEN+UiHW2ETFAzQbpYyyUP/OzaQ+
7qTix1rDGx1z6TDVoeB0r4+KqzgduXjlGR1SHnal3/lGxdlTghsfFtFht2eC
c8oPKp5SHpwR94IOLn0FU+9/U/HdV8Y3J72iQ+AZy1HhUSrerHnqaVolHc7t
e7ecSqHiTgstW568o8PKeenRU+NUfLZKKy+njg5nFLLOOE5Q8agb+SrPGunQ
cfOGSi5iRR3x50Uf6XDrCXlyH+K3q3d3vmynw0juop8kOm9VN136upsOKiUs
T0sUn3LHVaP6Mx2qiPJxI3+o+B39T69qBuiwwzImk4T0Sa4h7G8g0oGgGnhU
+ycVL20qqWr+geYlQtSah0TFje5v0m7/TQfD6CifwwNUnGwSVdM9SofLduIn
mD1U/Ar/EqFvHM0T/1Ddvg4qLtBxvuErnQ7PGuQu0JGfudEDhuQZOkxmc67b
V0fFe4QrTP8s06HaNlDG/yUVP9+r2EFl0eGe96Xla6hfrIRHFnSuKZhQ7arc
9JSK75L0tf4rMAWfDHK6T8dQ8aav3/tX1k8BdXJgkScM+ZdubschNgWVUlzW
Z4KQX5t3OPFvmgI1t4luggcVH1P8c27TzimIOjiRy6tDxW+PnKDIq08BU/vF
3Ct1VP+zRi+lfVPgVdHBUFdC9W7P9t2lMwUd91uVXwhS8Rx1xxtgNgV/hIr3
qpApuKNub/RZ7ynQuv84a+46Bf9kW/u6uHgKnKK1QjkKx/CKEMVRr5dIz51t
RY8ej+EZxREbd7yeAsq00qx03Bjuzml9q/DdFAR+oH8VDhjDl0tGjfPbpoC8
zzUu3nAMV+EWIWaNTYGBaEf7b/IoDqf2cLSJMkCA02Tza75RPJU3TKXGggG/
CvgvmRqN4A6L2IkmSwbwaHufNNEcweWozDudxxngLtv8WVtpBM9rv/6NbMsA
hrZzAHsNen7FeEcznRmQE86aZjUO461iJ2YIlxgguHYNVx9hGF+WV6xriGWA
zApHbfmu33ityM/xtngGJJVojGpv/o2HcGZKfU5gwKuWfZuqBX7jPMMS/r9T
GMD15GVq7NgvXOwZv9KapwzgC3Y+W5z9C1dTm35g9JIBmS/iorNFfuEuB+tt
Wz4xII2wPeJV90+81TmQWNLLAD9DSYZW8U987z2N0wl9DOCo2F/2JOInztud
7en8lQEUcz1pPuwnXnY2NHj2BwOsLrY18b/8gXPFGeTI0xlQpvJMM+red/zZ
nybadcFpoFzVqltYJOIi6275O6+fBkat0sHZLiIepLF/wUBkGuq/XekrySXi
lsH5bCHxaQhkOO51MCPiiyL3N+Rtmgbs+nl6Wfo3/KiuycGeHdNQ/V7AlLpj
EJ9MaLunemQaFisCPzopfcELxQQztcymISQn4O9Wej/ulnSswshiGvwsBV9V
VvXjg8l9I67Hp8FKeNbU4Gg/3pj2/XD6qWlQWOeYLXCxD0/NmuYV8EL5NFYF
lIt6cf0i6eiJKMTxQfPWop14csOFpBediE13BQ4qvMM1voVufN2N+OEt5uN9
b/F2RnpmVQ/iITC9ZFyNs+Tb8+r7UX2Hc0PMfSpxj9s73nwmo/WRhDrzt6/w
gzoTXxZo08CRn7QUXfkMJ1b4SIHQDHD4vQsNM38AVzvDHhsKIy6fecipHQ/r
RzLlTUURGxzzI3UkgoFY17bjEogT3r57Ts2AYv9dB8/KIs77WCB7Pw9u7qbb
R+xCfPm/eLeD5SBf6JvxyQLx9GGPP4/rwHXubkC55QzUsyq22TjjkIulWCce
nwHsuLYLa309KH2rEbCznQFXY2+TwO562CEgEPzDaQay73yPe2jaCJo+eY6T
3oiDHTdxqjaDqca3zeuiZkBhY4h6eVQ7PLhJW6Q9RPwjZet5cju0t7L7u2NQ
PE/p2thdHWBxRiUm4dEMhGgTr+/q7gDrhCtM6XS0n5iscY+vC5zmhH6oFiK9
9ha9rq6f4Am25Z1AEVr31iPHFn6CH9GaKbRiFI8dNL6R8QnOKDseK3s5A4zo
nf1PCD3gcbKw7kAVWheZGm1v6QG/aoOnxh9RvcMwXdnWC1yuQ+uPtyL9O6s8
J8d7IZH39m3H9hmIN618U7nuM1SefOvs1z0DZSlcLiyzz8CcU9+cMTADPdG9
LUdaPkNsZtfDvMEZGHoQ3sEa+QwKRt4rL4hIb9jueuDqA6PEZ8QPP5AeLkkB
N50+iNojmz45inj/IQ6Rwj7Y/O0d3yIFxVNdiRNs7IMXIfaBXBNI35Ha8HhS
H/R+SrSTmkLx706YaQv1w8ZLApL6f5FfrwpLz3v3Q37R34Qk3llAr83NtRJf
QMs6mesp/yz4aUmUxW//Aq1Ley8/XzcLIbST1TJ6X4Bmeul4nfAsKOg20JzP
foG9YyPCFKlZGDIdt5wt+QL1Wz9H66jOQryore2k1gAQM0vu/zZF6+VdSgaa
X0HsxuFj7UdRPv74RR2Dr2Bu+0PilfksYHu32clbfYVaIZH8UKtZqJe4Rcn1
/grZt698ULBH+1c9mrNyvoKHqzbH6fNIj+DeN1f5B2Fma+sNUjjaT3jcP9s6
CDs5zuh/iED5Sn7zHewfBHfyEl/xA7R/2OTc+Z+D8CVpZ1pQzCy4toi3R8wP
QvXauErpZFSPkX1pj8I3uD1mO2uXNwscfWHbYq98g3XFwz79jWj/CS/rDQJE
UJKzzn7VhOI9jq8q3EAE3Uf1ffEf0X5+yxy1TUTwuf5E26Id6Y3Q38fcSYRu
Qzu+j71Ij+/b/EZzIsST2/+rGvqfnq9e1CgiFFoe+pr8G/G5zi7nBCLUNxYI
XB1B/EUosD6dCNOFYf4aFOTPK6U+q0IiWF8jwPMpFO+9y2JWExEk1r8iZrBQ
ft6xvJUlIuwOVVh/g2MOho4saDhwkMB4LlbfjmsOMEPelgIeEgQQvQvFeND6
Q5K+iBgJBp8pB0QLzUH8Z/4WqZ0kyIB00dub58BPzfXNOnsSvHrFe9hJDp2v
Gkh2dSZBu3JAoLbCHPTUrzHMdyPByroTPxe2zkHIvd2aLB8SOA0KlvrunAOR
rfc+ToWQQN4/xPSM9hxofFh3nJxPgki4Ieypi9Yr40wfFZGAIXR54BIB5f8W
LKH5kgSNRWfdbxrMAcf7VxcNq0nod7xxSOpRpHdvfntUGwm6XoFJljk6z7iq
UNZFAq3Qg+vzj80BY3qx5UMvCXjldmS+skb7uwyPVqLfY0V2QtVdDii/+lR3
G4UEYio8d/qd5iD7lPe5szQS3JxjHSa5oPXvY20TUySweMToo7ih/Mu8Om0L
SF9739Qa7zmw6qX7Va8hw6n0zkqBi3PgKhi4o52HDI3nm2+J+s5BfYXF7g5+
MiRyV62Tv4Li23OfeCxMBi1Cxjbt4Dko2/v8wzUZMjwVTKRjt5CfW7LvrpEl
Ax/p4RuTO+j8I3W+UHkyfLt+y9D2HvKXi5BvpkQGA+MAAadw5C9fDylNhQxF
4r69bhEof4aC1IAqGW6Wu572e4j65bOVqLCLDCN3Tqlcj0F+lFNCdquTweKY
9eStOORvTIKX2h4yyE0YBj9MRPVseGe0pEmGBqVtqc8eI79S3VoGdciwY1be
pfQJivf15EEvPTIkNGxUrniK8jcEe9IIZHB3EXjd8B/Sn33L6IM+GTrV1gS1
5qN+ZFwU3mhIhv0rK9inArTftOKrsxEZeNImu8nFKH+3d1aNMRl8PUaTh0vR
/uKp919MyDCo+dNp/CWq35ghPmRKBmzN4NbpchRf6W816QgZnvf2jP99jfxo
jqlqPUqGDdlt5aw3SP8LPYUCMzIEXWoMXFuN9J+O57puTgbzdRU8YjUo/3aj
yxMWZHBaX6j8txblm8+LDz9GBh/RTCMSjvS8lyCIWSL/xOPP4g2o35NaEUmI
H0qF3f3vA4q3WBjIb0WGDJnAnIhm1E9LQfnLiItkfeq9W1A/XTkjuhG/U3D9
admG5idTtVbuOBnat9qw9nWgevwVu90QE1VMZTd2ofPH4z5mIB7frqu72o30
Fwu//oh4WU3DcagH9YtumD2KWEBDKajpM/I/ujNjGbHMvo3phf1o/+yRl1zW
qD9agtXRA8iPRKdxFlrXPsTx1W8Q5fueZz+F+Iju3LwNEenHPvD0I7YHivgh
Mqpvlz1nKWJPA/I+2R//6z+3bRDiwMM91pxDyC/X8+t1EUeaNvn/+YXyRyhq
z6D60syq49uGkX9/v4xkIi48VvKy9M8cKMgrbtJFXH08u/vRGMrnW0D9hPxr
tUmavEZF/trzONsjHrSLFHSYQPUf+Rn6BflPcbi5kzCJ/Hv12d0E8aKz31HF
KcRrQje8QP3iPeN+gWca5S+JSuVHLOluHzk+g/TLxnM4oP6qnDcv6J5D3LzH
4Snqv/FFzT8pi2hegjtE+dF8nPRT5Q5eRvfjAveDXWh+PK5s3np6FcU75rjV
BM1X+A3uM9s45sGvdmT2FJrHpJuLd9ZxzYPCNnvDE4fJkHeHljW1Zh6sTLwp
+mh+m8L7yVW888DhPXOOjea9P7J15TE/On+swK4bQ/ftYY1MyLp5GCq41ZsA
ZOBOyLM3FZ4H15si8au6ZDDMuto/KInWqQ4ZNgfIYJ3jOVuzcR563hXs7t1P
Brc8pw05MohDpMsM0X28W2RkdUFuHuqLJ0sE0H1trBTvXFKeB+zdyNSWHeh+
fKr4ILMfxXviWxCCnifZu/YFbDuA+IC0qOZGMnBEl6tqHpoHkY9CSWQJdL9N
X8RY6M1DfLmSipAoep40FtiFHEb6vZX06Oj5ZfgmY+KP7TyUJWMmdQwS5IlJ
Z83YzQOD9qS7fZIE3JdTrdin0H7uIL+ucRI07U56s9EF8fkVwzcjJDAqjLlj
5oH05urRRAbR++ZxiFh5ANKzMdmap5YEz5ZYzbWBaD/jt8DNtyTgsb8V2B6E
8tkM/6C8IUGLeND34dvIrzemMoUvSGAae6VAMmIevffrs+uekuBoqIfOzVTU
D4dDzFPofWJx3vysSTXqR8xS0DsdEkQ7ZYcefYfyVXsLmB4gQefxuacWNciv
6ot/u/eSwFw3k3yiHu1fXlRp247iidJsXVvROo/YfT8plO/9Q9Mbg6hehQeJ
adNEMBLu2FW8iPrhtvlcdQ56v1cdWVx/aAEw9a8vo+a+wayGeLRa+QJwdFnL
x8YMQuPta1y++/5Cmcd7ok3vAJxa+O86b+lfqC5JPnyO7wt8Vj74W1tpEVTd
8xctdvSB+/az6on5izAoQ1c9LtgLtScdg/XlluCgd6RckFA3qNuPPxfPWQJ7
2cZTmQVt4HnP+KvepmXANkz+tX3SDGEefMucicuwmYOSdaO9Ad7KnmGPi6+A
6rbwQErje3jDur9mR+wK2Dg/tUkVeQNR01sSD8SvQFOF8AHx+QpwGalRPJyw
Av1r5xWffqsAnvYZfdeUFUgjWtr8zK0A+2SXkJSsFTA69LRNQKsClndqMble
rsCggs+ZTadfA3bqzwLp0wpkY0uOsTXl0P7acDxGdBVEhH2cVa1K4bZexZ9H
YquwmGApMbulFPa2KP1KllgFq3RvnaHZEsggrh18Ir0Kri9ljRXTSuACZ2tz
6ZZV9H1ENsT0dzHwWZrndO1ZhYPnVMlat4rAeNzGXsh6FZKiLX6d6y6A5SvN
J0RtVsFpD3ajMq8AXjD3W0qcXIXNHlOyu4ILQFJUyljWYRV0OW04Y1QL4M+B
b/t2uaH1KKqDTPgzCAt3Fra4vArchr9fhB3OhwYFj4/RCavQYzx5320kFzb/
7JW+lLQKaafn3ig25kLAE72LlimrYJRVpcybnQtqMhLiGzJWgaJ7TVnPKRfS
xJrOpOasQkXnzwOuAzngx6PIzClbhcEcvkOpvdmgQPu+r6obxZutdiO2PoHg
oiMRaT2rkD1wmutjzBMY8HxDvPF5FbDX1yfY1k8g+k90qO7AKkRqxlKdf2TC
4g+dTw3fV4ER+HK4ZvEx9PSme3XSkB6haINvOhkQUmWb80uACX5J85j8cgqo
9ZpFTggyIdpKJtawKQW+juv7zq9nQn05ybgmNgV2y+3W4xdjQllW7fRzpRQg
hfF809jEBO6GuvFLNsno+3+VSMhOJrhKv7c79yERaLSNIXLmTLhZ8iFm3/d4
SOMRPq96jAkKVfPV7uXxYKiw9theKybYY+u5f4fHQ8aJ6U3GNkxo4r/JwNXj
weRdW9VFJyZQdknWr1kfB7kRQVM1Pkyo3rgo3Ho/GuwVyS6OMUzwoecM5AxH
QJFf1xODOCbw6R3H83MjgFlXR97+COl9zabJu0VArmOOw2ISE0pqrM9f+30f
aEkeJ5MzmaD58glvOiUcQninLT4Vo/XnO665C4TBZ9vf0ZWlTFh9OCWY0XMP
lPP6Op68ZILGlpTtkHoP2rHKIz6vmZDJE6o/oHwPxIOCD/O/Z4LqnoxNaqZ3
oZC2Vs+wnQmBaXp/pXJCYFn7b/COTiaIVGO6YpdCwOIB5Z1oNxM4JPiMr+uE
wIxyx8GhXuSHTfXU1Is7oHs6XvPWNyb0nOvky1a9jfono1ZFYUJIQfvtRf1g
+FupvmknLwusqPauuTwBsCNzoZmPnwWFhtz1xe+ugVNord+oAAvqRzMeufte
g3ozs48561lAU73s9It4FSKHPPw3SrKg5sGWY9Nvr8BGgayWtcosIMuZRVen
+sPRKffLwyos2Lz8479TJ/3hZv9O2QZVFizmsa4+kfCHoay3l2+qsaDnYZuE
QIofFO77Iju7D+mR6JJt1PWFg86CV4cMWOiTP6kgzRu8DPrk6oxYkLawYdvd
7d6QuS2j7bExC/gI12oi33sBx8w2ebujLGjdKJ4gNnwBWu8btncdR3q++Zyd
BU+wLwtSeO/KAo1j0levq5+DqGT9jjQ3VG+JxOkTn92hJogvIMAd5WspJukH
uIPC4ZSOPZ4sqLh8bZdVw1mgfCsPKPRlQdJtjRdr3d0gcA21M/k2iudUOPuz
4jQsG2qvywxB3FPkErT+NNwKe3gk9y6qr3B10cXLBe6u3f3xxX0WZIcO3FxQ
dYaHvFfwllgWVCc7CEzWO8B60yZmVzwL/BY/HTyv5gDxkRK6/Qks0CxTkl6X
cQqS+Kurh1JYIC5RUYYH20PWOmb5UhYL1G66hXnZnwQF82MMdjYLoo+2R9X3
28J/0U938/zHgjDnnGb5E7ZQKGRQvKGABUomf9KptjbwSjgib+dLdH72/dpD
V6yhWUw01RlnwVBds/vlDcfA1Mbty9kGFtjPO5oHmFpAe9JrMa8PqH+XRQoE
7ppDt8TJ+IAWFpjucT/YxD4Kg1KPH8R9QvGPPHNKVTIFB3taS3IvC0b05Xx1
Akzge5oeT2YfC3xc+5d2dxjDb+mhu4Vf0TyxopaHbx8G2iblmw0/kT/mojq5
goZwySngXcsvFmzk9Mr5cd0ApjNbFruGWSDyTiF8+6g+LMh6XSOOscBmx0GT
9g4M2PIvL81OsSBEiRlXeFUP7rpylC5No37OXzxpEKQL3DnHJ9izaF5iiVuu
h+sAn+LcecFFVN/ix06/kkOwQenQGWUONiw2dqR819YC3fTwv3xcbMgk2Kvq
3dgP59Z/jqGtYUN0a8Ha9TWaUL3o9e41Lxtq1uFfu4/tA5euTDEDYTZoJEqZ
OBZoQKQB9bmyKBuaqtbm9fFqQHnVfoxfjA0cf7d7FQzuBu7cbp8eSTaY9j20
9LmrBkUBHB9d5NgwR7h2Q3mvKvRPmDsZKLAhZGne8oXGNmC6ps8oK7IhUvLa
6StaKmBltld+UpkNrVGdj0ztlCCo/vabnm1sSKP2UbZe3gr/7e8wq9jOBqu6
A796ExVhQd49MHgXG1a/XJbTnVAAheSy9afV2cCteCP1g4ICHBFg5hnsYUP1
xBVNz7dykDmX3Mu/nw0iYQlHu7o3gUFby440XTbY/zxj7xwlCT4E8YZgAor/
Q+ex1kkJSH7tancaQ/n3rknU2SUOlCdL91SM2KDKlrg8vyIKG8SMZQSM2XD1
Ad6AzYqATmRC2aQJGzxllHe3UYUh9vLO7xVmbDho9tu4WU0QqseuX0mzYAM5
+U34M28B+OWEnuyWyF85G/+EWj7QNHHWMjzBBk1lb8Zw2lpwqXneqWKLzrc+
tQnYwg0RexbcBOzYkM2Q4r34nguIm+Lieh2QXyJmi0NbOID7EUn5jRMbAh3D
hCVJTMIuHtWaNBdUr9q40OijFUIIo55y2g3p2yJEK3H4Syg6J3TH0J0NPrEG
F5le84Q+4imJbR5scFccErmVOktQaZ7Rp19gQ4mlEVetPoNgpQ2Dvd6ov248
w6XBk4QbLx9eenORDUOJ+6Of5Y8TcpUGudN92eB0Ozanlj1G6ExXenzTnw2D
Zx80mUf+ISys99/jegXNW0JWSqneMEEhrLbF8Bqqx8r47SG5X4SjS/wu266j
+eicfpxs9YNw5dLJOYEbbMAOONOuVhAJG7XcW1WC2VBIiFZg8Xwl1DD9Mw1u
saH/P56/GhV9hDPNd/xc7qB5+/LDKaCqh8ATE2MUFMoGSsqx25c2dhKKbR5v
TLmH9DFGJN46thCsNj+nlYej87n5DlnqHwjzw5X1XRGo3wreFkMSOCGjuCmJ
+oANriZXCjnaqglw5bPn2mi0/qA0SN/jNWFEe0h3Sywb6i+2MNCLkfCAiy6i
F4/06eHFHjufEXa3r4zYJ7CBpjwQa8eTTeh7xP/2ahKa9yBYe+xwCiHwlFRM
fAoberLq6vwvxRBktyifKUljQ56ox/LqnruERsre/a0ZaJ6TI/DKsKuE82UY
/0gmum/S6UZFe90JgoHHvrOz2MDYVy90b8iSUA5O5ZtyUH8tfFV0L2sQTvJ6
hR/4D/lNPbkQ2T6nt9J9/dSJfHT+//+yU8J3+Rb848MuiZwPn//jceWcL8+K
/3Hc5IvnjaX/WPNNza0fL//xbaNBZcmKf7zhrHBAeM0/rtohezSn7h87zeyQ
q63/x89CjT/ONf1j7exbku5d/9jt+0SlwY9/zJu/FOUy9I9LfHhPB/3+xwsr
iryvRv9xlIyD3Zapf6z++/xOvel/3P/8Gtt+9h/LHXpUEP/3H3/geBpcsvSP
PVtLLFtX/rFg/LutI8x/XG7X+pfN/sf/BxxNcxo=
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{-0.5, 1},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490602051496909*^9, 3.4906031320709352`*^9, 3.490604083355918*^9, 
   3.49060498574852*^9, 3.4906057365323057`*^9, 3.490607194608697*^9, 
   3.490682722851453*^9, 3.4906829721160307`*^9, {3.490683414664806*^9, 
   3.49068345325373*^9}, 3.490683522500739*^9, 3.490683568688365*^9, {
   3.490683618940783*^9, 3.490683621835331*^9}, 3.490688116918796*^9, 
   3.4906948808638487`*^9, 3.490695214964747*^9, 3.490695400235921*^9, 
   3.4906955747574873`*^9, 3.490696037426305*^9, 3.490697527948403*^9, 
   3.490697864109346*^9, 3.490702065623317*^9, 3.490704176512308*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "5000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{".5", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906073941848*^9, {3.490607457034018*^9, 3.490607457133724*^9}, {
   3.4906090472738543`*^9, 3.490609057888105*^9}, {3.490609540881029*^9, 
   3.490609685293902*^9}, {3.4906827280760317`*^9, 3.490682735134865*^9}, {
   3.49069808065641*^9, 3.490698084074692*^9}}],

Cell[BoxData["3240.0493231019973`"], "Output",
 CellChangeTimes->{
  3.490609628027426*^9, {3.490682723417308*^9, 3.4906827354817333`*^9}, 
   3.490682972454174*^9, 3.490688119505783*^9, 3.490694883562995*^9, 
   3.49069521670109*^9, 3.4906954006008663`*^9, 3.4906955758133917`*^9, 
   3.490696037657449*^9, 3.490697529703084*^9, 3.490697865397018*^9, 
   3.4907020658917913`*^9, 3.490704176813781*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.4907041637975473`*^9, 3.4907041647283373`*^9}}],

Cell[BoxData["10827"], "Output",
 CellChangeTimes->{3.490704177821506*^9}],

Cell[BoxData["10827"], "Output",
 CellChangeTimes->{3.490704177826981*^9}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.490704177832754*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_lowT_pair\>\""}], 
   ",", "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_lowT_rho\>\""}], 
   ",", "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_lowT_emb\>\""}], 
   ",", "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490602297888136*^9, 
   3.490602307001584*^9}, {3.490602455546969*^9, 3.490602461254315*^9}, {
   3.490602518601597*^9, 3.490602519381613*^9}}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605021690888*^9, 
   3.490605740124065*^9, 3.49060719689602*^9, 3.490607398522768*^9, 
   3.4906074606189623`*^9, 3.490609070036997*^9, 3.4906827374131727`*^9, 
   3.4906829760952797`*^9, 3.4906948872319593`*^9, 3.490695219082754*^9, 
   3.490695402610713*^9, 3.4906955779347887`*^9, 3.490696039376266*^9, 
   3.4906975318410463`*^9, 3.490697868281663*^9, 3.4907020675956917`*^9, 
   3.4907041807122593`*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605021690888*^9, 
   3.490605740124065*^9, 3.49060719689602*^9, 3.490607398522768*^9, 
   3.4906074606189623`*^9, 3.490609070036997*^9, 3.4906827374131727`*^9, 
   3.4906829760952797`*^9, 3.4906948872319593`*^9, 3.490695219082754*^9, 
   3.490695402610713*^9, 3.4906955779347887`*^9, 3.490696039376266*^9, 
   3.4906975318410463`*^9, 3.490697868281663*^9, 3.4907020675956917`*^9, 
   3.49070418113456*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605021690888*^9, 
   3.490605740124065*^9, 3.49060719689602*^9, 3.490607398522768*^9, 
   3.4906074606189623`*^9, 3.490609070036997*^9, 3.4906827374131727`*^9, 
   3.4906829760952797`*^9, 3.4906948872319593`*^9, 3.490695219082754*^9, 
   3.490695402610713*^9, 3.4906955779347887`*^9, 3.490696039376266*^9, 
   3.4906975318410463`*^9, 3.490697868281663*^9, 3.4907020675956917`*^9, 
   3.4907041815433817`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["own fitting Ak Bk",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905972003333693`*^9, 3.4905972025222683`*^9}, {
  3.490685182278037*^9, 3.490685187214841*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"EcohAknBkn", "=", 
   RowBox[{"Ecohesion", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EvacAknBkn", "=", 
   RowBox[{"Evacancy", "[", 
    RowBox[{"Akn", ",", "Bkn"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp11AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[Sigma]hcp33AknBkn", "=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp11AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "1", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp12AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "2", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp13AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp33AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"3", ",", "3", ",", "Akn", ",", "Bkn"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Chcp44AknBkn", "=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"4", ",", "4", ",", "Akn", ",", "Bkn"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490531084065048*^9, 3.490531131962385*^9}, {
  3.490531285559321*^9, 3.4905313367468033`*^9}, {3.490531589938838*^9, 
  3.490531593206221*^9}, {3.4905316243781567`*^9, 3.490531631619998*^9}, {
  3.490535272081443*^9, 3.4905352888810997`*^9}, {3.4905841906861362`*^9, 
  3.490584233669372*^9}, {3.490596146553184*^9, 3.490596194876034*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]2", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"\[Rho]", "[", "Bk", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cond", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"20", ",", "Ev", ",", "Evac"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "Ec", ",", "Ecoh"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "\[Rho]0", ",", "\[Rho]2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1000", ",", "\[Sigma]11", ",", "\[Sigma]hcp11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1000", ",", "\[Sigma]33", ",", "\[Sigma]hcp33"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "C11", ",", "Chcp11"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "C12", ",", "Chcp12"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "C13", ",", "Chcp13"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"100", ",", "C33", ",", "Chcp33"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalDelta]", "[", 
   RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
  RowBox[{"Sum", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"cond", "\[LeftDoubleBracket]", 
      RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
     RowBox[{"Abs", "[", 
      RowBox[{
       RowBox[{"cond", "\[LeftDoubleBracket]", 
        RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], "-", 
       RowBox[{
        RowBox[{"cond", "\[LeftDoubleBracket]", 
         RowBox[{"i", ",", "3"}], "\[RightDoubleBracket]"}], "[", 
        RowBox[{"Ak", ",", "Bk"}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"i", ",", 
      RowBox[{"cond", "//", "Length"}]}], "}"}]}], "]"}]}]}], "Input",
 CellChangeTimes->{{3.490643019009325*^9, 3.490643169578643*^9}, {
   3.490643244940384*^9, 3.490643247481134*^9}, {3.490683779881062*^9, 
   3.4906838352630033`*^9}, {3.490683866928054*^9, 3.490684087632958*^9}, {
   3.490684243155375*^9, 3.490684288973646*^9}, {3.490684357386228*^9, 
   3.490684412306068*^9}, {3.4906844619068193`*^9, 3.490684478240546*^9}, {
   3.490684511454245*^9, 3.490684522656653*^9}, {3.4906846725969553`*^9, 
   3.490684686714307*^9}, {3.4906848045794477`*^9, 3.4906848388563843`*^9}, {
   3.490685202790991*^9, 3.49068520386957*^9}, {3.490692220776795*^9, 
   3.4906922276427794`*^9}, 3.4906932242866077`*^9, {3.4906933307243*^9, 
   3.4906934101505747`*^9}, {3.4906934468740187`*^9, 3.490693500360262*^9}, {
   3.490693824314776*^9, 3.49069382995024*^9}, {3.490693861376396*^9, 
   3.4906938649797707`*^9}, {3.490693988521154*^9, 3.490693998453233*^9}, {
   3.490694048142919*^9, 3.490694049966158*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[CapitalDelta]", "[", 
  RowBox[{"Ak", ",", "Bk"}], "]"}]], "Input",
 CellChangeTimes->{{3.490693243789557*^9, 3.490693246837948*^9}}],

Cell[BoxData["295.9052157189501`"], "Output",
 CellChangeTimes->{
  3.490693247192143*^9, {3.49069342751346*^9, 3.490693501506461*^9}, 
   3.490693831109091*^9, 3.490693866604005*^9, 3.490693999487503*^9, 
   3.490694051780554*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"sol", "=", 
  RowBox[{"FindMinimum", "[", 
   RowBox[{
    RowBox[{"\[CapitalDelta]", "[", 
     RowBox[{"Ak", ",", "Bkn"}], "]"}], ",", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Bkn", ",", "Bk"}], "}"}], "\[Transpose]"}], ",", 
    RowBox[{"Method", "\[Rule]", "\"\<ConjugateGradient\>\""}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"sol", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.490643156054881*^9, 3.490643159034882*^9}, {
   3.490643260209673*^9, 3.4906432701210737`*^9}, {3.490643351293874*^9, 
   3.490643358455317*^9}, {3.490643389002624*^9, 3.49064339000261*^9}, {
   3.4906434618493357`*^9, 3.4906434649979067`*^9}, 3.490643612805534*^9, 
   3.4906436953170767`*^9, {3.490643744484124*^9, 3.490643786755353*^9}, {
   3.490643862890205*^9, 3.4906439177021303`*^9}, {3.490643982750721*^9, 
   3.4906440148474007`*^9}, {3.490684111103736*^9, 3.4906841395515823`*^9}, {
   3.490692104246037*^9, 3.4906921180392933`*^9}, {3.4906932777658167`*^9, 
   3.490693313439727*^9}, {3.4906939112001057`*^9, 3.490693919630228*^9}, {
   3.490693970298414*^9, 3.490693970448399*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindMinimum", "::", "\<\"lstol\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The line search decreased \
the step size to within the tolerance specified by AccuracyGoal and \
PrecisionGoal but was unable to find a sufficient decrease in the function. \
You may need more than \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(MachinePrecision\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" digits of working precision to \
meet these tolerances.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/FindMinimum/lstol\\\", ButtonNote -> \
\\\"FindMinimum::lstol\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.4906932866076097`*^9, 3.49069335591403*^9}, {
   3.490693388612349*^9, 3.490693411206339*^9}, {3.4906934559547777`*^9, 
   3.490693502308758*^9}, 3.490693831944363*^9, 3.4906938673547573`*^9, 
   3.49069392082487*^9, {3.490693970803639*^9, 3.490694000098221*^9}, 
   3.490694052768445*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"275.97141562627496`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"BB", "[", "1", "]"}], "\[Rule]", "9.021258371090589`"}], ",", 
     RowBox[{
      RowBox[{"BB", "[", "2", "]"}], "\[Rule]", 
      RowBox[{"-", "0.36526341721708033`"}]}], ",", 
     RowBox[{
      RowBox[{"BB", "[", "3", "]"}], "\[Rule]", 
      RowBox[{"-", "172.2844561011786`"}]}], ",", 
     RowBox[{
      RowBox[{"BB", "[", "4", "]"}], "\[Rule]", "335.3882478752012`"}], ",", 
     RowBox[{
      RowBox[{"BB", "[", "5", "]"}], "\[Rule]", "466.90614342913256`"}]}], 
    "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4906431601336308`*^9, 3.490643172741291*^9}, 
   3.490643250124601*^9, {3.4906433628513937`*^9, 3.490643391243864*^9}, 
   3.4906434664014482`*^9, 3.490643615091484*^9, 3.4906436994722967`*^9, {
   3.490643758341464*^9, 3.4906437880101557`*^9}, {3.49064387673573*^9, 
   3.490643921225979*^9}, {3.490644000792593*^9, 3.490644017942342*^9}, {
   3.490684128191429*^9, 3.4906841408210287`*^9}, 3.4906842919871063`*^9, {
   3.490684375246505*^9, 3.4906844139884853`*^9}, 3.490684481188066*^9, 
   3.4906845249161*^9, {3.490684675899405*^9, 3.490684690431281*^9}, {
   3.4906848105441103`*^9, 3.490684840652164*^9}, 3.490685205731135*^9, {
   3.490692113149164*^9, 3.490692120828258*^9}, 3.490692232811607*^9, 
   3.490693229035254*^9, {3.49069328712514*^9, 3.490693355921921*^9}, {
   3.490693388620224*^9, 3.490693411220599*^9}, {3.490693455969014*^9, 
   3.4906935023165483`*^9}, 3.490693831958721*^9, 3.490693867368968*^9, 
   3.490693920998008*^9, {3.490693970817862*^9, 3.490694000112653*^9}, 
   3.490694052782776*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"original", " ", "Ak", " ", "Bk"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ak", ",", "Bk"}], "}"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Ak", ",", "Bkn"}], "}"}], "/.", "sol"}]}]}]], "Input",
 CellChangeTimes->{{3.4905966282017813`*^9, 3.490596629747342*^9}, {
  3.490596758734058*^9, 3.490596759490575*^9}, {3.4905971737634087`*^9, 
  3.490597182576355*^9}, {3.490684150776741*^9, 3.490684163899651*^9}, {
  3.490692127904565*^9, 3.4906921303468924`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.5206578`", ",", 
     RowBox[{"-", "0.5010806`"}], ",", 
     RowBox[{"-", "24.7980243`"}], ",", "61.6497601`", ",", "50.4873763`", 
     ",", "130.`", ",", "65.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9.0326709`", ",", 
     RowBox[{"-", "0.3592506`"}], ",", 
     RowBox[{"-", "172.2824142`"}], ",", "335.3887858`", ",", 
     "466.9061887`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.4906062092523003`*^9, 3.490681178826795*^9, 
   3.490684164461582*^9, 3.4906842942560377`*^9, {3.49068439515668*^9, 
   3.490684415909655*^9}, 3.49068448241432*^9, 3.49068452551554*^9, {
   3.4906846764857407`*^9, 3.490684690793356*^9}, 3.49068481145085*^9, 
   3.490684841608758*^9, 3.490685206636512*^9, {3.4906921230083447`*^9, 
   3.4906921307482233`*^9}, 3.490692234173491*^9, 3.490693235073159*^9, 
   3.490693316383456*^9, 3.490693357212566*^9, 3.490693391045405*^9, {
   3.490693430739903*^9, 3.4906935032537737`*^9}, 3.4906938343783703`*^9, 
   3.4906939260439367`*^9, 3.490693971685842*^9, 3.490694003437899*^9, 
   3.490694059241147*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.5206578`", ",", 
     RowBox[{"-", "0.5010806`"}], ",", 
     RowBox[{"-", "24.7980243`"}], ",", "61.6497601`", ",", "50.4873763`", 
     ",", "130.`", ",", "65.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9.021258371090589`", ",", 
     RowBox[{"-", "0.36526341721708033`"}], ",", 
     RowBox[{"-", "172.2844561011786`"}], ",", "335.3882478752012`", ",", 
     "466.90614342913256`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.490596630085451*^9, 3.490596726177747*^9, 3.4905967599028807`*^9, {
   3.4905969945691833`*^9, 3.490597004368078*^9}, 3.490597037316327*^9, 
   3.490598136808795*^9, 3.4906062092523003`*^9, 3.490681178826795*^9, 
   3.490684164461582*^9, 3.4906842942560377`*^9, {3.49068439515668*^9, 
   3.490684415909655*^9}, 3.49068448241432*^9, 3.49068452551554*^9, {
   3.4906846764857407`*^9, 3.490684690793356*^9}, 3.49068481145085*^9, 
   3.490684841608758*^9, 3.490685206636512*^9, {3.4906921230083447`*^9, 
   3.4906921307482233`*^9}, 3.490692234173491*^9, 3.490693235073159*^9, 
   3.490693316383456*^9, 3.490693357212566*^9, 3.490693391045405*^9, {
   3.490693430739903*^9, 3.4906935032537737`*^9}, 3.4906938343783703`*^9, 
   3.4906939260439367`*^9, 3.490693971685842*^9, 3.490694003437899*^9, 
   3.490694059246484*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{
      RowBox[{"Evacancy", "[", 
       RowBox[{"Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{
      RowBox[{"Ecohesion", "[", 
       RowBox[{"Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{
      RowBox[{"\[Rho]", "[", "Bkn", "]"}], "/.", "sol"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"1", ",", "1", ",", "Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}],
     "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{
      RowBox[{"\[Sigma]hcp", "[", 
       RowBox[{"3", ",", "3", ",", "Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}],
     "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "1", ",", "Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}],
     "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "2", ",", "Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}],
     "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"1", ",", "3", ",", "Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}],
     "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"3", ",", "3", ",", "Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}],
     "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{
      RowBox[{"Chcp", "[", 
       RowBox[{"4", ",", "4", ",", "Ak", ",", "Bkn"}], "]"}], "/.", "sol"}]}],
     "}"}]}]}]], "Input",
 CellChangeTimes->{{3.490596804858758*^9, 3.4905968319531183`*^9}, {
  3.4906841989833097`*^9, 3.490684219287725*^9}, {3.490684430369829*^9, 
  3.490684439366281*^9}, {3.490684545903954*^9, 3.490684557314125*^9}, {
  3.490692140780703*^9, 3.490692178967556*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.25`", ",", "1.9398791455445519`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694060145151*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.74`", ",", "6.472088369900163`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694060214925*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"322.5619157597301`", ",", "316.347054242921`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694060333435*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.08252875155476037`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694060452819*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.08108291687287152`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694060520236*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.597`", ",", "4.155757929856692`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694064067341*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1684`", ",", "1.327510333320903`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694067829731*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0442`", ",", "1.210025256808041`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694071682149*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.9977`", ",", "3.9977002247534705`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694075483492*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1803`", ",", "1.197332994384274`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.490692179422365*^9, 
   3.490692235494441*^9, 3.490693317737035*^9, 3.490693358400288*^9, 
   3.4906933919073772`*^9, {3.4906934315637083`*^9, 3.490693505012755*^9}, 
   3.4906938363026237`*^9, 3.49069392773388*^9, 3.490693972454027*^9, 
   3.490694004391354*^9, 3.490694079346299*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"V", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
       RowBox[{"2", " ", 
        RowBox[{"D\[Rho]", "[", "Bkn", "]"}], 
        RowBox[{"\[CapitalPhi]", "[", 
         RowBox[{
          RowBox[{"a0", " ", "r"}], ",", "Bkn"}], "]"}]}]}], "/.", "sol"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0.5", ",", "2"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "5"}], ",", "10"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.490596881267724*^9, 3.490596901214881*^9}, {
   3.490681365445443*^9, 3.4906813694177628`*^9}, {3.490681482592225*^9, 
   3.490681497081016*^9}, {3.490684313089698*^9, 3.490684319606329*^9}, {
   3.490693684899384*^9, 3.490693694167171*^9}, 3.490693817575776*^9}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxNmnk01G3YxyXZiewRylaolDbSXBOStVBCCZVHCSFUlmRLEkWWJERRyr5k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     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJxNmnk01H/0/1VCEsmSKGtKKEIlMXdCkigqUQnFB6GQyB4lW4jsQoRSimQr
qTfZlyzZmSm7iZkxGLsZ39fvd77n+PqD8zj3vu593uX1fs+cQ+K206X/NrOw
sCihX//v74eTvvWWOpPA8v9/9uMj712qyTo7CRaeY3FWZCn8bqZe8v3zk3Cr
pm0kv0gKnx6h5YS/OAmaVzLWbvhK4Qs/qOwhXJ2Eh/3HdH/zSOF7JwXv8tlM
gvD4VtMjJyXxUrYD/I8DJ6FpjGvILFUc/8XC2tqichJU2kTS8i+J4Fn2cfAK
10zCg8lSp2+rwvhz/bnfO+snoWSbVZVDtjC+/8qcoF7bJMw81QgtXdmDXz33
uEHl7yQEFfz3dfKDEB6nkn6EkzEJi3WxTFUFQXzQjNZANcsU2IWZNmkPC+Bb
8yaCH7FOQT97iPdUnADe8pDCEH37FGy9HSDKvs6PDxD9EfNXeApM2yDJppcP
X81BWCpSnYKsYEYRvOXFc9U+ynZSn4IRw6IXBVa8eOMnUpdk8VPA8ky5uEic
Fz/OsM99dXYKxP2HLR1TduLZ55Zvhl1F8a42rIgf48HrEXdXWTyYAr/p3ep6
t7fj2wsuR3B+mgIaC1k+LogVXybNdUuwaAoed/H+IAmx4rOSqlUkv0xBVPRm
svWHLXj3gGOEkxVTsMfNb7mtezNe2Gi33J22KVjsc+3TP7kJb03rr6+jTYHM
qX9aizZrYGAdk9JBn4I8eaFbp/NX4Xjveee/Syhf9Pvo3OUV4Kgo373IQgZu
qbsjHbHL8PF5ms0BXjLkaETriI4uwMKR26xPj5LByzKW/m9kBv6+Fu6NOkYG
PNn/XbX+DNQLduSmnCSDZnTa+chSGiQztS4XnSaDh2SlSLX0NECL9OsRIzKM
Pr/A41AxCSF3/4HmfTKEqDDuf8keBpehDL4L7mSYPcCmY/95CK4bX5+45kUG
+Xiutwk/B+GwRlOky2MyhPvMrCf2E+E310di+gsyNM+e4hnr7gaRD87e659R
vFd2m0GgGi6Fiq3XlCD9vb26awaVEGbT8ji8jAyDAhIHt0t9hyVx+bA9P8nQ
JqNUbOryGbrjJhKV28lo36vmQs0eYdyu8XtXOslQ4bwon+/0EjtjeCa9opcM
O4+eL3W88RYr4sx8azBIBl2ihOUQfzH24pF5ie00GVh9Y7wWvKqwRrMdakfm
yKB/ty+9M60G26RW/p2+QAYZcrPCga91mDN9T00Akwymzcu3XdubMIM7XR0v
d1AgcPZZ5P2Gdozjsv5MqxwFBn6PTV4o7sXwiqsP4hUocHdx+97gR33Ywx3v
l8yUKVBxa8uXxDP92HgdO8ukGgXS81lFnWsGsCr1Km5WPQqIhLyVYI/7g63s
uf+i0YACM+fyZCThL6a0KC4YbUQBLKbKzWbsL5Ze4LdP9BpiBYLtuZhBzO+A
mryqHQXWU3duOvdjCCvZ8i+f6UCBPENPs2DWYYwymKBc44T0TATrbj43jJm9
nFe79JACJF6bhsrmYezkzoJzjkEUcItoPzyHjWDOFItfSmEUyIrhb8lYGsFy
GrmNliOQftEUcpHCKCb41NE0KI4Cb/l0X+5NGsXoywdt07MocOXNDz/fa2NY
c8QU75ccCiRPvQoODB3DsiTyy1s/UIBLrsatp3QMMz53fNd6EQX6Xx5y8uIZ
x44Ql8sFv1KgsoXnaI/qOMbm8t32yHcKaDODzyRZjmMlidrfb9ZQ4I6xT4dN
7jgWKc9h59ZAgSHfV1setYxjNhVNuyJ+UYCe/XpOgDaOCZIu2ZV3UYBjPt6/
78gERvUW5Ovso4DDPoXOXfoTWC1P//cpIgVoOvNXRm0nsIcnbvGJjFPg+qtr
5++8nMAMm/b/UJpE/WxNe3iocAKTsSDZ6VEp0L3FEveyYQJjmcvluz1LAeo3
2kr1nwmsN8jph+cCBWQ8sjg+zk5gn4SV70SvUED9a8vPa1tJWEjeAt87JgWs
WaoC2wVJmGq3751eNipMZZhEnDpOwnban+ancVLBipEWpqZNwkgMVoydhwqa
lsy1fUYkrCK6/o4YHxW6zzcA2YyEJUmH85/YTQUL/OW8XFsSdv/rReyCCBW8
fkxn3nYhYXoGfPY2YlQI15n13u1FwiSHuvn9pKhw81pedFsACVt5kIzFHaSC
ycOH+NgQEvabw9z+oxwVxsQzRuwiSdj7FAmBGgUqiPf4dV+JIWGPFccwgjIV
Pu6xfmCeQMKuV+fY009QQcQ+Syg8mYQpmToKcKlTwV43RnQ0hYRxkhUqpPBU
oKkEDjmmkbDhR3P2p7Sp0PypsVz+FQn7xlcqcFmXCsfVy7bLIo5961Vhr0+F
lyZvDjkgf8dTOIfHhlTQDhx2WUDxtFs3CSZfoYL66Z/wG+Xba1VTUWBKBUne
JCprIgmjL4Q4NJhRoeZ+WV9sLAlrDtMXHLJEeiY8zUKiSFiW6M7KJWsqMKZl
f489I2E+nzscdt6hgiOXRHxhEAm7opMgKHOXCqrf87cs+ZMw+f7rleBChfIn
su5fUf+Im4YFnTypwGmk1NPsSMJK4rIrg3ypANdtfOT+I2GRh+44pgVQIcCr
M0b8JgnDGdEqf4VSobPo0b6J8yRMcKzQcSyCCoElsturNEkY1ePhbkY0FbDe
bF+9kyQsLZ3pKJ9MBd7/HAYdpUnY+jSX0LP3VNjX2iTjvjKBxRd4Jz/Po0K/
u/Gp69MT2BHXyb2xn6nANO9y3TE6gZkt1EmkllEhA+LMZponsK9rj+XyG6nQ
dkfyuFjqBOa6bRnXMUmF0th7+uJqE9iE5Nh/InLTcP/4Q+33DuNYq/H3wtzc
aSgTGjsR+GEUK/KXHLfPRzwxtqkxbRRLzg0Wki2cBl/93MSt0aOY9aZLvjll
09DlRZY0dxvFVj6M62Q3TMPz/v22sRqj2AHWnf1pE9MwpmUUx9c8gsG1oywN
vDQ4EV6MnR8axhLYAw+UG9Dg/p0XW/eRB7HrS/jL1RdpIG572MuyfxAT/cd4
1GxEA7spUEuoH8SyGh/2EYxpIPMzMupP1iD2KcIhnHGTBuoHZfGdZoNYPd/l
Wdw95F+/e60g9i+2Iib5ozKSBlHCVgr4E0Ts+86/kw1RNEg/+n3SYScR89+U
svv3Cxp84pFkv/uPgLGNCLgMx9Ngp1WZxXAyAeN7s23/llc00D30zwO3OoDJ
y8+EaufToNf2VexIXj9mrlphXNdKg5Dztlll3T1Y/U2P/g/tNBg04TlV/a4H
U3qiaPGigwYcsmzXwn16MPaWdLubPai+2zP8NyR6sE9WAd5zf2iguHJ8js2u
G9v8XDNDjIrscWd8T012Ym/GqskPuWYgKurNf0fr2jHKi4YnMudmoCLOaFZN
qBaLq7wTm9c8A/45ex5V2H0Cxb4AocKWGcCze9y9dKEAGmlJKaVtM8By60XJ
FeXPwBRrzKroROd1Bi6mrBaCjZ9s8W8C8nf8a94VWAqqp6a6FsiIPb9PE9x/
QH+R427YMQv4uaRZ08EaeNAc+FKLZxYGy7stKnVqgXs0RUyXdxbSbWe73n2o
BU2+XweNBJD90fHeOfc6yHU5rGq1bxYs/TYLnNraAD5HqKbBh2dBnKTgvIO9
GcRynJJbDWbBmS20t7yhDSzpj90LLs6Cv+i4kwetDV7j4y/FGM3CzpzOhRHB
dtjfV85pYozOK+1aqbvdDrKcnN5/zGaBJlA9mr/QDiqOWTcoDsie977CgrsD
3L6Unmi9i/RR9PqqFTqghLWJr8BpFgwPHfZpMeyAk6kzTQ9cZ0Hxi1Vwc3QH
4Fpw6mteyH//hZ8WPJ2gq9i3d3sYiteGgdZSJ4T6kJfIz2aBZTg38CVfFzTW
r3e2RCC7dxg1/EgXGNw6EPEiGtVj3WSiatUFl164MvYkIX1beZ+n1nVBzJ+g
vtVklG8bn3zu3y7olE0uJqag+jaba1xY7AKTqoq7GemoX50Xr5lLd4MZfccf
mRykd7H/3KRPN6TiJco4389C1IXmwxPR3fAnXCWenDsLn8TPD4a/6YZb0jcu
fMpH8adsbhFausHmas6PE6UoP//Ft60iPeD8RfOVTi2aZ0rGgPS7HthsOcht
VI/y1c4En/jWAzHsfn43GhEf+B2w81cPlFz9etO5Bc2jN6F0P60HGHSFvcnd
KL7G0xR5lV4IO7oviTKO2O55HWdJL+ztK+NYIiG9hg7/1dX0Qp6/qcfmKaQv
OFXcrqsX2ltjTHZPo3gT11Wu0ntB6B6n4OlFpO9JTMm4Yh9kv198Ecs+B/70
ZkNSVh8cvxS3+dW2OahQlRylfu6D+mWl+++2zwG+X/p9f0UfkHXvGf3gQawa
yXeb0AdKE6M8pN1zIO6pcVppVz9USP0OPyWD4rWPK0149EN/yoegYV0Ub2Wy
Zq/yAPB5nrnQqIfsHEFPVDQGQN/4j8Bn/Tmw5HerPX52AL7v2JkdYDgHg6Tv
/KvXByDdz7VK3HQOWAY2mQcGDICNpRqLhS2yh0WsZjcOwCv1jjqdOyj+Jatc
x44B6BVyfH7EAenbr/tTlDAA59pTRZn3UL6cjzfPUAZAXnOTRqo7Oh863ZXK
TYBZqXrPgadIv0no/hADAsix3DpdFYz8E/WGtxsTwJqwzJEbOgfp010kbzMC
dMXKJXpFIL2ZXzkkHAjwZevzkj1xyP9+uWhAMAH8JoznTLKQnhuTq1nlBCit
opbBG+TffXZk7icBaK+CHx/MQewqO6/QQIBbpl95F3NR/C5Km1MXAbQb9irG
F86B4YsHczwUAmzPHXHs/InqiS9X/yNEhP2il9I/VyOWJOWQ9xFBPbqiI6p2
DqJ8Gzr+SRLB8WGqmkEjqmeiL/mTPBFatEw4atuRPnvb2y5AhPGSmlNZHchu
/FB1UYsIzEMqTo+75uBTUtwJR10iKOzk7cb1IT1uh8aljIgQRWjMLB1Ees1H
PZpuESHn4smeuGGUn5Gyvfk/IlT8fMv5YBT5+5cfLb9DhJmcQBdF0hw4e5nd
dXAhwiU3HLybRnaxq4Ls/kQQ4P7cn8xEdrO/bbhkIhwJEOf2ZKHDoPXxLlwq
EXTokadNNtNB0Tb7tEI6Edz7HXL42Ohg+GoxeCibCL1vpN3Dd9Ah/edrXMQn
ItD2xL6z50HsP73IW0gEjojNRF1eOohXfXgSXEyEk65/tbYK0KFCJPvsmTIi
JEMSr99eOkSxVM1zVRHh82f2M2aiyN7QULKnhgiN0u4eauJ02Pk6qWh3HRFW
t1/+uyBFh7baipcTjUTgf1S5q0sa+R/Le/W1mQjyswo6hQfpYLkcJeDbQgSz
Xq6PTnJIb/Xt8N52Ijw47z1ocJgOeOrEW+cOIkT8+Mcnr0AH/8+R9iudRPiR
VetFUkJ6LtwVHukhQvfuY3m1Ksj/3ClJzT4iUMMyh7KOo/hSJmwx6PucmIu/
7i015P8tK5GTSIQQ8OSxU0f1nr5bce4P6seO+933cHRg2S8Q6PGXCNcI9qlu
eDrQDOPo8YNE+PneytpHE8UvGpfMHiKCrKeZ3BNt1G+1zeKZw0SIOWs8G6qD
9LcOrkWNEMF6VMc/QQ/F62tMUh8jwq/PcDZNH/X7QL33CuLjAarc2RfQ/FQc
A3LGiZB28WhXriGy0/K/6UwQgV1UNuXzJRRfJ/xUF2JnsqTV1ysonuQK7xUS
mmeZiGzFVeTvPHuxCvHpUP6ZWlNUr+g9Nql/RHhvsuPLr+uoX7ttdFwR8x1g
e9RphurR7RAvQuxDZ54ZMEfzSMt7M4Z49Oci17AlOr91hsQ+SQSDaFoH6Taq
907MkjDiEot/ydPWSG9J5LgoYtEjw7cWbBD3D1TxIQ5e65dh2KH+VrpmLKN4
tMaO6S0OaB9MLka1Ib6W1FzCeRf1J8Q2IxHxT9saX14nOjifLh4zQix7/Ie2
kAval3tH762hemJYS7eLuaLzjM7ziYjXfuf/lnZDensTn0sjts7ISZJ/iOqh
uOllof78csqwVPZE+g/9F8GP+Dgu+aCaN+KHFnfcUX9fccVQ8b6on9U3pxtQ
/zkGnhWffUSHT2umijyInd8F+lwIQPG49DR0RonQ99BXy/gJsg8dOuiE5qmp
485p9hTVazPDDEXzfs/v1H47GPU3NKkrHu2DT4GlhfMzdN7EqSoI7c/oo2sH
Hkag84TItTtovwwuXKL4Pkf1frrvAWj/RKe0vJ/FoH4s2PtUov2s3H8w4c1L
VH+vSZRUF+rHnJj5x1RkL+goS0b7/6JSSLroFdKvPpDP+hvVb85ZWJmJ9lfE
RaMA3R+2REoLIRfF75upvIfun5PNeNzIR5RfYuteP3Q/e1X+mk3mI/2PHOr9
0f191942uViI5qUgYGaJEUF/exEbXznKf1JQL6wE3UfuHOnF7+i8WNBZ8yL0
fORN0R7A0D7cLMo/+JkIz3YHPs6sQvblh4vJH9H9l7rCVG5C83FtG2fNIsI5
dfr8lX7kf97x6mwkEUyBxH+SgOppIbtLhRPBTpOgvO8Pqoef8EcvFN1H3WqX
sSFUzxblcp8nRKi/Ektx+4f8ZReP3HuInm93Vcbil1A+Lz+22JtEuOosw+q9
gvJdFBRQvE4EG9e9UhZraF8u/zpbdZUITz1Zbx1kmYcoZrVh60UiVD/tJJSy
z4P/Gx7XR6eJoJX2oLNXcB4qdn/h1JciAr61qEr42DzQXAL5FgcJkH5Y2f3g
iXlg2cZar0wgAEt4gYzKSXR+5eZeux4CVOrmRRhozEO6/Z/J0l8E0Pz51sT/
zDz6/IlxLnwlgFZx8tSY8TxY4j0LV6MIoPPSn6/AHcXLvBX79iQBDGz1rc5+
mQdnHRrN1HMAws3SA/TK5uFTX7CrtOsANBvRXxmUz4P4GUdRqiN636unEC5X
zMOg8guFB5YDoMdLNrasR/lvRe00Ru9/3W/PdD17Ub77Z0w8+AdAm6fpcO4S
8hfmPvv1Qz+ol55b4j65AIZ/tY/96uiDOUX+cPmCBfCQpcRHC/fCTz+3zU7K
i6C4wH8nkqcbri1kPmT/uAikFykXh9g74be06rDa/iVQDF1dfo0+v1ofslKI
yV4CDkVepeVrrfD96g3v06LLYPr1Yu42/iZQMJ18x5+xDIac0fVfg2vB7olO
j4bICnxgn/lY4/ITAm04VjbFrEBUk9xmnPF3+Lrv1vok/yp4lL8Y8WwvBvVi
l9VWwVWI6vuwyCwphgr9x4tFQqug7meeFZVSDPXemdN+e1dB1UJ+uc+2GHr7
xv7u2r8KHwKpU1vXi2Apzr5CTXkVtIPJ7b8UiuAE94OAMKNVcPzS5vfg5Wco
ZgZtkY1E5/8Lyck5lQ9hMxIxJ6JQPtOwKfK2fDAfLZc882IV0vuHeK725gFb
4+xpy/hVsHP755Xglgemceb+8WmrkOjx80J/wUdYkTvO2Jy/CrRzPVHeRz8A
/trYwkAripdnl7jtwjvg1/cP+te+CjIZn1UPSrwDEk5EcLFjFUz9eT/epedA
9H6jY7t6V4Ew/V+U28scGJ4ud9UdXIUitvbiB1Nv4WlQLK2Itgop2VOi+jFv
oLFQazKCdw3kT/MEqm/JAj+NorFovjXYG+M7c4eQCUp1+4fiBNagXE02+Gdx
JiT3b+1N3bMGpqwtr+ftMuHOpvqajxJrYNklN2jT/ho4Lupn/Dq6Bjs5MpOf
v88AnckrpjsuIX+OQzHxjDRYca25zHtlDULGEw0VvqVBHuPYRYGra9C2zbdH
2jMNBHl36+y7vgbOR/UVDy+kwtiJPuXDt9cAn5vJl01PgcCnN3kM7q/Bp7zs
U5u2vIRKcZva8BdrkJiyLSXcKgH2/m3fcy92Dfw9JwuVFBPAPVXj7sX4NVjK
SZDfz4gHeWEB/l3Ja6CYbXeblBAPiXzVtxIy1iA91bJlui0OfS+TZGR8WgOz
gUCRRsNYECcTlUtb1mBw1f+QTFA0eL8/F5zYhvoR7jHQciMauu2K+z1/rwH9
VQPz69FoCB8LD1DvXgPSbOg3sz9RsPTnVGslcQ30u5irv9SioK09yb6ZjPR+
lttjzhIJ/qXGGUOcDEhMKxFscQ8F+fbzIVNcDCCL7vmaIR8KPZOnnea5GcCh
nDezdSQEjoge0djGxwDFrIRpX6MQGAhk61MUYcCDCJ/svceC0feH0p3+cgxI
jzumlCT4FIYdPi6GHmbA6JIVSbkrECKeZv6JUWCAj4zVzauxgTD65fmHt8oM
CPFaNVDkD4RoMTvd1lMMKG/JaZMRfgJkspC/qD4DBi+mxn7CBUAiG4+tzAUG
mEl4kwK3BoCW+NYLSoYMYF2qk+pt9ofkyzMiOlcYkKXZLbxs5g9nyxpK75ox
IMqySEqO7RG8DvaaLndkgDO3wRfPZm8wlSSY34hggMwU34VfHO7w3vlXquZz
VO+fg3nZX92A8eMH4VA0Oj/w44m6gxu8vpFxfSmWAR4ZMQsZbQ+AHGtzNS6F
AXuZb5uVslzBn33GoDWXAfRDy/Wv77rAb+Ph8JKPDCCUlMYvHHIB6ayOptR8
VM+Ck/vKuDM04kvOORYywO7k1G9uK2fg9/I+s+0bA1j+fsnMqL0HOeStGlqN
DDBMNyAPsjnAitqit2wzij9Nn/kcaw8GoaQy3hYGyM/7XKmXsodZ6SbVwXY0
Tzd7ZvGZO6BuEaXi28cAx6TrofaJtmj+wvKlJAbwN4cmZj+0BklxLoe0SQao
XlJM6BKyBrd7jHdPyQzQ/5MlJ//NCoS3Dx68QkP9NVMePbPFCqy1s6VmFhlA
Unt6Yjn9FiyWKIjIsTNBtZXCniRhDrIpCzUc25igO17sLB52E8wCvjuPczIh
KpKt+w3dDCrOn6/N4GZCTvgX9szWGxAyaOMiJMgEU+50iZWUa1BWc3jvwm4m
hAdQQoQFrgH5Pb22Yw8THngUtIo+NwVDt8d7n+9jQtsU392aEBMQ4kyr2yrN
BMdvTzbJvzAGvWnr+yMHmPBFvNaPa48x+HTK7auUYQJ9zfFHccYVGEz7et9H
ngmjfBYLV75chhzlrn1zykxYeiZgZbtiBKo3uR4MajLB0CFrS2OqAdhrdoj+
0GaCZUjysNuQPqQcTG54qcOERHPe3zoy+sAye1DMRI8J/LJONeqYHtQHaTX+
MmIC1x9HpW+8urDiwOmWexnVYzfZ0H73LMgbtYuFGiM90dUnepp1IErEwk37
GhNUinw8Y2LOgOknL/FvlkxgHfBt4NPSgrC4002Jt5ngwXJbd6RYE8q9ONzd
rZH+935WDnKa6L0a33TUDvXn0UWjMNHTQOorcM9xYsLOtIxHYbo4EMY8JIJc
UL8859+dMNUA/SxotnJlAofs/cR/jurw6d4vCbGHqH/UymDpbDXw2PKvOc6P
CWZ6P4QeXzwBK1pq21P80TzDzg5SHxwH38Bn514/Rv5Xq2Z/vjoGj7ceqc0L
YkKFVm7pja0q8IzdFauLZEKs4r8Ve+6jwK1bzfgVhfQnFF4+fFMRokIE1Dtf
MCG9RWsq8ZYCxG778mUwHvV3YGtOabM8pG1nFCynMeFTPtudIl4ZENe/QFtP
Z4JikLK4+vIByAx/dYQtkwmEUU4bu3/SkLNDM3fXW9TP+EmR/SNSIHsh5p/Q
OyaIJ24/f48sCR8jRw+K5TLhig9H8G+GBHzmCc6Sy0f7ql+Xaa4qDiqGvcNH
C5gg1KgV/PinKJRGHZJQLWSCnRcf0UZqH5TzNqdql6J6ef6re8grDDV8vAk3
MSZocwT6HkzgB90rt7usKlE9RyuuXLrOB42xhXz2VUwg6RLU7svughaBq1Hu
dWgf/x22XBrkAcOrb1t8GpC96ZdXadMO6Ihf4nrShOY1P5t7vGU79O5+Gfq8
lQlZUS/0zgtxwHVTcl1cO9JX5lTUZM4GxEQNtpQOtC9JCYeHy1hheM/g45we
JvhMhuu8LdgE1tePVub1MaGX//sw/jwLTCQ/Xi8aQPlqV3ZE0Bg4soi0T+Vf
JoRgExU9/Mu4e2buZXVDKH/onv0UwgJuJqVu6dcI6pfHQkhQHR33gCh0onMM
5dcZmorsmMUt7LN3659A+/9O/dzMOg3nYf6tcPAfE5xLutWOJlBxK2lcs+NT
TPCXSG/4az+FWxfLvzc3zYT9NeG+RT/GcI8tWT4uz6B9JKjFBqmN4FgzjKbW
5xCX2j/YOTmICxp6fYhtAT0PnlYdNown4jgk6bZcS2ifehpJOqV9uLDbZ97s
WkHPD7z79gKlbtyOzPhRoTXkn24YrMbagYsamZAUYyLuGDV4frANt2v/yVvS
LOtg6OydUaLYhFNPerrIsXkdFNu63Tiptbj/uH9HkLesA2lTvkahVBUu8ono
/rat62BHvVNtGIfhvizZlxWyr4O+inLSz9KvuOG7pYYJ29bB46tI8/v0Itz2
kS0TXtvX4YHZU4Wl059wKqaGvuY71iFxLVNOWeQdzvxXCp8mzzrUT9e+Xp18
jQvR/PdOmncdhHLv/b6Q9xJXUHoMv40P5e9yOSsTHIPrl3/cTeZfB7NyDYKv
YRiO9XWLY5vgOsjcXhFL+eyPO7JbZEuR0DrEGhv1a4W44kzCbZMShJF9l/mN
3Zescf6bihS8966D6Uie/1ySEe69O0utueg6qF4z9ju3dAzXOaVvpim+DtVJ
Iz6M4G04hmXSrLTkOnT6qk/tsLDTONA9FrJt//r//j8DC4vheSUxivQGe1X4
Fbcd3ODMY03niw5t8IKYtYf34Q0Wj/vEbaGwwec4GVmaRzc4hR7Xvu3YBms2
1Mkmqm+wI46/0hu3wXGFliYW+A0mpS4/OaC9wZH35YhF5ze4X+T58/brG+x6
7yqd03ODhY5b1x/w3uByhkuKpu8Gs0VEaHsFbHBybnXsv9AN/klSOlafvMG7
rHjcn5ZvcKnsPr2MHxtsNisr+r1ig98E6NTSqzdYLd1X0PrXBt8mTpVo/tlg
9uzlMPPBDf7gyG7hNfx/+r8qyf55fIPDhK+bSExvsMKwrZzGzAZ3vnNbN53b
YNGT0W+jFje4iuWV94flDbar/3CxfnWDuaLKpEYZG1xgUr+4vr7B/wPUNamq

     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{{0.5, 2}, {-5, 10}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.490596904365493*^9, {3.490597014762521*^9, 3.4905970436979303`*^9}, 
   3.490598143113193*^9, 3.490606217827778*^9, 3.490681189456958*^9, {
   3.490681358387107*^9, 3.4906813714967623`*^9}, 3.490681499453601*^9, 
   3.490684326102716*^9, 3.4906845836664753`*^9, 3.490684880706687*^9, 
   3.490693536846686*^9, 3.490693700567081*^9, 3.490693954606995*^9, 
   3.490694039869647*^9, 3.4906940855285*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", 
     RowBox[{"Bkn", "/.", "sol"}]}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "50000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{"5", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906073941848*^9, {3.490607457034018*^9, 3.490607457133724*^9}, {
   3.4906090472738543`*^9, 3.490609057888105*^9}, {3.490609540881029*^9, 
   3.490609685293902*^9}, {3.49068185000086*^9, 3.490681882403051*^9}, {
   3.490684635164741*^9, 3.49068463662204*^9}, {3.490693712061521*^9, 
   3.490693713467339*^9}}],

Cell[BoxData["2814.709262206336`"], "Output",
 CellChangeTimes->{
  3.490609628027426*^9, 3.4906097644370317`*^9, 3.490681523053619*^9, {
   3.4906818520791473`*^9, 3.4906818830938663`*^9}, 3.490684588272149*^9, 
   3.4906846370135612`*^9, 3.490684884442452*^9, 3.4906935454362383`*^9, 
   3.490693713837699*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{
        RowBox[{"V", "[", 
         RowBox[{"r", ",", "Ak"}], "]"}], "/.", "sol"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{
        RowBox[{"\[CapitalPhi]", "[", 
         RowBox[{"r", ",", "Bkn"}], "]"}], "/.", "sol"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490681834690378*^9, 3.490681843677499*^9}, {3.490684647846023*^9, 
   3.490684651359775*^9}, {3.490693718064904*^9, 3.490693722645349*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"emb", "//", "Length"}]], "Input",
 CellChangeTimes->{{3.490681885708858*^9, 3.49068188899675*^9}}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.490681889694666*^9, 3.4906846535888844`*^9, 
  3.490684886625051*^9, 3.490693728921349*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_lowT_own_pair\>\""}], ",", "pair", ",", "\"\<Table\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_lowT_own_rho\>\""}], ",", "rho", ",", "\"\<Table\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_lowT_own_emb\>\""}], ",", "emb", ",", "\"\<Table\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490602297888136*^9, 
   3.490602307001584*^9}, {3.490602455546969*^9, 3.490602461254315*^9}, {
   3.490681529283904*^9, 3.49068153549925*^9}, {3.4906845978114023`*^9, 
   3.490684603875574*^9}}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_own_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.4906819096661*^9, 
   3.4906846055660257`*^9, 3.490684654599121*^9, 3.4906848878588257`*^9, 
   3.490693730398793*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_own_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.4906819096661*^9, 
   3.4906846055660257`*^9, 3.490684654599121*^9, 3.4906848878588257`*^9, 
   3.490693730873171*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_own_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.4906819096661*^9, 
   3.4906846055660257`*^9, 3.490684654599121*^9, 3.4906848878588257`*^9, 
   3.490693731307583*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[StyleBox["own fitting Rak Rbk",
 FontColor->GrayLevel[0.5]]], "Subsubsection",
 CellChangeTimes->{{3.4905972003333693`*^9, 3.4905972025222683`*^9}, {
  3.490685182278037*^9, 3.490685187214841*^9}, {3.490686626522375*^9, 
  3.490686628149129*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]2", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"\[Rho]", "[", "Bk", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Sigma]hcp11tmp", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Sigma]hcp33tmp", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"\[Sigma]hcp", "[", 
    RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Chcp11tmp", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Chcp12tmp", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Chcp13tmp", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Chcp33tmp", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Chcp44tmp", "[", 
    RowBox[{"Ak_", ",", "Bk_"}], "]"}], ":=", 
   RowBox[{"Chcp", "[", 
    RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.490531084065048*^9, 3.490531131962385*^9}, {
  3.490531285559321*^9, 3.4905313367468033`*^9}, {3.490531589938838*^9, 
  3.490531593206221*^9}, {3.4905316243781567`*^9, 3.490531631619998*^9}, {
  3.490535272081443*^9, 3.4905352888810997`*^9}, {3.4905841906861362`*^9, 
  3.490584233669372*^9}, {3.490596146553184*^9, 3.490596194876034*^9}, {
  3.490687313053204*^9, 3.49068748014287*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"cond", ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "Ev", ",", "Evac"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "Ec", ",", "Ecohesion"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "\[Rho]0", ",", "\[Rho]2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "\[Sigma]11", ",", "\[Sigma]hcp11tmp"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "\[Sigma]33", ",", "\[Sigma]hcp33tmp"}], "}"}]}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[CapitalDelta]", "[", 
    RowBox[{"a_", ",", "b_"}], "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Rak", "=", 
      RowBox[{"a0", " ", 
       RowBox[{"(", 
        RowBox[{"a", " ", 
         RowBox[{"par", "\[LeftDoubleBracket]", 
          RowBox[{"1", ";;", "7"}], "\[RightDoubleBracket]"}]}], ")"}]}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Rbk", "=", 
      RowBox[{"a0", " ", 
       RowBox[{"(", 
        RowBox[{"b", " ", 
         RowBox[{"par", "\[LeftDoubleBracket]", 
          RowBox[{"15", ";;", "19"}], "\[RightDoubleBracket]"}]}], ")"}]}]}], 
     ";", "\[IndentingNewLine]", 
     RowBox[{"Sum", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"cond", "\[LeftDoubleBracket]", 
         RowBox[{"i", ",", "1"}], "\[RightDoubleBracket]"}], 
        RowBox[{"Abs", "[", 
         RowBox[{
          RowBox[{"cond", "\[LeftDoubleBracket]", 
           RowBox[{"i", ",", "2"}], "\[RightDoubleBracket]"}], "-", 
          RowBox[{
           RowBox[{"cond", "\[LeftDoubleBracket]", 
            RowBox[{"i", ",", "3"}], "\[RightDoubleBracket]"}], "[", 
           RowBox[{"Ak", ",", "Bk"}], "]"}]}], "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", 
         RowBox[{"cond", "//", "Length"}]}], "}"}]}], "]"}]}], 
    "\[IndentingNewLine]", ")"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.49068664926368*^9, 3.4906866681615267`*^9}, {
   3.490686714174964*^9, 3.490686737248169*^9}, {3.490686781316324*^9, 
   3.490686782762982*^9}, {3.49068712510277*^9, 3.490687131806147*^9}, {
   3.490687249075383*^9, 3.490687285701445*^9}, 3.490687424150406*^9, {
   3.4906874573292627`*^9, 3.490687493931164*^9}, 3.490687529395212*^9, 
   3.490687747719949*^9, {3.490688128667756*^9, 3.4906881543145437`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[CapitalDelta]", "[", 
  RowBox[{"1", ",", "1"}], "]"}]], "Input",
 CellChangeTimes->{{3.490686796157612*^9, 3.490686798653126*^9}, {
  3.490687134287808*^9, 3.490687138263298*^9}, {3.490687211087919*^9, 
  3.490687227807541*^9}, {3.490687537471342*^9, 3.4906875375682783`*^9}}],

Cell[BoxData["3.156938793924616`"], "Output",
 CellChangeTimes->{
  3.4906867990651217`*^9, {3.490687135760919*^9, 3.490687138801635*^9}, {
   3.4906872115731163`*^9, 3.490687228138204*^9}, {3.4906875207008266`*^9, 
   3.490687541439454*^9}, 3.490687748965147*^9, 3.490688160273458*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"sol", "=", 
  RowBox[{"FindMinimum", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\[CapitalDelta]", "[", 
       RowBox[{"a", ",", "b"}], "]"}], ",", 
      RowBox[{".8", "<", "a", "<", "1.2"}], ",", 
      RowBox[{".8", "<", "b", "<", "1.2"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"a", ",", "1"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"b", ",", "1"}], "}"}]}], "}"}]}], 
   "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"sol", "=", 
   RowBox[{"sol", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], 
  ";"}]}], "Input",
 CellChangeTimes->{{3.490643156054881*^9, 3.490643159034882*^9}, {
   3.490643260209673*^9, 3.4906432701210737`*^9}, {3.490643351293874*^9, 
   3.490643358455317*^9}, {3.490643389002624*^9, 3.49064339000261*^9}, {
   3.4906434618493357`*^9, 3.4906434649979067`*^9}, 3.490643612805534*^9, 
   3.4906436953170767`*^9, {3.490643744484124*^9, 3.490643786755353*^9}, {
   3.490643862890205*^9, 3.4906439177021303`*^9}, {3.490643982750721*^9, 
   3.4906440148474007`*^9}, {3.490684111103736*^9, 3.4906841395515823`*^9}, {
   3.490686764017639*^9, 3.490686767558675*^9}, {3.49068760109855*^9, 
   3.490687623205826*^9}, {3.4906877126345778`*^9, 3.490687724301729*^9}, {
   3.490687785293809*^9, 3.490687787411173*^9}, {3.49069143598638*^9, 
   3.490691445405157*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindMinimum", "::", "\<\"eit\"\>"}], 
  RowBox[{
  ":", " "}], "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The algorithm does not \
converge to the tolerance of \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(4.806217383937354`*^-6\\), \\\
\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" in \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(500\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" iterations. The best estimated \
solution, with feasibility residual, KKT residual, or complementary residual \
of \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\({19.999999999999996`, 0.`, \
8.36983425454217`}\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\", is \
returned.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\
\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/FindMinimum\\\", ButtonNote -> \
\\\"FindMinimum::eit\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.4906877342906637`*^9, 3.490687775178754*^9, 
  3.490687814534068*^9, 3.490688245744055*^9, 3.490691534632807*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.1569387939235067`", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "1.`"}], ",", 
     RowBox[{"b", "\[Rule]", "1.`"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.4906431601336308`*^9, 3.490643172741291*^9}, 
   3.490643250124601*^9, {3.4906433628513937`*^9, 3.490643391243864*^9}, 
   3.4906434664014482`*^9, 3.490643615091484*^9, 3.4906436994722967`*^9, {
   3.490643758341464*^9, 3.4906437880101557`*^9}, {3.49064387673573*^9, 
   3.490643921225979*^9}, {3.490644000792593*^9, 3.490644017942342*^9}, {
   3.490684128191429*^9, 3.4906841408210287`*^9}, 3.4906842919871063`*^9, {
   3.490684375246505*^9, 3.4906844139884853`*^9}, 3.490684481188066*^9, 
   3.4906845249161*^9, {3.490684675899405*^9, 3.490684690431281*^9}, {
   3.4906848105441103`*^9, 3.490684840652164*^9}, 3.490685205731135*^9, 
   3.490686865818904*^9, 3.490687576262657*^9, {3.490687709674765*^9, 
   3.490687734279984*^9}, 3.490687775194909*^9, 3.490687814548601*^9, 
   3.490688245758304*^9, 3.4906915346825123`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"{", 
  RowBox[{"Rak", ",", "Rbk"}], "}"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rak", "=", 
   RowBox[{
    RowBox[{"a0", " ", 
     RowBox[{"(", 
      RowBox[{"a", " ", 
       RowBox[{"par", "\[LeftDoubleBracket]", 
        RowBox[{"1", ";;", "7"}], "\[RightDoubleBracket]"}]}], ")"}]}], "/.", 
    "sol"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Rbk", "=", 
   RowBox[{
    RowBox[{"a0", " ", 
     RowBox[{"(", 
      RowBox[{"b", " ", 
       RowBox[{"par", "\[LeftDoubleBracket]", 
        RowBox[{"15", ";;", "19"}], "\[RightDoubleBracket]"}]}], ")"}]}], "/.",
     "sol"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"{", 
  RowBox[{"Rak", ",", "Rbk"}], "}"}]}], "Input",
 CellChangeTimes->{{3.4906879048261547`*^9, 3.490687918536358*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"5.3531348619`", " ", "a"}], ",", 
     RowBox[{"4.8743978640000005`", " ", "a"}], ",", 
     RowBox[{"3.7782770445`", " ", "a"}], ",", 
     RowBox[{"3.1981676222999997`", " ", "a"}], ",", 
     RowBox[{"2.8412946975`", " ", "a"}], ",", 
     RowBox[{"2.65039862598`", " ", "a"}], ",", 
     RowBox[{"2.62389463917`", " ", "a"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"5.3531348619`", " ", "b"}], ",", 
     RowBox[{"4.6400517282`", " ", "b"}], ",", 
     RowBox[{"3.7801708329`", " ", "b"}], ",", 
     RowBox[{"3.2420004057`", " ", "b"}], ",", 
     RowBox[{"2.868354909`", " ", "b"}]}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.490687919003831*^9, 3.490691400149302*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "5.085478118805`", ",", "4.6306779708`", ",", "3.5893631922749996`", ",", 
     "3.0382592411849996`", ",", "2.699229962625`", ",", "2.517878694681`", 
     ",", "2.4926999072114997`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "5.3531348619`", ",", "4.6400517282`", ",", "3.7801708329`", ",", 
     "3.2420004057`", ",", "2.868354909`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.490687919003831*^9, 3.490691400185161*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"6", ",", "6", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"True", ",", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"3", 
         RowBox[{"\[Rho]", "[", "Bk", "]"}]}], ")"}], 
       RowBox[{"-", "1"}]], "<", "A", "<", 
      SuperscriptBox[
       RowBox[{"\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"-", "1"}]]}]}], "}"}], "  ", 
   RowBox[{"(*", " ", 
    RowBox[{"Ref", " ", "Vitek", " ", "text", " ", "following", " ", 
     RowBox[{"Eq", ".", " ", 
      RowBox[{"(", "8", ")"}]}]}], " ", "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.490596804858758*^9, 3.4905968319531183`*^9}, {
   3.4906841989833097`*^9, 3.490684219287725*^9}, {3.490684430369829*^9, 
   3.490684439366281*^9}, {3.490684545903954*^9, 3.490684557314125*^9}, 
   3.490687871976686*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.25`", ",", 
   RowBox[{"-", "1.0180943894074446`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.490691402025457*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"6.74`", ",", "3.491596502738833`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.49069140209789*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"322.5619157597301`", ",", "319.70124531612856`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.4906914022066727`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "3.2469149494013836`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.4906914023717947`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "4.0626118969522595`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.4906914024315434`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.597`", ",", 
   RowBox[{"-", "48.62363325702758`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.490691405522551*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.1684`", ",", 
   RowBox[{"-", "16.264407728553532`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.490691408873674*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0442`", ",", 
   RowBox[{"-", "17.044471058476145`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.490691412186863*^9}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.490691413223329*^9}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.4906914134310293`*^9}],

Cell[BoxData["$Aborted"], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.490691413565237*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "True"}], "}"}]], "Output",
 CellChangeTimes->{
  3.4905968442930202`*^9, {3.490596995550303*^9, 3.490597004771104*^9}, 
   3.490597038765625*^9, 3.490598137903737*^9, 3.490606211737602*^9, 
   3.490681181289633*^9, {3.490681338743753*^9, 3.490681350017335*^9}, 
   3.490684167402297*^9, {3.4906842098261633`*^9, 3.4906842196655273`*^9}, 
   3.4906842957114162`*^9, {3.490684396389071*^9, 3.490684417141768*^9}, 
   3.4906844834649487`*^9, 3.490684526766655*^9, 3.490684557616481*^9, {
   3.490684681023472*^9, 3.4906846912464933`*^9}, {3.490684812237115*^9, 
   3.4906848422200327`*^9}, 3.490685207285541*^9, 3.4906878730485888`*^9, 
   3.490687923715263*^9, 3.490691413637295*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"V", "[", 
      RowBox[{
       RowBox[{"a0", " ", "r"}], ",", "Akn"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"r", ",", "0.5", ",", "2"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "5"}], ",", "10"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.490596881267724*^9, 3.490596901214881*^9}, {
  3.490681365445443*^9, 3.4906813694177628`*^9}, {3.490681482592225*^9, 
  3.490681497081016*^9}, {3.490684313089698*^9, 3.490684319606329*^9}, {
  3.490688025963562*^9, 3.49068803914322*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBWIQvcv2XHrC8n/2DFCg5Tf5pcRKBH9t3xN1+dUI/ib+
9iXa6xH8o8KC02P3I/hCKpaJqgz/4fzivLAvXJUIvoRZygm1agR/z9/COU61
CD5bb69LVSOCP2v1kSkvOxH8Qy+MTE/MQvCFkvnLWvcg+Nu1ZL0W7kPwYz5p
ye09gOAva3Q79uUIgm+1oFYs5SyCn3T39Tanewg++9KfXXEPEPw1OezxVY8Q
/G+/ldg3PUPwu6SiwhXfI/j6j9K1bT8i+FdWlv6P+Izgy1lOXD7hO4J/mGF+
9ZqfCH7GiTX+J34j+DwTdik/+Yvgbww/8f3/fwQfAAdOf9g=
     "]]}, 
   {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJxNmnk01P8X/xWyJFkiKvuaFKI+Et2xZFdKRRKSUJGlkjYJlUJJyJ6dUiJE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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{{0.5, 2}, {-5, 10}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], Automatic}]], "Output",
 CellChangeTimes->{
  3.490596904365493*^9, {3.490597014762521*^9, 3.4905970436979303`*^9}, 
   3.490598143113193*^9, 3.490606217827778*^9, 3.490681189456958*^9, {
   3.490681358387107*^9, 3.4906813714967623`*^9}, 3.490681499453601*^9, 
   3.490684326102716*^9, 3.4906845836664753`*^9, 3.490684880706687*^9, 
   3.490688042440645*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", 
     RowBox[{
      RowBox[{"b", " ", "Bk"}], "/.", "sol"}]}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "50000"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{"5", "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906073941848*^9, {3.490607457034018*^9, 3.490607457133724*^9}, {
   3.4906090472738543`*^9, 3.490609057888105*^9}, {3.490609540881029*^9, 
   3.490609685293902*^9}, {3.49068185000086*^9, 3.490681882403051*^9}, {
   3.490684635164741*^9, 3.49068463662204*^9}}],

Cell[BoxData["2838.234458376046`"], "Output",
 CellChangeTimes->{
  3.490609628027426*^9, 3.4906097644370317`*^9, 3.490681523053619*^9, {
   3.4906818520791473`*^9, 3.4906818830938663`*^9}, 3.490684588272149*^9, 
   3.4906846370135612`*^9, 3.490684884442452*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{
        RowBox[{"V", "[", 
         RowBox[{"r", ",", 
          RowBox[{"a", " ", "Ak"}]}], "]"}], "/.", "sol"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{
        RowBox[{"\[CapitalPhi]", "[", 
         RowBox[{"r", ",", 
          RowBox[{"b", " ", "Bk"}]}], "]"}], "/.", "sol"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490681834690378*^9, 3.490681843677499*^9}, {3.490684647846023*^9, 
   3.490684651359775*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"emb", "//", "Length"}]], "Input",
 CellChangeTimes->{{3.490681885708858*^9, 3.49068188899675*^9}}],

Cell[BoxData["10001"], "Output",
 CellChangeTimes->{3.490681889694666*^9, 3.4906846535888844`*^9, 
  3.490684886625051*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_lowT_own_pair\>\""}], ",", "pair", ",", "\"\<Table\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_lowT_own_rho\>\""}], ",", "rho", ",", "\"\<Table\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", 
    "\"\<_Vitek_lowT_own_emb\>\""}], ",", "emb", ",", "\"\<Table\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490602297888136*^9, 
   3.490602307001584*^9}, {3.490602455546969*^9, 3.490602461254315*^9}, {
   3.490681529283904*^9, 3.49068153549925*^9}, {3.4906845978114023`*^9, 
   3.490684603875574*^9}}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_own_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.4906819096661*^9, 
   3.4906846055660257`*^9, 3.490684654599121*^9, 3.4906848878588257`*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_own_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.4906819096661*^9, 
   3.4906846055660257`*^9, 3.490684654599121*^9, 3.490684888410058*^9}],

Cell[BoxData["\<\"Ru/Ru_Vitek_lowT_own_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605936718936*^9, 
   3.490609774613768*^9, 3.490681536832469*^9, 3.4906819096661*^9, 
   3.4906846055660257`*^9, 3.490684654599121*^9, 3.490684888793282*^9}]
}, Open  ]]
}, Closed]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Be Vitek                   ",
 StyleBox["Ref. Igarashi, Khantha, and Vitek,  Phil. Mag. B 63 (1991) 603",
  FontColor->GrayLevel[0.5]]
}], "Subsubsection",
 CellChangeTimes->{{3.484926549703*^9, 3.48492658694*^9}, {
   3.490167823990555*^9, 3.490167824413797*^9}, 3.49016965353773*^9, {
   3.4901701650351543`*^9, 3.4901701660612698`*^9}, {3.4901918578920527`*^9, 
   3.490191865038221*^9}, {3.490207037575309*^9, 3.490207040873612*^9}, {
   3.4904974591870117`*^9, 3.4904974670349417`*^9}, {3.490552380932757*^9, 
   3.490552381426475*^9}, {3.490597280653537*^9, 3.4905972810172*^9}, {
   3.49060166054762*^9, 3.49060166624483*^9}, {3.4906025043567657`*^9, 
   3.490602505346787*^9}, {3.490604660850788*^9, 3.490604758771997*^9}, {
   3.490617168054706*^9, 3.49061717749221*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"str", "=", "\"\<Be\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"prop", "=", 
   RowBox[{
    RowBox[{
     RowBox[{"#", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
     "&"}], "/@", 
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Properties.dat\>\""}],
      "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"par", "=", 
   RowBox[{
    RowBox[{"Import", "[", 
     RowBox[{
     "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek.dat\>\""}], 
     "]"}], "//", "Flatten"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926591416*^9, 3.484926614764*^9}, {
   3.4901678313911877`*^9, 3.490167831966443*^9}, 3.490169648745202*^9, {
   3.490170184469874*^9, 3.490170184985085*^9}, {3.490191939857315*^9, 
   3.490191947008441*^9}, {3.490207047179237*^9, 3.490207055511044*^9}, {
   3.490349831434619*^9, 3.490349832612741*^9}, {3.490524695361081*^9, 
   3.4905247640974703`*^9}, {3.490535156349859*^9, 3.4905351607804403`*^9}, {
   3.490552393643462*^9, 3.4905524034713078`*^9}, {3.490598518763735*^9, 
   3.49059855741039*^9}, {3.490601674157384*^9, 3.490601674284174*^9}, {
   3.490601847355219*^9, 3.4906018748184958`*^9}, 3.490602517570265*^9, {
   3.490617182938068*^9, 3.4906171830961742`*^9}, {3.490617929610817*^9, 
   3.490617929759089*^9}, {3.490674888635396*^9, 3.4906748887985764`*^9}}],

Cell[TextData[StyleBox["WARNING: modifying embedding function",
 FontColor->RGBColor[1, 0, 0]]], "Text",
 CellChangeTimes->{{3.4906058547672*^9, 3.49060586552531*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "\[Rho]_", "]"}], ":=", 
  RowBox[{
   RowBox[{"Sqrt", "[", "\[Rho]", "]"}], 
   RowBox[{"(", 
    RowBox[{"1", "+", 
     RowBox[{"A", " ", "\[Rho]"}]}], ")"}], "  ", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"Ref", ".", " ", "Vitek"}], " ", "Eq", " ", 
     RowBox[{"(", "8", ")"}]}], " ", "*)"}]}]}]], "Input",
 CellChangeTimes->{{3.490610914916313*^9, 3.490610916449903*^9}, {
  3.4906109506729383`*^9, 3.4906109519747343`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
     "a0", ",", "cBya", ",", "Ec", ",", "Ev", ",", "\[Sigma]11", ",", 
      "\[Sigma]33", ",", "C11", ",", "C12", ",", "C13", ",", "C33", ",", 
      "C44", ",", "C66"}], "}"}], "=", "prop"}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rak", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"1", ";;", "7"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Ak", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"8", ";;", "14"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Rbk", "=", 
    RowBox[{
     RowBox[{"a0", " ", 
      RowBox[{"par", "\[LeftDoubleBracket]", 
       RowBox[{"15", ";;", "19"}], "\[RightDoubleBracket]"}]}], "+", 
     SuperscriptBox["10", 
      RowBox[{"-", "7"}]]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"to", " ", "avoid", " ", 
    RowBox[{"HeavisideTheta", "[", "0", "]"}]}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Bk", "=", 
   RowBox[{"par", "\[LeftDoubleBracket]", 
    RowBox[{"20", ";;", "24"}], "\[RightDoubleBracket]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"A", "=", 
    RowBox[{"par", "\[LeftDoubleBracket]", "25", "\[RightDoubleBracket]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"\[Rho]0", "=", 
    RowBox[{"1", "/", 
     RowBox[{"(", 
      RowBox[{"2", "A"}], ")"}]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Ref", ".", " ", "Vitek"}], " ", "text", " ", "following", " ", 
    RowBox[{"Eq", ".", " ", 
     RowBox[{"(", "8", ")"}]}]}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"cell", "=", 
   RowBox[{"hcpCell", "[", 
    RowBox[{"a0", ",", "cBya"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"basis", "=", "hcpCoordsRel"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"\[CapitalOmega]", "=", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"cell", "\[LeftDoubleBracket]", "1", "\[RightDoubleBracket]"}], 
      "\[Cross]", 
      RowBox[{
      "cell", "\[LeftDoubleBracket]", "2", "\[RightDoubleBracket]"}]}], ".", 
     RowBox[{"cell", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}],
     "/", 
    RowBox[{"Length", "[", "basis", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"radius", "=", 
   RowBox[{"2", "a0"}]}], ";", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "cutoff", " ", "radius", " ", "for", " ", "neighbors", " ", "in", " ", 
    "units", " ", "of", " ", "a0"}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"R", "=", 
   RowBox[{"neighborsList", "[", 
    RowBox[{"cell", ",", "basis", ",", "1", ",", "radius"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"n", "=", 
   RowBox[{"Length", "[", "R", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nR", "=", 
   RowBox[{"Norm", "/@", "R"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484926667517*^9, 3.484926784475*^9}, {3.484926886295*^9,
    3.484926889564*^9}, {3.490170199521113*^9, 3.490170242431931*^9}, {
   3.490497738435029*^9, 3.49049775347081*^9}, {3.490514176459455*^9, 
   3.490514177624763*^9}, {3.49051476831645*^9, 3.490514795446958*^9}, {
   3.4905151148813753`*^9, 3.490515138739306*^9}, {3.490516385053495*^9, 
   3.490516408678947*^9}, {3.490517893035123*^9, 3.49051792370294*^9}, {
   3.490518250363222*^9, 3.490518271272552*^9}, {3.4905183231028013`*^9, 
   3.490518372091412*^9}, {3.490518506557008*^9, 3.490518510196148*^9}, {
   3.490523227428474*^9, 3.4905232324756947`*^9}, {3.490523478199223*^9, 
   3.490523494172798*^9}, {3.490523933064457*^9, 3.490524038930393*^9}, {
   3.4905247748066587`*^9, 3.490524888569841*^9}, {3.490532305022636*^9, 
   3.490532316785172*^9}, {3.490532509074918*^9, 3.4905325117963552`*^9}, {
   3.490532710677519*^9, 3.4905327955339518`*^9}, {3.490534688261076*^9, 
   3.4905346888556423`*^9}, {3.490535149679144*^9, 3.490535175625491*^9}, {
   3.490535243628532*^9, 3.490535254014401*^9}, {3.490535558868782*^9, 
   3.490535559159237*^9}, {3.490535793693202*^9, 3.490535804655664*^9}, {
   3.4905360654391947`*^9, 3.4905360761220837`*^9}, {3.4905361373575974`*^9, 
   3.490536150999702*^9}, {3.490536673740806*^9, 3.490536707104238*^9}, {
   3.490536742255052*^9, 3.490536742425685*^9}, {3.4905367751533327`*^9, 
   3.490536776973736*^9}, {3.490537099738865*^9, 3.490537137883738*^9}, {
   3.490537227813488*^9, 3.490537237675828*^9}, {3.490553838995544*^9, 
   3.490553840118346*^9}, 3.49055389478529*^9, {3.4905539631799393`*^9, 
   3.49055412883326*^9}, {3.490555609778729*^9, 3.490555648798121*^9}, {
   3.4905556871234713`*^9, 3.4905556943209667`*^9}, {3.490555772758131*^9, 
   3.490555786063382*^9}, 3.490582485909587*^9, {3.490593229131515*^9, 
   3.4905932604522657`*^9}, {3.4905934990236607`*^9, 3.490593504733473*^9}, {
   3.4905936391011763`*^9, 3.490593645714859*^9}, {3.490593685843361*^9, 
   3.490593803023193*^9}, {3.490594859514225*^9, 3.4905948638121367`*^9}, {
   3.490594955402624*^9, 3.4905949746335163`*^9}, {3.4905950242732286`*^9, 
   3.490595070926241*^9}, {3.4906026010589743`*^9, 3.4906026392783127`*^9}, {
   3.4906027001195602`*^9, 3.49060272725968*^9}, {3.49060284707508*^9, 
   3.490602858819017*^9}, {3.490602945183097*^9, 3.49060294847338*^9}, {
   3.490603024169639*^9, 3.490603037380048*^9}, {3.490603249528762*^9, 
   3.490603282820067*^9}, 3.49060333363957*^9, {3.4906038959762783`*^9, 
   3.4906038974361486`*^9}, {3.490603964738929*^9, 3.490604037606134*^9}, {
   3.490604603345162*^9, 3.4906046536231613`*^9}, {3.490605822679552*^9, 
   3.490605842396473*^9}, {3.490610735464527*^9, 3.4906107364135513`*^9}, {
   3.4906109175216303`*^9, 3.490610918078246*^9}, {3.490703802483881*^9, 
   3.490703803045081*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", "CHECK", " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"(", 
    RowBox[{"reference", ",", "calculated"}], ")"}], "  ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Ev", ",", 
     RowBox[{"Evacancy", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"Ec", ",", 
     RowBox[{"Ecohesion", "[", 
      RowBox[{"Ak", ",", "Bk"}], "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Rho]0", ",", 
     RowBox[{"\[Rho]", "[", "Bk", "]"}]}], "}"}], "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]11", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"\[Sigma]33", ",", 
     RowBox[{"\[Sigma]hcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C11", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "1", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C12", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "2", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C13", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"1", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C33", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"3", ",", "3", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C44", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"4", ",", "4", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"C66", ",", 
     RowBox[{"Chcp", "[", 
      RowBox[{"6", ",", "6", ",", "Ak", ",", "Bk"}], "]"}]}], "}"}], 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{"True", ",", 
     RowBox[{
      SuperscriptBox[
       RowBox[{"(", 
        RowBox[{"3", 
         RowBox[{"\[Rho]", "[", "Bk", "]"}]}], ")"}], 
       RowBox[{"-", "1"}]], "<", "A", "<", 
      SuperscriptBox[
       RowBox[{"\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"-", "1"}]]}]}], "}"}], "  ", 
   RowBox[{"(*", " ", 
    RowBox[{"Ref", " ", "Vitek", " ", "text", " ", "following", " ", 
     RowBox[{"Eq", ".", " ", 
      RowBox[{"(", "8", ")"}]}]}], " ", "*)"}], 
   "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.490552753644071*^9, 3.490552781551602*^9}, {
   3.490553094381299*^9, 3.490553095909259*^9}, {3.490553919064872*^9, 
   3.490553925248577*^9}, {3.490554044810121*^9, 3.490554051698544*^9}, {
   3.4905557064777412`*^9, 3.490555711780596*^9}, {3.49059431177031*^9, 
   3.490594313052116*^9}, {3.490594360349834*^9, 3.490594366167715*^9}, {
   3.490594402660902*^9, 3.490594405102147*^9}, {3.4905944507467318`*^9, 
   3.49059449632194*^9}, {3.490594665082348*^9, 3.490594692625759*^9}, {
   3.4905947287500343`*^9, 3.490594738563517*^9}, {3.490594854351142*^9, 
   3.4905948983889112`*^9}, {3.490595930901627*^9, 3.4905959961592827`*^9}, {
   3.4906049533260727`*^9, 3.4906049618199167`*^9}, 3.490605597580228*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.11`", ",", "1.101150687410021`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.49070380485168*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"3.32`", ",", "3.3145726028358826`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703804914072*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"78.25730375415937`", ",", "78.12660364618372`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.49070380499361*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "0.00031042639082292604`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.4907038051355886`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{"-", "0.0031515430889262463`"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703805182981*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.8687`", ",", "1.7126913154520198`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703805312776*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1723`", ",", "0.12809567610304254`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703805684135*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.0687`", ",", "0.09470916365857215`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.4907038060663977`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2.1358`", ",", "2.2031474071330064`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703806442872*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.0373`", ",", "1.0502913890774574`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703806814314*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.8482`", ",", "0.7922978196744676`"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703807185152*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"True", ",", "True"}], "}"}]], "Output",
 CellChangeTimes->{
  3.49055280639354*^9, 3.4905528591084833`*^9, 3.490553038933042*^9, 
   3.490553097938308*^9, 3.490553847468892*^9, 3.490553927297625*^9, {
   3.4905539744348717`*^9, 3.490554109285612*^9}, 3.4905548935392513`*^9, 
   3.490555364505912*^9, 3.49055546360323*^9, {3.490555669471925*^9, 
   3.490555712896052*^9}, {3.490555781450623*^9, 3.49055579546656*^9}, 
   3.490555882126492*^9, 3.49058256922648*^9, 3.490583339597855*^9, 
   3.4905839421367826`*^9, 3.490594313711343*^9, 3.4905943667146606`*^9, {
   3.490594459355517*^9, 3.49059449671014*^9}, 3.4905946929989777`*^9, 
   3.490594739837675*^9, 3.490594867704295*^9, 3.490595075214176*^9, 
   3.490595852918757*^9, {3.4905959599529552`*^9, 3.490595977825048*^9}, 
   3.490598010686845*^9, {3.490601853837264*^9, 3.4906018765453243`*^9}, 
   3.490602744195241*^9, {3.490602849740752*^9, 3.49060288409181*^9}, 
   3.490602954275854*^9, {3.490603017712925*^9, 3.490603052038021*^9}, 
   3.490603218920841*^9, {3.490603255703568*^9, 3.490603284711334*^9}, 
   3.490603334584643*^9, 3.490603909179434*^9, {3.49060396692389*^9, 
   3.490604065550881*^9}, 3.4906046085806093`*^9, 3.490604964191751*^9, 
   3.490605602912121*^9, 3.490605731263541*^9, 3.4906071906939287`*^9, 
   3.490610071100534*^9, 3.49061074389491*^9, 3.490610919284546*^9, 
   3.490617939733589*^9, 3.490618753385021*^9, 3.490674842506618*^9, 
   3.490703807280966*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"V", "[", 
       RowBox[{
        RowBox[{"a0", " ", "r"}], " ", ",", "Ak"}], "]"}], "-", 
      RowBox[{"2", " ", 
       RowBox[{"D\[Rho]", "[", "Bk", "]"}], 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{
         RowBox[{"a0", " ", "r"}], ",", "Bk"}], "]"}]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0.5", ",", "2"}], "}"}]}], "]"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".5"}], ",", "1"}], "}"}]}], ",", 
   RowBox[{"AxesOrigin", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{".5", ",", "0"}], "}"}]}]}], "]"}]], "Input",
 CellChangeTimes->{{3.4905542076706743`*^9, 3.4905542796893177`*^9}, {
  3.490554310761365*^9, 3.490554346461074*^9}, {3.490584133180016*^9, 
  3.490584133995467*^9}, {3.4905842869427223`*^9, 3.490584315763605*^9}, {
  3.490585178834*^9, 3.490585181136901*^9}, {3.490594583936707*^9, 
  3.490594587908353*^9}, {3.490598573068777*^9, 3.4905985747979183`*^9}, {
  3.4906020440406437`*^9, 3.490602049639514*^9}}],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVl3c81f8Xx5GQJFv2KFpCERLOx8gqQlYikq9KSMhMZkiUiJCsJKOkSNa9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     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0.5, 0},
  PlotRange->{-0.5, 1},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 CellChangeTimes->{
  3.49055428081376*^9, {3.490554323427905*^9, 3.4905543473193502`*^9}, 
   3.4905841395527077`*^9, 3.4905843172654333`*^9, 3.4905851830768843`*^9, 
   3.490585217818787*^9, 3.490594590619503*^9, 3.490598016800557*^9, 
   3.490602051496909*^9, 3.4906031320709352`*^9, 3.490604083355918*^9, 
   3.49060498574852*^9, 3.4906057365323057`*^9, 3.490607194608697*^9, 
   3.490617974655562*^9, 3.490618775704507*^9, 3.490703869472261*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"dr", "=", 
    RowBox[{
     RowBox[{"5", " ", 
      SuperscriptBox["10", 
       RowBox[{"-", "4"}]]}], "//", "N"}]}], ";"}], " ", 
  RowBox[{"(*", " ", "Angstrom", " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"nRSmallALat", "=", 
   RowBox[{"Norm", "/@", 
    RowBox[{"neighborsList", "[", 
     RowBox[{
      RowBox[{"hcpCell", "[", 
       RowBox[{
        RowBox[{"0.8", "a0"}], ",", "cBya"}], "]"}], ",", "basis", ",", "1", 
      ",", "radius"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   UnderoverscriptBox["\[Sum]", 
    RowBox[{"j", "=", "1"}], "n"], 
   RowBox[{"\[CapitalPhi]", "[", 
    RowBox[{
     RowBox[{
     "nRSmallALat", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}], 
     ",", "Bk"}], "]"}]}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "set", " ", "rhoMax", " ", "sufficiently", " ", "beyond", " ", "this", " ",
     "value"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rhoMax", "=", "1500"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"drho", "=", 
   RowBox[{
    SuperscriptBox["10", 
     RowBox[{"-", "1"}]], "//", "N"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.484930105097*^9, 3.484930119666*^9}, {3.484930187184*^9,
    3.48493022877*^9}, {3.4849302706619997`*^9, 3.4849302750620003`*^9}, {
   3.4849304149960003`*^9, 3.48493044048*^9}, {3.484930847568*^9, 
   3.484930849961*^9}, {3.490197953812294*^9, 3.490197958395236*^9}, {
   3.4901980689643793`*^9, 3.490198130515011*^9}, {3.4902371545198927`*^9, 
   3.4902371567708807`*^9}, {3.490538676008957*^9, 3.490538676747507*^9}, 
   3.4906073941848*^9, {3.490607457034018*^9, 3.490607457133724*^9}, {
   3.4906090472738543`*^9, 3.490609057888105*^9}, {3.490609540881029*^9, 
   3.490609685293902*^9}, {3.490617981866848*^9, 3.490617989084405*^9}, {
   3.490618762736004*^9, 3.490618780253886*^9}, {3.4906189583906803`*^9, 
   3.490618958475194*^9}, {3.490619538027384*^9, 3.4906195635339527`*^9}}],

Cell[BoxData["639.6248954965226`"], "Output",
 CellChangeTimes->{
  3.490609628027426*^9, {3.4906179779319553`*^9, 3.4906179901985893`*^9}, 
   3.4906187813839483`*^9, 3.490618959388576*^9, {3.490619543674519*^9, 
   3.4906195648956623`*^9}, 3.4907038712404623`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"pair", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"V", "[", 
        RowBox[{"r", ",", "Ak"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"rho", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"\[CapitalPhi]", "[", 
        RowBox[{"r", ",", "Bk"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"2", "a0"}], ",", "dr"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"emb", "=", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", 
       RowBox[{"-", 
        RowBox[{"f", "[", "\[Rho]", "]"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"\[Rho]", ",", "0", ",", "rhoMax", ",", "drho"}], "}"}]}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{"pair", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"rho", "//", "Length"}], "\[IndentingNewLine]", 
 RowBox[{"emb", "//", "Length"}]}], "Input",
 CellChangeTimes->{{3.4849299661870003`*^9, 3.484930094575*^9}, {
   3.484930133058*^9, 3.4849301334309998`*^9}, {3.484930233334*^9, 
   3.484930239883*^9}, {3.48493029358*^9, 3.4849303537980003`*^9}, {
   3.484930402203*^9, 3.484930413343*^9}, {3.484930731593*^9, 
   3.484930759021*^9}, {3.490598651374509*^9, 3.490598653238194*^9}, {
   3.490599042405492*^9, 3.490599064791044*^9}, 3.490599295661375*^9, {
   3.490703878896277*^9, 3.490703893647045*^9}}],

Cell[BoxData["9145"], "Output",
 CellChangeTimes->{3.490703902052746*^9}],

Cell[BoxData["9145"], "Output",
 CellChangeTimes->{3.490703902145505*^9}],

Cell[BoxData["15001"], "Output",
 CellChangeTimes->{3.490703902207971*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_pair\>\""}], ",", 
   "pair", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_rho\>\""}], ",", 
   "rho", ",", "\"\<Table\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Export", "[", 
  RowBox[{
   RowBox[{
   "str", "<>", "\"\</\>\"", "<>", "str", "<>", "\"\<_Vitek_emb\>\""}], ",", 
   "emb", ",", "\"\<Table\>\""}], "]"}]}], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, {
   3.490237174130909*^9, 3.490237199062149*^9}, 3.4905985841485357`*^9, {
   3.490598620230855*^9, 3.4905986337521133`*^9}, {3.490602297888136*^9, 
   3.490602307001584*^9}, {3.490602455546969*^9, 3.490602461254315*^9}, {
   3.490602518601597*^9, 3.490602519381613*^9}, {3.4906179970442657`*^9, 
   3.490618000108979*^9}}],

Cell[BoxData["\<\"Be/Be_Vitek_pair\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605021690888*^9, 
   3.490605740124065*^9, 3.49060719689602*^9, 3.490607398522768*^9, 
   3.4906074606189623`*^9, 3.490609070036997*^9, 3.490618001037271*^9, 
   3.490618793931902*^9, 3.490618971084222*^9, {3.4906195456879263`*^9, 
   3.490619568222645*^9}, 3.4907039081609783`*^9}],

Cell[BoxData["\<\"Be/Be_Vitek_rho\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605021690888*^9, 
   3.490605740124065*^9, 3.49060719689602*^9, 3.490607398522768*^9, 
   3.4906074606189623`*^9, 3.490609070036997*^9, 3.490618001037271*^9, 
   3.490618793931902*^9, 3.490618971084222*^9, {3.4906195456879263`*^9, 
   3.490619568222645*^9}, 3.4907039085713253`*^9}],

Cell[BoxData["\<\"Be/Be_Vitek_emb\"\>"], "Output",
 CellChangeTimes->{
  3.484930547017*^9, 3.484930761108*^9, 3.4849308529700003`*^9, 
   3.4901699950995092`*^9, 3.490191646706338*^9, 3.490192004884356*^9, 
   3.4901979662542553`*^9, 3.490237200917227*^9, 3.490343433861909*^9, 
   3.490350231563306*^9, 3.4905986626609907`*^9, {3.490599050887197*^9, 
   3.490599067344109*^9}, 3.490599298685772*^9, {3.490602290223546*^9, 
   3.490602308128873*^9}, 3.4906024625999002`*^9, 3.490605021690888*^9, 
   3.490605740124065*^9, 3.49060719689602*^9, 3.490607398522768*^9, 
   3.4906074606189623`*^9, 3.490609070036997*^9, 3.490618001037271*^9, 
   3.490618793931902*^9, 3.490618971084222*^9, {3.4906195456879263`*^9, 
   3.490619568222645*^9}, 3.490703909358955*^9}]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.484930496509*^9, 3.484930545348*^9}, {
   3.490169948426141*^9, 3.490169967374037*^9}, {3.490191640948543*^9, 
   3.490191644734672*^9}, {3.4901919716761503`*^9, 3.490191990580988*^9}, 
   3.490497525951449*^9}]
}, Closed]]
},
CellGrouping->Manual,
WindowSize->{863, 743},
WindowMargins->{{258, Automatic}, {Automatic, 36}},
ShowSelection->True,
FrontEndVersion->"7.0 for Linux x86 (64-bit) (February 25, 2009)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 222, 3, 27, "Subsubsection"],
Cell[CellGroupData[{
Cell[814, 29, 148, 2, 27, "Subsubsection"],
Cell[965, 33, 11723, 293, 712, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[12725, 331, 144, 2, 27, "Subsubsection"],
Cell[12872, 335, 10507, 246, 602, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[23416, 586, 203, 3, 21, "Subsubsection"],
Cell[23622, 591, 9869, 237, 600, "Input"]
}, Closed]]
}, Closed]],
Cell[33518, 832, 288, 8, 25, "Input"],
Cell[CellGroupData[{
Cell[33831, 844, 662, 11, 27, "Subsubsection"],
Cell[34496, 857, 567, 12, 52, "Input"],
Cell[35066, 871, 904, 21, 72, "Input"],
Cell[35973, 894, 786, 21, 92, "Input"],
Cell[36762, 917, 2401, 68, 112, "Input"],
Cell[CellGroupData[{
Cell[39188, 989, 759, 14, 31, "Input"],
Cell[39950, 1005, 7327, 123, 228, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[47314, 1133, 1965, 56, 178, "Input"],
Cell[49282, 1191, 334, 5, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[49653, 1201, 306, 6, 31, "Input"],
Cell[49962, 1209, 9484, 160, 243, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[59483, 1374, 453, 9, 31, "Input"],
Cell[59939, 1385, 8483, 142, 239, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[68459, 1532, 771, 15, 72, "Input"],
Cell[69233, 1549, 214, 3, 31, "Output"],
Cell[69450, 1554, 213, 3, 31, "Output"],
Cell[69666, 1559, 215, 3, 31, "Output"]
}, Open  ]],
Cell[69896, 1565, 254, 4, 31, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[70187, 1574, 557, 10, 21, "Subsubsection"],
Cell[70747, 1586, 530, 12, 52, "Input"],
Cell[71280, 1600, 802, 19, 72, "Input"],
Cell[72085, 1621, 786, 21, 92, "Input"],
Cell[72874, 1644, 2356, 68, 112, "Input"],
Cell[CellGroupData[{
Cell[75255, 1716, 692, 12, 31, "Input"],
Cell[75950, 1730, 19370, 323, 238, 15046, 250, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[95357, 2058, 286, 6, 31, "Input"],
Cell[95646, 2066, 144712, 2378, 248, 140922, 2314, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[240395, 4449, 291, 6, 31, "Input"],
Cell[240689, 4457, 135045, 2219, 238, 131524, 2160, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[375771, 6681, 755, 18, 72, "Input"],
Cell[376529, 6701, 149, 2, 31, "Output"],
Cell[376681, 6705, 146, 2, 31, "Output"],
Cell[376830, 6709, 146, 2, 31, "Output"]
}, Open  ]],
Cell[376991, 6714, 254, 4, 31, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[377282, 6723, 382, 8, 21, "Subsubsection"],
Cell[377667, 6733, 438, 12, 52, "Input"],
Cell[378108, 6747, 802, 19, 72, "Input"],
Cell[378913, 6768, 786, 21, 92, "Input"],
Cell[379702, 6791, 2356, 68, 112, "Input"],
Cell[CellGroupData[{
Cell[382083, 6863, 692, 12, 31, "Input"],
Cell[382778, 6877, 20089, 335, 237, 15636, 260, "CachedBoxData", "BoxData", \
"Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[402904, 7217, 286, 6, 31, "Input"],
Cell[403193, 7225, 106450, 1752, 251, 103078, 1694, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[509680, 8982, 291, 6, 31, "Input"],
Cell[509974, 8990, 123795, 2034, 241, 120072, 1972, "CachedBoxData", \
"BoxData", "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[633806, 11029, 651, 16, 72, "Input"],
Cell[634460, 11047, 98, 1, 31, "Output"],
Cell[634561, 11050, 95, 1, 31, "Output"],
Cell[634659, 11053, 94, 1, 31, "Output"]
}, Open  ]],
Cell[634768, 11057, 254, 4, 31, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[635059, 11066, 703, 12, 21, "Subsubsection"],
Cell[635765, 11080, 1206, 27, 72, "Input"],
Cell[636974, 11109, 5554, 126, 301, "Input"],
Cell[CellGroupData[{
Cell[642553, 11239, 2282, 55, 212, "Input"],
Cell[644838, 11296, 998, 16, 31, "Output"],
Cell[645839, 11314, 999, 16, 31, "Output"],
Cell[646841, 11332, 1015, 17, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[647893, 11354, 1054, 26, 31, "Input"],
Cell[648950, 11382, 8843, 150, 233, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[657830, 11537, 1657, 42, 144, "Input"],
Cell[659490, 11581, 183, 2, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[659710, 11588, 1678, 45, 132, "Input"],
Cell[661391, 11635, 98, 1, 31, "Output"],
Cell[661492, 11638, 100, 1, 31, "Output"],
Cell[661595, 11641, 95, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[661727, 11647, 966, 21, 72, "Input"],
Cell[662696, 11670, 499, 7, 31, "Output"],
Cell[663198, 11679, 496, 7, 31, "Output"],
Cell[663697, 11688, 498, 7, 31, "Output"]
}, Open  ]],
Cell[664210, 11698, 260, 4, 31, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[664507, 11707, 860, 14, 21, "Subsubsection"],
Cell[665370, 11723, 1256, 28, 72, "Input"],
Cell[666629, 11753, 5866, 130, 301, "Input"],
Cell[CellGroupData[{
Cell[672520, 11887, 2692, 66, 235, "Input"],
Cell[675215, 11955, 1305, 20, 31, "Output"],
Cell[676523, 11977, 1303, 20, 31, "Output"],
Cell[677829, 11999, 1322, 21, 31, "Output"],
Cell[679154, 12022, 1304, 20, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[680495, 12047, 2431, 60, 152, "Input"],
Cell[682929, 12109, 26435, 440, 233, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[709401, 12554, 1156, 35, 144, "Input"],
Cell[710560, 12591, 161, 2, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[710758, 12598, 1676, 45, 132, "Input"],
Cell[712437, 12645, 124, 2, 31, "Output"],
Cell[712564, 12649, 126, 2, 31, "Output"],
Cell[712693, 12653, 124, 2, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[712854, 12660, 966, 21, 72, "Input"],
Cell[713823, 12683, 497, 7, 31, "Output"],
Cell[714323, 12692, 496, 7, 31, "Output"],
Cell[714822, 12701, 496, 7, 31, "Output"]
}, Open  ]],
Cell[715333, 12711, 260, 4, 31, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[715630, 12720, 800, 13, 21, "Subsubsection"],
Cell[716433, 12735, 1306, 29, 72, "Input"],
Cell[717742, 12766, 6016, 132, 301, "Input"],
Cell[CellGroupData[{
Cell[723783, 12902, 2690, 66, 235, "Input"],
Cell[726476, 12970, 1445, 22, 31, "Output"],
Cell[727924, 12994, 1450, 22, 31, "Output"],
Cell[729377, 13018, 1464, 23, 31, "Output"],
Cell[730844, 13043, 1450, 22, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[732331, 13070, 2637, 62, 152, "Input"],
Cell[734971, 13134, 25819, 430, 233, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[760827, 13569, 1756, 43, 144, "Input"],
Cell[762586, 13614, 258, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[762881, 13623, 1676, 45, 132, "Input"],
Cell[764560, 13670, 96, 1, 31, "Output"],
Cell[764659, 13673, 98, 1, 31, "Output"],
Cell[764760, 13676, 96, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[764893, 13682, 966, 21, 72, "Input"],
Cell[765862, 13705, 521, 8, 31, "Output"],
Cell[766386, 13715, 519, 8, 31, "Output"],
Cell[766908, 13725, 520, 8, 31, "Output"]
}, Open  ]],
Cell[767443, 13736, 260, 4, 31, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[767740, 13745, 971, 17, 21, "Subsubsection"],
Cell[768714, 13764, 1456, 31, 77, "Input"],
Cell[770173, 13797, 5666, 114, 297, "Input"],
Cell[CellGroupData[{
Cell[775864, 13915, 421, 11, 77, "Input"],
Cell[776288, 13928, 160, 3, 31, "Output"]
}, Open  ]],
Cell[776463, 13934, 154, 2, 31, "Text"],
Cell[776620, 13938, 4115, 82, 187, "Input"],
Cell[CellGroupData[{
Cell[780760, 14024, 1365, 28, 121, "Input"],
Cell[782128, 14054, 159, 3, 31, "Output"],
Cell[782290, 14059, 159, 3, 31, "Output"],
Cell[782452, 14064, 176, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[782665, 14073, 1761, 43, 147, "Input"],
Cell[784429, 14118, 277, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[784743, 14127, 1677, 45, 143, "Input"],
Cell[786423, 14174, 100, 1, 31, "Output"],
Cell[786526, 14177, 102, 1, 31, "Output"],
Cell[786631, 14180, 100, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[786768, 14186, 966, 21, 77, "Input"],
Cell[787737, 14209, 544, 8, 31, "Output"],
Cell[788284, 14219, 540, 8, 31, "Output"],
Cell[788827, 14229, 541, 8, 31, "Output"]
}, Open  ]],
Cell[789383, 14240, 260, 4, 32, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[789680, 14249, 656, 11, 21, "Subsubsection"],
Cell[790339, 14262, 1207, 27, 77, "Input"],
Cell[791549, 14291, 5580, 123, 341, "Input"],
Cell[CellGroupData[{
Cell[797154, 14418, 2642, 67, 297, "Input"],
Cell[799799, 14487, 901, 14, 31, "Output"],
Cell[800703, 14503, 902, 14, 31, "Output"],
Cell[801608, 14519, 916, 14, 31, "Output"],
Cell[802527, 14535, 900, 14, 31, "Output"],
Cell[803430, 14551, 901, 14, 31, "Output"],
Cell[804334, 14567, 905, 14, 31, "Output"],
Cell[805242, 14583, 903, 14, 31, "Output"],
Cell[806148, 14599, 903, 14, 31, "Output"],
Cell[807054, 14615, 903, 14, 31, "Output"],
Cell[807960, 14631, 906, 14, 31, "Output"],
Cell[808869, 14647, 904, 14, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[809810, 14666, 1313, 33, 77, "Input"],
Cell[811126, 14701, 12511, 211, 233, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[823674, 14917, 1608, 40, 147, "Input"],
Cell[825285, 14959, 111, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[825433, 14965, 1678, 45, 143, "Input"],
Cell[827114, 15012, 74, 1, 31, "Output"],
Cell[827191, 15015, 74, 1, 31, "Output"],
Cell[827268, 15018, 74, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[827379, 15024, 910, 20, 77, "Input"],
Cell[828292, 15046, 451, 7, 31, "Output"],
Cell[828746, 15055, 448, 7, 31, "Output"],
Cell[829197, 15064, 448, 7, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[829682, 15076, 154, 2, 29, "Subsubsection"],
Cell[829839, 15080, 1814, 47, 209, "Input"],
Cell[CellGroupData[{
Cell[831678, 15131, 2026, 52, 121, "Input"],
Cell[833707, 15185, 1419, 35, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[835163, 15225, 359, 8, 77, "Input"],
Cell[835525, 15235, 420, 9, 31, "Output"],
Cell[835948, 15246, 363, 7, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[836348, 15258, 2456, 73, 297, "Input"],
Cell[838807, 15333, 258, 5, 31, "Output"],
Cell[839068, 15340, 259, 5, 31, "Output"],
Cell[839330, 15347, 275, 6, 31, "Output"],
Cell[839608, 15355, 278, 6, 33, "Output"],
Cell[839889, 15363, 258, 5, 33, "Output"],
Cell[840150, 15370, 259, 5, 31, "Output"],
Cell[840412, 15377, 260, 5, 31, "Output"],
Cell[840675, 15384, 260, 5, 31, "Output"],
Cell[840938, 15391, 260, 5, 31, "Output"],
Cell[841201, 15398, 261, 5, 31, "Output"],
Cell[841465, 15405, 261, 5, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[841763, 15415, 1200, 35, 99, "Input"],
Cell[842966, 15452, 25410, 424, 233, "Output"]
}, Open  ]]
}, Closed]],
Cell[868403, 15880, 260, 4, 26, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[868700, 15889, 704, 12, 21, "Subsubsection"],
Cell[869407, 15903, 1257, 28, 77, "Input"],
Cell[870667, 15933, 5633, 129, 341, "Input"],
Cell[CellGroupData[{
Cell[876325, 16066, 2642, 67, 297, "Input"],
Cell[878970, 16135, 1027, 16, 31, "Output"],
Cell[880000, 16153, 1030, 16, 31, "Output"],
Cell[881033, 16171, 1029, 16, 31, "Output"],
Cell[882065, 16189, 1030, 16, 33, "Output"],
Cell[883098, 16207, 1028, 16, 33, "Output"],
Cell[884129, 16225, 1030, 16, 31, "Output"],
Cell[885162, 16243, 1029, 16, 31, "Output"],
Cell[886194, 16261, 1032, 16, 31, "Output"],
Cell[887229, 16279, 1032, 16, 31, "Output"],
Cell[888264, 16297, 1030, 16, 31, "Output"],
Cell[889297, 16315, 1030, 16, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[890364, 16336, 1313, 33, 77, "Input"],
Cell[891680, 16371, 11406, 193, 233, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[903123, 16569, 1606, 40, 147, "Input"],
Cell[904732, 16611, 112, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[904881, 16617, 1678, 45, 143, "Input"],
Cell[906562, 16664, 74, 1, 31, "Output"],
Cell[906639, 16667, 74, 1, 31, "Output"],
Cell[906716, 16670, 74, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[906827, 16676, 910, 20, 77, "Input"],
Cell[907740, 16698, 474, 7, 31, "Output"],
Cell[908217, 16707, 473, 7, 31, "Output"],
Cell[908693, 16716, 475, 7, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[909205, 16728, 154, 2, 29, "Subsubsection"],
Cell[909362, 16732, 1814, 47, 209, "Input"],
Cell[CellGroupData[{
Cell[911201, 16783, 2026, 52, 121, "Input"],
Cell[913230, 16837, 1411, 33, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[914678, 16875, 359, 8, 77, "Input"],
Cell[915040, 16885, 445, 9, 31, "Output"],
Cell[915488, 16896, 405, 8, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[915930, 16909, 2456, 73, 297, "Input"],
Cell[918389, 16984, 283, 6, 31, "Output"],
Cell[918675, 16992, 283, 6, 31, "Output"],
Cell[918961, 17000, 285, 6, 31, "Output"],
Cell[919249, 17008, 303, 7, 33, "Output"],
Cell[919555, 17017, 304, 7, 33, "Output"],
Cell[919862, 17026, 288, 6, 31, "Output"],
Cell[920153, 17034, 287, 6, 31, "Output"],
Cell[920443, 17042, 289, 6, 31, "Output"],
Cell[920735, 17050, 286, 6, 31, "Output"],
Cell[921024, 17058, 286, 6, 31, "Output"],
Cell[921313, 17066, 287, 6, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[921637, 17077, 1200, 35, 99, "Input"],
Cell[922840, 17114, 18686, 314, 233, "Output"]
}, Open  ]]
}, Closed]],
Cell[941553, 17432, 260, 4, 26, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[941850, 17441, 781, 13, 21, "Subsubsection"],
Cell[942634, 17456, 1305, 29, 77, "Input"],
Cell[943942, 17487, 5585, 129, 341, "Input"],
Cell[CellGroupData[{
Cell[949552, 17620, 2642, 67, 297, "Input"],
Cell[952197, 17689, 952, 15, 31, "Output"],
Cell[953152, 17706, 954, 15, 31, "Output"],
Cell[954109, 17723, 967, 15, 31, "Output"],
Cell[955079, 17740, 953, 15, 33, "Output"],
Cell[956035, 17757, 971, 16, 31, "Output"],
Cell[957009, 17775, 955, 15, 31, "Output"],
Cell[957967, 17792, 953, 15, 31, "Output"],
Cell[958923, 17809, 958, 15, 31, "Output"],
Cell[959884, 17826, 955, 15, 31, "Output"],
Cell[960842, 17843, 958, 15, 31, "Output"],
Cell[961803, 17860, 955, 15, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[962795, 17880, 1056, 26, 55, "Input"],
Cell[963854, 17908, 11742, 198, 233, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[975633, 18111, 1731, 43, 147, "Input"],
Cell[977367, 18156, 209, 3, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[977613, 18164, 1676, 45, 143, "Input"],
Cell[979292, 18211, 97, 1, 31, "Output"],
Cell[979392, 18214, 98, 1, 31, "Output"],
Cell[979493, 18217, 100, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[979630, 18223, 910, 20, 77, "Input"],
Cell[980543, 18245, 496, 7, 31, "Output"],
Cell[981042, 18254, 495, 7, 31, "Output"],
Cell[981540, 18263, 494, 7, 31, "Output"]
}, Open  ]],
Cell[982049, 18273, 260, 4, 32, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[982346, 18282, 692, 12, 21, "Subsubsection"],
Cell[983041, 18296, 1337, 30, 72, "Input"],
Cell[984381, 18328, 5985, 134, 318, "Input"],
Cell[CellGroupData[{
Cell[990391, 18466, 2642, 67, 272, "Input"],
Cell[993036, 18535, 1493, 22, 31, "Output"],
Cell[994532, 18559, 1495, 22, 31, "Output"],
Cell[996030, 18583, 1508, 22, 31, "Output"],
Cell[997541, 18607, 1493, 22, 31, "Output"],
Cell[999037, 18631, 1510, 23, 31, "Output"],
Cell[1000550, 18656, 1493, 22, 31, "Output"],
Cell[1002046, 18680, 1496, 22, 31, "Output"],
Cell[1003545, 18704, 1495, 22, 31, "Output"],
Cell[1005043, 18728, 1496, 22, 31, "Output"],
Cell[1006542, 18752, 1496, 22, 31, "Output"],
Cell[1008041, 18776, 1496, 22, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1009574, 18803, 1125, 28, 52, "Input"],
Cell[1010702, 18833, 12421, 210, 228, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1023160, 19048, 1791, 45, 146, "Input"],
Cell[1024954, 19095, 207, 3, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1025198, 19103, 1675, 45, 132, "Input"],
Cell[1026876, 19150, 76, 1, 31, "Output"],
Cell[1026955, 19153, 74, 1, 31, "Output"],
Cell[1027032, 19156, 76, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1027145, 19162, 1024, 21, 72, "Input"],
Cell[1028172, 19185, 602, 9, 31, "Output"],
Cell[1028777, 19196, 601, 9, 31, "Output"],
Cell[1029381, 19207, 601, 9, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1030019, 19221, 154, 2, 27, "Subsubsection"],
Cell[1030176, 19225, 1814, 47, 192, "Input"],
Cell[CellGroupData[{
Cell[1032015, 19276, 2125, 53, 112, "Input"],
Cell[1034143, 19331, 734, 13, 24, "Message"],
Cell[1034880, 19346, 1509, 35, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1036426, 19386, 359, 8, 72, "Input"],
Cell[1036788, 19396, 549, 11, 31, "Output"],
Cell[1037340, 19409, 489, 9, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1037866, 19423, 2554, 75, 272, "Input"],
Cell[1040423, 19500, 431, 8, 31, "Output"],
Cell[1040857, 19510, 430, 8, 31, "Output"],
Cell[1041290, 19520, 445, 8, 31, "Output"],
Cell[1041738, 19530, 430, 8, 31, "Output"],
Cell[1042171, 19540, 449, 9, 31, "Output"],
Cell[1042623, 19551, 432, 8, 31, "Output"],
Cell[1043058, 19561, 434, 8, 31, "Output"],
Cell[1043495, 19571, 432, 8, 31, "Output"],
Cell[1043930, 19581, 432, 8, 31, "Output"],
Cell[1044365, 19591, 433, 8, 31, "Output"],
Cell[1044801, 19601, 433, 8, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1045271, 19614, 1460, 42, 112, "Input"],
Cell[1046734, 19658, 18465, 311, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1065236, 19974, 1839, 45, 144, "Input"],
Cell[1067078, 20021, 191, 3, 31, "Output"]
}, Open  ]],
Cell[1067284, 20027, 1569, 44, 72, "Input"],
Cell[CellGroupData[{
Cell[1068878, 20075, 122, 2, 31, "Input"],
Cell[1069003, 20079, 74, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1069114, 20085, 1097, 25, 72, "Input"],
Cell[1070214, 20112, 576, 8, 31, "Output"],
Cell[1070793, 20122, 577, 8, 31, "Output"],
Cell[1071373, 20132, 577, 8, 31, "Output"]
}, Open  ]]
}, Closed]],
Cell[1071977, 20144, 260, 4, 25, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1072274, 20153, 790, 13, 21, "Subsubsection"],
Cell[1073067, 20168, 1312, 29, 72, "Input"],
Cell[1074382, 20199, 167, 2, 29, "Text"],
Cell[1074552, 20203, 484, 13, 31, "Input"],
Cell[1075039, 20218, 7885, 163, 392, "Input"],
Cell[CellGroupData[{
Cell[1082949, 20385, 3384, 86, 315, "Input"],
Cell[1086336, 20473, 2509, 36, 31, "Output"],
Cell[1088848, 20511, 2510, 36, 31, "Output"],
Cell[1091361, 20549, 2521, 36, 31, "Output"],
Cell[1093885, 20587, 2510, 36, 31, "Output"],
Cell[1096398, 20625, 2508, 36, 31, "Output"],
Cell[1098909, 20663, 2509, 36, 31, "Output"],
Cell[1101421, 20701, 2511, 36, 31, "Output"],
Cell[1103935, 20739, 2513, 36, 31, "Output"],
Cell[1106451, 20777, 2513, 36, 31, "Output"],
Cell[1108967, 20815, 2513, 36, 31, "Output"],
Cell[1111483, 20853, 2513, 36, 31, "Output"],
Cell[1113999, 20891, 2495, 36, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1116531, 20932, 1202, 29, 52, "Input"],
Cell[1117736, 20963, 13739, 230, 228, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1131512, 21198, 1861, 45, 144, "Input"],
Cell[1133376, 21245, 402, 6, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1133815, 21256, 1680, 45, 132, "Input"],
Cell[1135498, 21303, 74, 1, 31, "Output"],
Cell[1135575, 21306, 74, 1, 31, "Output"],
Cell[1135652, 21309, 74, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1135763, 21315, 1071, 22, 72, "Input"],
Cell[1136837, 21339, 894, 13, 31, "Output"],
Cell[1137734, 21354, 890, 13, 31, "Output"],
Cell[1138627, 21369, 893, 13, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1139557, 21387, 209, 3, 27, "Subsubsection"],
Cell[1139769, 21392, 1814, 47, 192, "Input"],
Cell[1141586, 21441, 2686, 60, 92, "Input"],
Cell[CellGroupData[{
Cell[1144297, 21505, 159, 3, 31, "Input"],
Cell[1144459, 21510, 231, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1144727, 21519, 1209, 24, 52, "Input"],
Cell[1145939, 21545, 1098, 18, 85, "Message"],
Cell[1147040, 21565, 1676, 32, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1148753, 21602, 586, 14, 72, "Input"],
Cell[1149342, 21618, 1294, 25, 52, "Output"],
Cell[1150639, 21645, 1331, 25, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1152007, 21675, 2426, 70, 252, "Input"],
Cell[1154436, 21747, 965, 15, 31, "Output"],
Cell[1155404, 21764, 964, 15, 31, "Output"],
Cell[1156371, 21781, 976, 15, 31, "Output"],
Cell[1157350, 21798, 962, 15, 31, "Output"],
Cell[1158315, 21815, 962, 15, 31, "Output"],
Cell[1159280, 21832, 965, 15, 31, "Output"],
Cell[1160248, 21849, 966, 15, 31, "Output"],
Cell[1161217, 21866, 966, 15, 31, "Output"],
Cell[1162186, 21883, 967, 15, 31, "Output"],
Cell[1163156, 21900, 966, 15, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1164159, 21920, 1419, 38, 92, "Input"],
Cell[1165581, 21960, 23050, 385, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1188668, 22350, 1938, 47, 144, "Input"],
Cell[1190609, 22399, 312, 5, 31, "Output"]
}, Open  ]],
Cell[1190936, 22407, 1664, 45, 72, "Input"],
Cell[CellGroupData[{
Cell[1192625, 22456, 122, 2, 31, "Input"],
Cell[1192750, 22460, 145, 2, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1192932, 22467, 1146, 26, 72, "Input"],
Cell[1194081, 22495, 675, 10, 31, "Output"],
Cell[1194759, 22507, 674, 10, 31, "Output"],
Cell[1195436, 22519, 674, 10, 31, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[1196159, 22535, 260, 4, 21, "Subsubsection"],
Cell[1196422, 22541, 2123, 59, 172, "Input"],
Cell[1198548, 22602, 2371, 58, 132, "Input"],
Cell[CellGroupData[{
Cell[1200944, 22664, 303, 5, 31, "Input"],
Cell[1201250, 22671, 286, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1201573, 22680, 1399, 31, 52, "Input"],
Cell[1202975, 22713, 1144, 20, 85, "Message"],
Cell[1204122, 22735, 1057, 18, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1205216, 22758, 795, 23, 92, "Input"],
Cell[1206014, 22783, 784, 19, 52, "Output"],
Cell[1206801, 22804, 510, 12, 52, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1207348, 22821, 2761, 77, 315, "Input"],
Cell[1210112, 22900, 769, 13, 31, "Output"],
Cell[1210884, 22915, 748, 12, 31, "Output"],
Cell[1211635, 22929, 765, 12, 31, "Output"],
Cell[1212403, 22943, 748, 12, 31, "Output"],
Cell[1213154, 22957, 748, 12, 31, "Output"],
Cell[1213905, 22971, 769, 13, 31, "Output"],
Cell[1214677, 22986, 771, 13, 31, "Output"],
Cell[1215451, 23001, 771, 13, 31, "Output"],
Cell[1216225, 23016, 690, 10, 31, "Output"],
Cell[1216918, 23028, 692, 10, 31, "Output"],
Cell[1217613, 23040, 690, 10, 31, "Output"],
Cell[1218306, 23052, 734, 12, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1219077, 23069, 1142, 31, 92, "Input"],
Cell[1220222, 23102, 13386, 226, 238, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1233645, 23333, 1914, 47, 144, "Input"],
Cell[1235562, 23382, 262, 4, 31, "Output"]
}, Open  ]],
Cell[1235839, 23389, 1679, 47, 72, "Input"],
Cell[CellGroupData[{
Cell[1237543, 23440, 122, 2, 31, "Input"],
Cell[1237668, 23444, 123, 2, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1237828, 23451, 1146, 26, 72, "Input"],
Cell[1238977, 23479, 649, 9, 31, "Output"],
Cell[1239629, 23490, 646, 9, 31, "Output"],
Cell[1240278, 23501, 646, 9, 31, "Output"]
}, Open  ]]
}, Closed]],
Cell[1240951, 23514, 260, 4, 25, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[1241248, 23523, 798, 13, 21, "Subsubsection"],
Cell[1242049, 23538, 1429, 30, 72, "Input"],
Cell[1243481, 23570, 167, 2, 29, "Text"],
Cell[1243651, 23574, 484, 13, 31, "Input"],
Cell[1244138, 23589, 6157, 135, 338, "Input"],
Cell[CellGroupData[{
Cell[1250320, 23728, 3280, 84, 315, "Input"],
Cell[1253603, 23814, 1500, 23, 31, "Output"],
Cell[1255106, 23839, 1502, 23, 31, "Output"],
Cell[1256611, 23864, 1513, 23, 31, "Output"],
Cell[1258127, 23889, 1504, 23, 31, "Output"],
Cell[1259634, 23914, 1520, 24, 31, "Output"],
Cell[1261157, 23940, 1504, 23, 31, "Output"],
Cell[1262664, 23965, 1505, 23, 31, "Output"],
Cell[1264172, 23990, 1507, 23, 31, "Output"],
Cell[1265682, 24015, 1504, 23, 31, "Output"],
Cell[1267189, 24040, 1504, 23, 31, "Output"],
Cell[1268696, 24065, 1504, 23, 31, "Output"],
Cell[1270203, 24090, 1486, 23, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1271726, 24118, 1125, 28, 52, "Input"],
Cell[1272854, 24148, 12168, 205, 228, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1285059, 24358, 2007, 48, 146, "Input"],
Cell[1287069, 24408, 266, 4, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1287372, 24417, 1676, 45, 132, "Input"],
Cell[1289051, 24464, 73, 1, 31, "Output"],
Cell[1289127, 24467, 73, 1, 31, "Output"],
Cell[1289203, 24470, 74, 1, 31, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1289314, 24476, 1108, 23, 72, "Input"],
Cell[1290425, 24501, 763, 11, 31, "Output"],
Cell[1291191, 24514, 762, 11, 31, "Output"],
Cell[1291956, 24527, 760, 11, 31, "Output"]
}, Open  ]],
Cell[1292731, 24541, 260, 4, 31, "Input"]
}, Closed]]
}
]
*)

(* End of internal cache information *)
